; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_PIN_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (HSYNC_DDR),(HSYNC_PIN_NR)		; HSYNC	
	sbi (VSYNC_DDR),(VSYNC_PIN_NR)		; VSYNC	
	sbi (RGB_DATA_DDR),(R_DATA_PIN_NR)	; R		
	sbi (RGB_DATA_DDR),(G_DATA_PIN_NR)	; G		
	sbi (RGB_DATA_DDR),(B_DATA_PIN_NR)	; B		
	; auf HIGH									
	sbi (HSYNC_PORT),(HSYNC_PIN_NR)		; HSYNC	
	sbi (VSYNC_PORT),(VSYNC_PIN_NR)		; VSYNC	
	sbi (RGB_DATA_PORT),(R_DATA_PIN_NR)	; R		
	sbi (RGB_DATA_PORT),(G_DATA_PIN_NR)	; G		
	sbi (RGB_DATA_PORT),(B_DATA_PIN_NR)	; B		
	; auf LOW									
	cbi (HSYNC_PORT),(HSYNC_PIN_NR)		; HSYNC	
	cbi (VSYNC_PORT),(VSYNC_PIN_NR)		; VSYNC	
	cbi (RGB_DATA_PORT),(R_DATA_PIN_NR)	; R		
	cbi (RGB_DATA_PORT),(G_DATA_PIN_NR)	; G		
	cbi (RGB_DATA_PORT),(B_DATA_PIN_NR)	; B		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER1 16-BIT-TIMER 															
;																				
; CSn2 CSn1 CSn0																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
; * 0 	0 	1 	clkI/O/1 (No prescaling)										
; 	0 	1 	0 	clkI/O/8 (From prescaler)										
; 	0 	1 	1 	clkI/O/64 (From prescaler)										
; 	1 	0 	0 	clkI/O/256 (From prescaler)										
; 	1 	0 	1 	clkI/O/1024 (From prescaler)									
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
;  VGA-TIMER (31,7 s) 															
;																				
TIMER1_INITIALISIERUNG_CTC:
	; TCCR1A  Timer/Counter 1 Control Register A			
;	ldi temp, (0<<COM1A1)| (1<<COM1A0)|(0<<COM1B1)|(1<<COM1B0)|(0<<WGM11)|(0<<WGM10)	; PIN TOOGELN OC1A PIN OC1B 
	ldi temp, (0<<COM1A1)| (0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)
	STS TCCR1A,temp
	; TCCR1B  Timer/Counter 1 Control Register B			
	ldi temp, (0<<ICNC1)| (0<<ICES1)|(0<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)
	STS TCCR1B,temp
	; TCCR1C  Timer/Counter 1 Control Register C			
	ldi temp, (0<<FOC1A)|(0<<FOC1B)
	STS TCCR1C,temp
	; TIMSK1  Timer/Counter1 Interrupt Mask Register		
	ldi temp, (0<<ICIE1)| (0<<OCIE1B)|(1<<OCIE1A)|(0<<TOIE1)
	STS TIMSK1,temp
	; OCR1A													
	ldi temp,HIGH(TIMER1_CTC)
	STS OCR1AH,temp
	ldi temp,LOW (TIMER1_CTC)
	STS OCR1AL,temp
	; auf AUSGANG											
	;sbi DDRD,PD5	; PIN OC1A 
	;sbi DDRD,PD4	; PIN OC1B 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_OFF:
	STS (TCCR1B),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_ON:
	call TIMER1_INITIALISIERUNG_CTC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: TEMP																		
VGA_STATUS_TEMP:
	LDS temp,(TCCR1B)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Alle 31,7 s muss eine Zeile geschrieben werden								
; Die SYNCHRONIMPULSE drfen nicht jittern !!									
;																				
TIM1_COMPA:
	mov TEMP_KOPIE ,temp	; TEMP sichern							
	in	SREG_KOPIE ,SREG	; SREG sichern							
	MOVW ZL_KOPIE,ZL		; Z sichern (Copy Register Word)		
;-------------------------------------------------------------------------------
; TAKTKORREKTUR beim INTERRUPTAUFRUF, sonst jittert das BILD und 				
; der MONITOR schaltet ev. sogar ab												
	LDS temp, TCNT1L							; TIMERWERT auslesen 	
	subi temp,10								; -10					
	cpi temp,(8+1)								; 8 im Bereich ?			
	brlo VGA_TAKTKOREKTUR_RUN
;-------------------------------------------------------------------------------
; ERROR																			
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	clr temp
;-------------------------------------------------------------------------------
VGA_TAKTKOREKTUR_RUN:
	ldi ZL, LOW(VGA_TAKTKOREKTUR_SPRUNGMARKE)
	ldi ZH,HIGH(VGA_TAKTKOREKTUR_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	IJMP										; SPRUNG (Zeiger nach Z)
VGA_TAKTKOREKTUR_SPRUNGMARKE:
	nop	; 0
	nop	; 1
	nop	; 2
	nop	; 3
	nop	; 4
	nop	; 5
	nop	; 6
	nop	; 7
	nop	; 8
;	nop	; 9
;	nop	; 10
;	nop	; 11
;	nop	; 12
;-------------------------------------------------------------------------------
; BILDAUFBAU																	
	cbi (HSYNC_PORT),(HSYNC_PIN_NR)	; HSYNC	(ab hier 3,8S Impuls)			
	MOVW YL_KOPIE,YL				;  Y sichern (Copy Register Word)		
	; Z-ZEIGER initialisieren				
	ldi ZL, LOW(BILDAUFBAU_SPRUNGMARKE)
	ldi ZH,HIGH(BILDAUFBAU_SPRUNGMARKE)
	; ZEILENNUMMER addieren					
	LDS YL,(adr_VGA_BILDZEILEN_NR_L)	
	LDS YH,(adr_VGA_BILDZEILEN_NR_H)	
	add ZL,YL
	adc ZH,YH
	; ZEILENNUMMER +1						
	add YL,EINS
	adc YH,NULL
	STS(adr_VGA_BILDZEILEN_NR_L),YL
	STS(adr_VGA_BILDZEILEN_NR_H),YH
	IJMP		; SPRUNG (Zeiger nach Z)	
;-------------------------------------------------------------------------------
BILDAUFBAU_SPRUNGMARKE:
	rjmp VGA_ZEILE_001		;  1		; VSYNC	
	rjmp VGA_ZEILE_DUMMY	;  2
	rjmp VGA_ZEILE_003		;  3		; VSYNC	
	rjmp VGA_TURBO			;  4		; TURBO	
	rjmp VGA_ZEILE_DUMMY	;  5		; NIX	
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_ZEILE_DUMMY
	rjmp VGA_TURBO_OFF
	rjmp VGA_TURBO_ON
	MACRO_VGA_ZEILE_DATA_480	; DATA		
	rjmp VGA_ZEILE_525			; ZEILE 525	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HSYNC= 3,8s																	
; VSYNC=63,5s																	
VGA_ZEILE_001:
	MACRO_VGA_HSYNC_IMPULS				; HSYNC	
	cbi (VSYNC_PORT),(VSYNC_PIN_NR)		; VSYNC	
	MACRO_REGISTER_WIEDER_HERSTELLEN	; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_ZEILE_003:
	MACRO_VGA_HSYNC_IMPULS				; HSYNC	
	sbi (VSYNC_PORT),(VSYNC_PIN_NR)		; VSYNC	
	MACRO_REGISTER_WIEDER_HERSTELLEN	; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_ZEILE_DUMMY:
	MACRO_VGA_HSYNC_IMPULS				; HSYNC	
	MACRO_REGISTER_WIEDER_HERSTELLEN	; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_ZEILE_525:
	MACRO_VGA_HSYNC_IMPULS					; HSYNC	
;-------------------------------------------------------------------------------
	; ERROR Zeilennummer ?	
	LDS temp,(adr_VGA_BILDZEILEN_NR_L)	
	cpi temp,LOW(525)
	breq VGA_ZEILE_525_NO_ERROR
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR		; ROT  an	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an	
VGA_ZEILE_525_NO_ERROR:
;-------------------------------------------------------------------------------
	; ZEILE NULL						
	STS(adr_VGA_BILDZEILEN_NR_L),NULL
	STS(adr_VGA_BILDZEILEN_NR_H),NULL
	; PIXEL-ZEILEN-COUNTER				
	ldi temp,(VGA_ZEILEN_PRO_PIXEL+1)
	STS(adr_VGA_PIXEL_ZEILEN_COUNTER),temp
	; BILD-ZEILE						
	STS(adr_VGA_BILD_ZEILE),NULL
	; ZEIGER DATA=BILDBEREICH ANFANG	
	ldi ZL,LOW (adr_VGA_BILDBEREICH)
	ldi ZH,HIGH(adr_VGA_BILDBEREICH)
	STS(adr_VGA_ZEIGER_DATA_L),ZL
	STS(adr_VGA_ZEIGER_DATA_H),ZH
	; Register							
	MACRO_REGISTER_WIEDER_HERSTELLEN		; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TURBO-abschalten																
; Alle Zeilen werden komplett ausgegeben										
VGA_TURBO_OFF:
	MACRO_VGA_HSYNC_IMPULS					; HSYNC	
;-------------------------------------------------------------------------------
	LDS temp,(adr_VGA_TURBO_OFF)
	tst temp
	breq VGA_TURBO_OFF_FERTIG
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH160)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH160)
	; SCHLEIFE 160 BYTES	
	ldi temp,10
VGA_TURBO_OFF_s:
	ST Z+,NULL	;  1
	ST Z+,NULL	;  2
	ST Z+,NULL	;  3
	ST Z+,NULL	;  4
	ST Z+,NULL	;  5
	ST Z+,NULL	;  6
	ST Z+,NULL	;  7
	ST Z+,NULL	;  8
	ST Z+,NULL	;  9
	ST Z+,NULL	; 10
	ST Z+,NULL	; 11
	ST Z+,NULL	; 12
	ST Z+,NULL	; 13
	ST Z+,NULL	; 14
	ST Z+,NULL	; 15
	ST Z+,NULL	; 16
	dec temp
	brne VGA_TURBO_OFF_s
	STS(adr_VGA_TURBO_OFF),NULL
;-------------------------------------------------------------------------------
VGA_TURBO_OFF_FERTIG:
	; Register			
	MACRO_REGISTER_WIEDER_HERSTELLEN		; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TURBO-einschalten 															
; keine ZEILE wird ausgegeben													
VGA_TURBO_ON:
	MACRO_VGA_HSYNC_IMPULS					; HSYNC	
;-------------------------------------------------------------------------------
	LDS temp,(adr_VGA_TURBO_ON)
	tst temp
	breq VGA_TURBO_ON_FERTIG
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH160)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH160)
	; SCHLEIFE 160 BYTES	
	ldi YL,10
	ldi temp,255
VGA_BILD_OFF_s:
	ST Z+,temp	;  1
	ST Z+,temp	;  2
	ST Z+,temp	;  3
	ST Z+,temp	;  4
	ST Z+,temp	;  5
	ST Z+,temp	;  6
	ST Z+,temp	;  7
	ST Z+,temp	;  8
	ST Z+,temp	;  9
	ST Z+,temp	; 10
	ST Z+,temp	; 11
	ST Z+,temp	; 12
	ST Z+,temp	; 13
	ST Z+,temp	; 14
	ST Z+,temp	; 15
	ST Z+,temp	; 16
	dec YL
	brne VGA_BILD_OFF_s
	STS(adr_VGA_TURBO_ON),NULL
;-------------------------------------------------------------------------------
VGA_TURBO_ON_FERTIG:
	; Register			
	MACRO_REGISTER_WIEDER_HERSTELLEN		; Register	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
VGA_ZEILE_DATA:
	MACRO_VGA_HSYNC_IMPULS					; HSYNC	
;-------------------------------------------------------------------------------
; PIXEL-ZEILEN berechnen Y,Z,temp wird im "MACRO_VGA_HSYNC_IMPULS" initialisiert
	breq VGA_ZEILE_DATA_NEXT_ZEILE
	; PIXEL-ZEILEN-COUNTER						
	STS(adr_VGA_PIXEL_ZEILEN_COUNTER),temp
	; ZEIGER DATA (Y) wieder laden				
	LDS YL,(adr_VGA_ZEIGER_DATA_L)
	LDS YH,(adr_VGA_ZEIGER_DATA_H)
	; BILD-ZEILE								
	LDS temp,(adr_VGA_BILD_ZEILE)
	; TAKT-AUSGLEICH, sonst Zacken im BILD 		
	nop
	nop
	nop
	rjmp VGA_ZEILE_DATA_NEXT_ZEILE_OK
;-------------------------------------------------------------------------------
VGA_ZEILE_DATA_NEXT_ZEILE:
	; PIXEL-ZEILEN-COUNTER				
	ldi temp,(VGA_ZEILEN_PRO_PIXEL)
	STS(adr_VGA_PIXEL_ZEILEN_COUNTER),temp
	; ZEIGER DATA (Y) speichern			
	STS(adr_VGA_ZEIGER_DATA_L),YL
	STS(adr_VGA_ZEIGER_DATA_H),YH
	; BILD-ZEILE						
	LDS temp,(adr_VGA_BILD_ZEILE)
	inc temp
	STS(adr_VGA_BILD_ZEILE),temp
VGA_ZEILE_DATA_NEXT_ZEILE_OK:
;-------------------------------------------------------------------------------
; Schwarzschulter-REST (1,6s)													
	nop
;-------------------------------------------------------------------------------
; BYTE aus TURBO-BEREICH auslesen												
	add ZL,temp
	adc ZH,NULL
	LD temp,Z	; 0...89
	cpi temp,(VGA_BYTES_PRO_ZEILE+1) 	; vergleich		
	brlo VGA_ZEILE_DATA_RUN
;-------------------------------------------------------------------------------
; sofort verlassen																
	; Register			
	MACRO_REGISTER_WIEDER_HERSTELLEN		; Register	
reti
;-------------------------------------------------------------------------------
VGA_ZEILE_DATA_RUN:
	ldi ZL,LOW (VGA_ZEILE_DATA_SPRUNGMARKE)
	ldi ZH,HIGH(VGA_ZEILE_DATA_SPRUNGMARKE)
	add ZL,temp	; temp x 2	
	adc ZH,NULL
	add ZL,temp	; temp x 3	
	adc ZH,NULL
	add ZL,temp	; temp x 4	
	adc ZH,NULL
	add ZL,temp	; temp x 5	
	adc ZH,NULL
	add ZL,temp	; temp x 6	
	adc ZH,NULL
	IJMP		; SPRUNG (Zeiger nach Z)	
;-------------------------------------------------------------------------------
VGA_ZEILE_DATA_SPRUNGMARKE:
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
	MACRO_VGA_DATA_PIXEL_10	
;-------------------------------------------------------------------------------
	OUT	SREG ,SREG_KOPIE		
	mov TEMP ,temp_KOPIE
	out PORTB,NULL			; RGB aus			
	MOVW YL,YL_KOPIE 		; Copy Register Word
	MOVW ZL,ZL_KOPIE 		; Copy Register Word
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Jede ZEILE auf Dateninhalt prfen												
VGA_TURBO:
	MACRO_VGA_HSYNC_IMPULS				; HSYNC	
	; (Y) auf TURBO_BEREICH 					
	ldi YL,LOW (adr_VGA_TURBO_BEREICH160)
	ldi YH,HIGH(adr_VGA_TURBO_BEREICH160)
	LDS temp,(adr_VGA_TURBO_DUMMY)		; ZHLER
	add YL,temp
	adc YH,NULL
	; (Z) auf ENDE erste ZEILE					
	ldi ZL,LOW (adr_VGA_BILDBEREICH+VGA_BYTES_PRO_ZEILE-1)
	ldi ZH,HIGH(adr_VGA_BILDBEREICH+VGA_BYTES_PRO_ZEILE-1)
	; (Z) auf ENDE der entsprechenden ZEILE		
	push R0
	push R1
	push temp1
	ldi temp1,(VGA_BYTES_PRO_ZEILE)	;90
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
	pop temp1
	pop R1
	pop R0
;-------------------------------------------------------------------------------
	; ZHLER					
	LDS temp,(adr_VGA_TURBO_DUMMY)
	inc temp
	cpi temp,(VGA_Ysitze+1)				; 160
	brlo VGA_TURBO_w
	clr temp
VGA_TURBO_w:
	STS(adr_VGA_TURBO_DUMMY),temp
;-------------------------------------------------------------------------------
	adiw ZL,1
	MACRO_TURBO
	ldi temp,0
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,1
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,2
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,3
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,4
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,5
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,6
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,7
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,8
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,9
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,10
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,11
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,12
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,13
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,14
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,15
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,16
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,17
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,18
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,19
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,20
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,21
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,22
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,23
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,24
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,25
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,26
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,27
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,28
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,29
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,30
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,31
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,32
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,33
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,34
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,35
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,36
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,37
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,38
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,39
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,40
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,41
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,42
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,43
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,44
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,45
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,46
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,47
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,48
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,49
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,50
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,51
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,52
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,53
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,54
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,55
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,56
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,57
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,58
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,59
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,60
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,61
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,62
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,63
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,64
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,65
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,66
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,67
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,68
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,69
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,70
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,71
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,72
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,73
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,74
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,75
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,76
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,77
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,78
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,79
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,80
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,81
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,82
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,83
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,84
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,85
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,86
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,87
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,88
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	MACRO_TURBO
	ldi temp,89
	rjmp VGA_TURBO_FERTIG
;-------------------------------------------------------------------------------
	ldi temp,255
	ldi temp,255
;-------------------------------------------------------------------------------
VGA_TURBO_FERTIG:
;	ldi temp,89
	ST Y,temp	
	; ANZEIGE		
;	cpi temp,90
;	breq VGA_TURBO_FERTIG_w
;	ldi temp,0x11
;	ST Z,temp
;VGA_TURBO_FERTIG_w:

	MACRO_REGISTER_WIEDER_HERSTELLEN	; Register
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
