; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_INITIALISIERUNG:
	; DCF-EINGANG						
	cbi (DCF_DDR) ,(DCF_PIN_NR) ; auf EINGANG
	cbi (DCF_PORT),(DCF_PIN_NR) ; PULL UP aus, wichtig, denn manche DCF-Module sehr hochohmig !

	ldi temp,(DCF_PHASENKORREKTUR_WARTEZEIT)			; Wartezeit in Sekunden, bis Phasenkorrektur	
	STS(adr_DCF_PHASE_WAIT),temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_CHECK_TEMP1:
	clr temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alle 20ms erfolgt ein Aufruf dieser ROUTINE									
DCF_UHR:
	; VORTEILER 0...59			
	LDS temp,(adr_DCF_ss20)
	inc temp
	STS(adr_DCF_ss20),temp
	cpi temp,50
	brlo DCF_UHR_SS_FERTIG
	STS(adr_DCF_ss20),NULL
	; 0..59						
	LDS temp,(adr_DCF_ss)
	inc temp
	STS(adr_DCF_ss),temp
	cpi temp,59+1
	brlo DCF_UHR_SS_FERTIG
	STS(adr_DCF_ss),NULL
DCF_UHR_SS_FERTIG:
;-------------------------------------------------------------------------------
	rcall DCF_UHR_STELLEN
	rcall DCF_EINGANGSSIGNAL_ANPASSUNG
	rcall DCF_PIN_ABFRAGEN
	rcall DCF_PHASENKORREKTUR	
	rcall DCF_SAMPLES_A_B_AND_WRITE
	rcall DCF_ZEIT_BERECHNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_UHR_STELLEN:
	; PROTOKOLL erfolgreich ?	
	LDS temp,(adr_DCF_PROTOKOLL_OK)
	tst temp
	brne DCF_UHR_STELLEN_w
	ret
;------------------------------------------------------------------------
DCF_UHR_STELLEN_w:
	; SEKUNDEN NULL?			
	LDS temp,(adr_DCF_ss)
	tst temp
	breq DCF_UHR_STELLEN_RUN
	ret
;------------------------------------------------------------------------
DCF_UHR_STELLEN_RUN:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRUEN	an			
	STS(adr_DCF_ERROR_CODE),NULL					; ERROR-CODE		
	STS(adr_DS1307_WRITE_AKTIV),EINS				; DS1307 RTC write	
	STS(adr_DCF_PROTOKOLL_OK),NULL					; DCF-PROTOKOLL		
	STS(adr_DCF_GUELTIG),EINS						; DCF_GUELTIG		
	STS(adr_DCF_HEUTE_EMPFANGEN),EINS				; DCF heute schon empfangen
	STS(adr_DCF_NO_BERECHNUNG),EINS					; Kalender + Uhr berspringen	
	; 100-el SEKUNDEN			
	STS(adr_ss20),NULL
	; SEKUNDEN					
	STS(adr_ss),NULL
	; MINUTEN					
	LDS temp,(adr_DCF_mm) 				; aus SRAM laden	
	STS (adr_mm),temp					; in SRAM speichern	
	; STUNDEN					
	LDS temp,(adr_DCF_hh) 				; aus SRAM laden	
	STS (adr_hh),temp					; in SRAM speichern	
	; TAG						
	LDS temp,(adr_DCF_TAG) 				; aus SRAM laden	
	STS (adr_TAG),temp					; in SRAM speichern	
	; Wochentag					
	LDS temp,(adr_DCF_WOCHENTAG) 		; aus SRAM laden	
	STS (adr_WOCHENTAG),temp			; in SRAM speichern	
	; MONAT						
	LDS temp,(adr_DCF_MONAT) 			; aus SRAM laden	
	STS (adr_MONAT),temp				; in SRAM speichern	
	; JAHR						
	LDS temp,(adr_DCF_JAHR) 			; aus SRAM laden	
	STS (adr_JAHR),temp					; in SRAM speichern	
	; MESZ						
	LDS temp,(adr_DCF_MESZ) 			; aus SRAM laden	
	STS (adr_MESZ),temp					; in SRAM speichern	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_EINGANGSSIGNAL_ANPASSUNG:
	; nicht prfen, wenn DCF heute schon empfangen wurde	
	LDS temp,(adr_DCF_HEUTE_EMPFANGEN)
	tst temp
	breq DCF_EINGANGSSIGNAL_ANPASSUNG_RUN
	ret
;------------------------------------------------------------------------
DCF_EINGANGSSIGNAL_ANPASSUNG_RUN:
	; PIN abfragen			
	sbic (DCF_PIN),(DCF_PIN_NR)	; springe, wenn...
	rjmp DCF_EINGANGSSIGNAL_ANPASSUNG_w
	; LOW-PEGEL "zhlen"	
	LDS temp,(adr_DCF_SIGNAL_ZAEHLER)
	inc temp
	STS (adr_DCF_SIGNAL_ZAEHLER),temp
;------------------------------------------------------------------------
DCF_EINGANGSSIGNAL_ANPASSUNG_w:
	; Schleife				
	LDS temp,(adr_DCF_ss20)
	tst temp
	breq DCF_EINGANGSSIGNAL_ANPASSUNG_ww
	ret
;------------------------------------------------------------------------
DCF_EINGANGSSIGNAL_ANPASSUNG_ww:
	; Zhler auswerten	
	LDS temp,(adr_DCF_SIGNAL_ZAEHLER)
	STS(adr_DCF_SIGNAL_ZAEHLER),NULL
	cpi temp,25
	brsh DCF_EINGANGSSIGNAL_ANPASSUNG_INVERTIEREN
;------------------------------------------------------------------------
DCF_EINGANGSSIGNAL_ANPASSUNG_NO_INVERTIEREN:
	STS(adr_DCF_SIGNAL_INVERTIEREN),NULL
	ret
;------------------------------------------------------------------------
DCF_EINGANGSSIGNAL_ANPASSUNG_INVERTIEREN:
	STS(adr_DCF_SIGNAL_INVERTIEREN),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DCF77-TRGER=ON=MODULAUSGANG=5V (NORMAL)										
; DCF77-TRGER=ON=MODULAUSGANG=0V (INVERTIERT)									
; Abtastung erfolgt 50 mal pro Sekunde											
; LED GELB muss kurz aufleuchten, wenn DCF77 Trger ausgetastet ist				
DCF_PIN_ABFRAGEN:
	; INVERTIERMODUS ?	
	LDS temp,(adr_DCF_SIGNAL_INVERTIEREN)
	SBRC temp,0				; skip if...
	rjmp DCF_PIN_ABFRAGEN_TEMP1_NO_INVERTIERT
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_TRAEGER_ON
	rjmp DCF_PIN_ABFRAGEN_77kHz_TRAEGER_OFF
;------------------------------------------------------------------------
DCF_PIN_ABFRAGEN_TEMP1_NO_INVERTIERT:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_TRAEGER_OFF
	rjmp DCF_PIN_ABFRAGEN_77kHz_TRAEGER_ON
;------------------------------------------------------------------------
DCF_PIN_ABFRAGEN_77kHz_TRAEGER_ON:
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB-AUS					
	STS(adr_DCF_TRAEGER),EINS						; DCF-TRAEGER=EINS			
	ret
;------------------------------------------------------------------------
DCF_PIN_ABFRAGEN_77kHz_TRAEGER_OFF:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB-AN					
	STS(adr_DCF_TRAEGER),NULL						; DCF_TRAEGER=NULL			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Immer wenn der DCF-TRGER ausgetastet wird, wird der Zeitpunkt des 			
; Flankenwechsels mit der internen UHR verglichen.								
; Der Flankenwechsel muss im Bereich 0..2 erfolgen.								
; 																				
DCF_PHASENKORREKTUR:
	; PEGEL/Trgerwechsel ?		
	LDS temp,(adr_DCF_TRAEGER)
	tst temp
	breq DCF_PHASENKORREKTUR_w
	STS(adr_DCF_TRAEGER_OLD),EINS
	ret
DCF_PHASENKORREKTUR_w:
	LDS temp,(adr_DCF_TRAEGER_OLD)
	STS(adr_DCF_TRAEGER_OLD),NULL
	tst temp
	brne DCF_PHASENKORREKTUR_RUN
	ret
;------------------------------------------------------------------------
DCF_PHASENKORREKTUR_RUN:
	; Zeitvergleich		
	LDS temp,(adr_DCF_ss20)
	STS(adr_DCF_PHASE),temp	; fr Kontrollzwecke 
	cpi temp,1		; Phasenabweichung 0...2, ideal ist 1
	brne DCF_PHASENKORREKTUR_WAIT
;------------------------------------------------------------------------
	ldi temp,(DCF_PHASENKORREKTUR_WARTEZEIT)			; Wartezeit in Sekunden, bis Phasenkorrektur	
	STS(adr_DCF_PHASE_WAIT),temp
	ret
;------------------------------------------------------------------------
DCF_PHASENKORREKTUR_WAIT:
	; WARTESCHLEIFE	
	LDS temp,(adr_DCF_PHASE_WAIT)
	dec temp
	STS(adr_DCF_PHASE_WAIT),temp
	breq DCF_PHASENKORREKTUR_AKTION
	ret
;------------------------------------------------------------------------
DCF_PHASENKORREKTUR_AKTION:
	; WARTEZEIT		
	ldi temp,(DCF_PHASENKORREKTUR_WARTEZEIT)			; Wartezeit in Sekunden, bis Phasenkorrektur	
	STS(adr_DCF_PHASE_WAIT),temp
	STS(adr_DCF_ss20),EINS  ; PHASE auf 1 setzen						
	; ERROR			
	ldi temp1,(ERROR_DCF_PHASE)
	STS(adr_DCF_ERROR_CODE),temp1
	LDS temp2,(adr_DCF_PHASE)
	call FEHLERSPEICHER_WRITE_TEMP1_TEMP2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bei 60ms und 160ms wird gesampelt												
DCF_SAMPLES_A_B_AND_WRITE:
	LDS temp,(adr_DCF_ss20)
	cpi temp,3		; 60ms	
	breq DCF_SAMPLES_A
	cpi temp,8		; 160ms	
	breq DCF_SAMPLES_B
	cpi temp,30		; 300ms	
	breq DCF_SAMPLES_WRITE
	cpi temp,40 	; 400ms	
	breq DCF_ZEIT_BERECHNUNG
ret
;---------------------------------------------------------------------------
; SAMPLES "A"																
DCF_SAMPLES_A:
	LDS temp,(adr_DCF_TRAEGER)
	com temp
	STS(adr_DCF_SAMPLES_A),temp
	ret
;---------------------------------------------------------------------------
; SAMPLES "B"																
DCF_SAMPLES_B:
	LDS temp,(adr_DCF_TRAEGER)
	com temp
	andi temp,0b00000001
	STS(adr_DCF_SAMPLES_B),temp	; nur 0 und 1 zulssig, wegen nachfolgender Berechnung !
	ret
;---------------------------------------------------------------------------
; SAMPLES-BIT in das DATENFELD schreiben									
DCF_SAMPLES_WRITE:
	LDI ZL, low(adr_DCF_BEREICH60)	; Z-ZEIGER initialisieren			
	LDI ZH,high(adr_DCF_BEREICH60)
	LDS temp,(adr_DCF_ss)			; addieren							
	add ZL,temp
	adc ZH,NULL
	LDS temp,(adr_DCF_SAMPLES_B)	;"B" SAMPLES in's Datenfeld schreiben ("A"wird ignoriert)	
	ST Z,temp
;---------------------------------------------------------------------------
	; DCF-MINUTEN-ENDE ?			
	LDS temp,(adr_DCF_SAMPLES_A)
	SBRC temp,0	; skip if...
	ret
	LDS temp,(adr_DCF_SAMPLES_B)
	SBRC temp,0	; skip if...
	ret
;---------------------------------------------------------------------------
	; 59-te Sekunde ?			
	LDS temp,(adr_DCF_ss)
	cpi temp,59
	brne DCF_MINUTEN_ENDE_ERROR
	; Minutenende erkannt		
	STS(adr_DCF_MINUTENENDE),EINS
	ret
;---------------------------------------------------------------------------
DCF_MINUTEN_ENDE_ERROR:
	; auf 59 Sekunden setzen	
	ldi temp,59
	STS(adr_DCF_ss),temp
	STS(adr_DCF_GUELTIG),NULL						; DCF_GUELTIG	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; LED-GRUEN		
	; CLEAR						
	rcall DCF_BEREICH_CLEAR
	; ERROR Code				
	ldi temp,(ERROR_DCF_MINUTENENDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Bit(s) Anzahl 		Bedeutung 												
; 0 		1 bit	Start einer neuen Minute (ist immer "0") 				
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
;59 		1 bit	MINUTEN-ENDE											
DCF_ZEIT_BERECHNUNG:
	; MINUTENENDE erkannt ?	
	LDS temp,(adr_DCF_MINUTENENDE)
	tst temp
	brne DCF_ZEIT_BERECHNUNG_RUN
	ret
;---------------------------------------------------------------------------
DCF_ZEIT_BERECHNUNG_RUN:
	STS(adr_DCF_MINUTENENDE),NULL					; MINUTENENDE	
	STS(adr_DCF_GUELTIG),NULL						; DCF_GUELTIG	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRUEN aus 	
;---------------------------------------------------------------------------
;0 	Start einer neuen Minute (ist immer "0") 				
DCF_ZEIT_00:
	LDS temp,(adr_DCF_BEREICH60+0)			; aus SRAM laden	
 	tst temp 
	breq DCF_ZEIT_00_OK
	; ERROR						
	ldi temp,(ERROR_DCF_NO_ANFANGSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_00_OK:
;---------------------------------------------------------------------------
;1-14 Wetterdaten															
DCF_ZEIT_01:
;---------------------------------------------------------------------------
;15 Reserveantenne aktiv													
DCF_ZEIT_15:
	LDS temp,(adr_DCF_BEREICH60+15)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_15_OK
	; ERROR	(als INFO)				
	ldi temp,(ERROR_DCF_RESERVEANTENNE)
	STS(adr_DCF_ERROR_CODE),temp
DCF_ZEIT_15_OK:
;---------------------------------------------------------------------------
;16 Umstellung von MEZ auf MESZ oder umgekehrt								
DCF_ZEIT_16:
	LDS temp,(adr_DCF_BEREICH60+16)
	tst temp
	breq DCF_ZEIT_16_OK
	; ERROR	(als INFO)				
	ldi temp,(ERROR_DCF_ZEITUMSTELLUNG)
	STS(adr_DCF_ERROR_CODE),temp
DCF_ZEIT_16_OK:
;---------------------------------------------------------------------------
;17 SOMMERZEIT aktiv				"0": MEZ, "1": MESZ 					
DCF_ZEIT_17:
	LDS temp,(adr_DCF_BEREICH60+17)
	STS (adr_DCF_MESZ),temp			; im SRAM ablegen	
;---------------------------------------------------------------------------
;18 NORMALZEIT aktiv				"1": MEZ, "0": MESZ 					
DCF_ZEIT_18:
	LDS temp1,(adr_DCF_BEREICH60+18)
	; MEZ<>MESZ					
	add temp,temp1
	cpi temp,1
	breq DCF_ZEIT_18_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MESZ)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_18_OK:
;---------------------------------------------------------------------------
;19 Ankndigung Schaltsekunde												
DCF_ZEIT_19:
	LDS temp,(adr_DCF_BEREICH60+19)
	tst temp
	breq DCF_ZEIT_19_OK
	; ERROR						
	ldi temp,(ERROR_DCF_SCHALTSEKUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_19_OK:
;---------------------------------------------------------------------------
;20 Beginn der Zeitinformation (ist immer "1") 								
DCF_ZEIT_20:
	LDS temp,(adr_DCF_BEREICH60+20)
 	tst temp 
	brne DCF_ZEIT_20_OK
	; ERROR-CODE			
	ldi temp,(ERROR_DCF_NO_ZEITINFORMATIONSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_20_OK:
;---------------------------------------------------------------------------
;21-27 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 				
DCF_ZEIT_21:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH60+21)
	ldi ZH,HIGH(adr_DCF_BEREICH60+21)
	rcall FUNCTION_DCF_BIT_01	; 21
	rcall FUNCTION_DCF_BIT_02	; 22
	rcall FUNCTION_DCF_BIT_04	; 23
	rcall FUNCTION_DCF_BIT_08	; 24
	rcall FUNCTION_DCF_BIT_10	; 25
	rcall FUNCTION_DCF_BIT_20	; 26
	rcall FUNCTION_DCF_BIT_40	; 27
	; MINUTENWERT bernehmen	
	STS(adr_DCF_mm),temp1
	; Fehlerprfung MINUTE 0...59
	cpi temp1,(59+1)
	brlo DCF_ZEIT_27_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_27_OK:
;---------------------------------------------------------------------------
;28  	Paritt Minute 											
DCF_ZEIT_28:
	LDS temp,(adr_DCF_BEREICH60+28)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_28_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_28_OK:
;---------------------------------------------------------------------------
;29-34 	 	Stunde (1, 2, 4, 8, 10, 20) 									
DCF_ZEIT_29:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH60+29)
	ldi ZH,HIGH(adr_DCF_BEREICH60+29)
	rcall FUNCTION_DCF_BIT_01	; 29
	rcall FUNCTION_DCF_BIT_02	; 30
	rcall FUNCTION_DCF_BIT_04	; 31
	rcall FUNCTION_DCF_BIT_08	; 32
	rcall FUNCTION_DCF_BIT_10	; 33
	rcall FUNCTION_DCF_BIT_20	; 34
	; STUNDENWERT bernehmen		
	STS(adr_DCF_hh),temp1
	; Fehlerprfung STUNDE 0...23	
	cpi temp1,(23+1)
	brlo DCF_ZEIT_34_OK
	; ERROR							
	ldi temp,(ERROR_DCF_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_34_OK:
;---------------------------------------------------------------------------
;35 			Paritt Stunde 											
DCF_ZEIT_35:
	LDS temp,(adr_DCF_BEREICH60+35)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_35_OK
	; ERROR-CODE				
	ldi temp,(ERROR_DCF_PARITAET_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_35_OK:
;---------------------------------------------------------------------------
;36-41 		 	Monatstag (1, 2, 4, 8, 10, 20) 								
DCF_ZEIT_36:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH60+36)
	ldi ZH,HIGH(adr_DCF_BEREICH60+36)
	rcall FUNCTION_DCF_BIT_01	; 36
	rcall FUNCTION_DCF_BIT_02	; 37
	rcall FUNCTION_DCF_BIT_04	; 38
	rcall FUNCTION_DCF_BIT_08	; 39
	rcall FUNCTION_DCF_BIT_10	; 40
	rcall FUNCTION_DCF_BIT_20	; 41
	; TAG bernehmen			
	STS(adr_DCF_TAG),temp1
	; Fehlerprfung TAG	1...31	
	tst temp1
	breq DCF_ZEIT_41_ERROR
	cpi temp1,(31+1)
	brlo DCF_ZEIT_41_OK
	; ERROR						
DCF_ZEIT_41_ERROR:
	ldi temp,(ERROR_DCF_TAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_41_OK:
;---------------------------------------------------------------------------
;42-44 		 	Wochentag (1, 2, 4) 										
DCF_ZEIT_42:
	clr temp1	; BIT					
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH60+42)
	ldi ZH,HIGH(adr_DCF_BEREICH60+42)
	rcall FUNCTION_DCF_BIT_01	; 42
	rcall FUNCTION_DCF_BIT_02	; 43
	rcall FUNCTION_DCF_BIT_04	; 44
	; WOCHENTAG bernehmen		
	STS(adr_DCF_WOCHENTAG),temp1
	; Fehlerprfung WOCHENTAG 1=MO 1...7	
	tst temp1
	breq DCF_ZEIT_44_ERROR
	cpi temp1,(7+1)
	brlo DCF_ZEIT_44_OK
	; ERROR						
DCF_ZEIT_44_ERROR:
	ldi temp,(ERROR_DCF_WOCHENTAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_44_OK:
;---------------------------------------------------------------------------
;45-49 		 	Monat (1, 2, 4, 8, 10) 										
DCF_ZEIT_45:
	clr temp1	; BIT					
	; Z-ZEIGER						
	ldi ZL,LOW (adr_DCF_BEREICH60+45)
	ldi ZH,HIGH(adr_DCF_BEREICH60+45)
	rcall FUNCTION_DCF_BIT_01	; 45
	rcall FUNCTION_DCF_BIT_02	; 46
	rcall FUNCTION_DCF_BIT_04	; 47
	rcall FUNCTION_DCF_BIT_08	; 48
	rcall FUNCTION_DCF_BIT_10	; 49
	; MONAT bernehmen				
	STS(adr_DCF_MONAT),temp1
	; Fehlerprfung MONAT 1...12	
	tst temp1
	breq DCF_ZEIT_49_ERROR
	cpi temp1,(12+1)
	brlo DCF_ZEIT_49_OK
	; ERROR							
DCF_ZEIT_49_ERROR:
	ldi temp,(ERROR_DCF_MONAT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_49_OK:
;---------------------------------------------------------------------------
;50-57 		 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 				
DCF_ZEIT_50:
	clr temp1	; BIT					
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH60+50)
	ldi ZH,HIGH(adr_DCF_BEREICH60+50)
	rcall FUNCTION_DCF_BIT_01	; 50
	rcall FUNCTION_DCF_BIT_02	; 51
	rcall FUNCTION_DCF_BIT_04	; 52
	rcall FUNCTION_DCF_BIT_08	; 53
	rcall FUNCTION_DCF_BIT_10	; 54
	rcall FUNCTION_DCF_BIT_20	; 55
	rcall FUNCTION_DCF_BIT_40	; 56
	rcall FUNCTION_DCF_BIT_80	; 57
	; JAHR bernehmen			
	STS(adr_DCF_JAHR),temp1
	; Fehlerprfung Jahr 15...40
	cpi temp1,(40+1)		; <=40
	brsh DCF_ZEIT_57_ERROR
	cpi temp1,(15)			; >=15
	brsh DCF_ZEIT_57_OK
DCF_ZEIT_57_ERROR:
	; ERROR						
	ldi temp,(ERROR_DCF_JAHR)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_57_OK:
;---------------------------------------------------------------------------
;58 Paritt Datum 											
DCF_ZEIT_58:
	LDS temp,(adr_DCF_BEREICH60+58)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_58_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_DATUM)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_58_OK:
; --------------------------------------------------------------------------
	; DCF-PROTOKOLL ist korrekt !!!		 
	STS(adr_DCF_PROTOKOLL_OK),EINS					; DCF-BERECHNUNG ok	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Wertigkeit + Paritt berechnen											
; 1, 2, 4, 8, 10, 20, 40, 80												
; INP/OUT: Z																
; INP/OUT: temp1															
FUNCTION_DCF_BIT_01:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-1 ; +1	
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_02:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-2 ;+2	
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_04:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-4 ;+ 4
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_08:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-8 ;+ 8
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_10:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-10 ;+ 10
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_20:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-20 ;+ 20
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_40:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-40 ;+ 40
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_80:
	LD temp,Z+	; laden Z	
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-80 ;+ 80
; --------------------------------------------------------------------------
FUNCTION_DCF_BIT_PARITAET:
	add temp2,EINS			; Paritt+1
	andi temp2,0b00000001 	; BITMUSTER
	ret
; --------------------------------------------------------------------------
FUNCTION_DCF_BIT_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_BEREICH_CLEAR:
	ldi ZL,LOW (adr_DCF_BEREICH60)
	ldi ZH,HIGH(adr_DCF_BEREICH60)
	ldi temp,60
DCF_BEREICH_CLEAR_s:
	ST Z+,NULL
	dec temp
	brne DCF_BEREICH_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_ANZEIGE_STATUS:
	call ASCII_CURSOR_ZEILE_0
	call FARBE_GRUEN	
	call ANZEIGE_DATUM_KURZ
	call ASCII_SPACE6
	call ANZEIGE_ZEIT_KURZ

	call ASCII_CURSOR_ZEILE_NEXT
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE6
	call ANZEIGE_DCF_SYMBOL1_KURZ
	call ASCII_SPACE6
	call ANZEIGE_MEZ_MESZ_KURZ
; --------------------------------------------------------------------------
	; DCF							
	call ASCII_CURSOR_ZEILE_3
	call FARBE_GELB
	; DCF-SEKUNDEN					
	call ASCII_S
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_ss)
	call ANZEIGE_2_STELLEN_TEMP1
	; DCF-PHASE						
	call ASCII_CURSOR_ZEILE_NEXT	
	call ASCII_P
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_PHASE)
	cpi temp1,1
	breq ANZEIGE_WARTUNG_P_OK
	call FARBE_ROT
ANZEIGE_WARTUNG_P_OK:
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_SPACE3
	; DCF-PHASE-WAIT				
	call FARBE_GELB
	call ASCII_W
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_PHASE_WAIT)
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_SPACE3
	; DCF-INVERTIERUNG-SIGNAL		
	call ASCII_I
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_SIGNAL_INVERTIEREN)
	call ANZEIGE_1_STELLEN_TEMP1
	; DCF-GLTIG					
	call ASCII_CURSOR_ZEILE_NEXT
	call ASCII_G
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_GUELTIG)
	call ANZEIGE_1_STELLEN_TEMP1
	call ASCII_SPACE4
	; DCF-EROR-CODE					
	LDS temp1,(adr_DCF_ERROR_CODE)
	tst temp1
	breq ANZEIGE_WARTUNG_DCF_NO_ERROR
	call FARBE_ROT
ANZEIGE_WARTUNG_DCF_NO_ERROR:
	call ASCII_E
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_DCF_ERROR_CODE)
	call ANZEIGE_3_STELLEN_TEMP1_NONULL
; ----------------------------------------------------------------------------
;Bit(s) Anzahl 		Bedeutung 												
; 0 		1 bit	Start einer neuen Minute (ist immer "0") 				
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
;59 		1 bit	MINUTEN-ENDE											
	; DCF-BEREICH					
	call ASCII_CURSOR_ZEILE_7
	clr temp9
	ldi ZL, LOW(adr_DCF_BEREICH60)
	ldi ZH,HIGH(adr_DCF_BEREICH60)

	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD

	call ASCII_CURSOR_ZEILE_8
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD
	call ANZEIGE_WARTUNG_DCF_FELD

ret
; ----------------------------------------------------------------------------
ANZEIGE_WARTUNG_DCF_FELD:
	call FARBE_GRUEN
	inc temp9
	LDS temp,(adr_DCF_ss)
	cp temp9,temp
	brne ANZEIGE_WARTUNG_DCF_FELD_w
	call FARBE_ROT
ANZEIGE_WARTUNG_DCF_FELD_w:
	LD  temp,Z+
	tst temp
	brne ANZEIGE_WARTUNG_DCF_FELD1
ANZEIGE_WARTUNG_DCF_FELD0:
	call ASCII_MINUS
	ret
ANZEIGE_WARTUNG_DCF_FELD1:
	call ASCII_1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
