; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP (DATEN)														
;																				
EEPROM_READ_Z_TEMP:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_READ_Z_TEMP
	out EEARH, ZH	; ADRESSE						
	out EEARL, ZL
	sbi EECR,EERE	; Start eeprom read 			
	in temp,EEDR 	; Read data 					
	adiw ZL,1		; ADRESSE +1 					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
EEPROM_WRITE_Z_TEMP:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_TEMP
	out EEARH, ZH	; Adresse								
	out EEARL, ZL	
	adiw ZL,1		; ADRESSE +1 							
;-------------------------------------------------------------------------------
	sbi EECR,EERE	; Start eeprom read 			
	in R0,EEDR 		; Read data 					
	cp temp,R0
	brne EEPROM_WRITE_Z_TEMP_w
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_Z_TEMP_w:
	out EEDR,temp	; Write data							
	sbi EECR,EEMPE	; Write logical one to EEMPE			
	sbi EECR,EEPE 	; Start eeprom write by setting EEPE	
;-------------------------------------------------------------------------------
	cbi (RELAIS_KLICK_PORT),(RELAIS_KLICK_PIN_NR)	; RELAIS-KLICK-an		
	call wait_100ms
	sbi (RELAIS_KLICK_PORT),(RELAIS_KLICK_PIN_NR)	; RELAIS-KLICK-an		
	call wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	; RTC									
	call DS1307_RTC_STELLEN_SOFORT
	; Z-ADRESSE								
	ldi ZL, LOW(adr_EEPROM_WERKSEINSTELLUNG)
	ldi ZH,HIGH(adr_EEPROM_WERKSEINSTELLUNG)
	; VERSION								
	ldi temp,(VERSION)
	rcall EEPROM_WRITE_Z_TEMP		; write	0
	; PROGRAMM-LNGE(LOW)					
	ldi temp,LOW(PROGRAMM_ENDE*2)
	rcall EEPROM_WRITE_Z_TEMP		; write	1
	; PROGRAMM-LNGE(HIGH)					
	ldi temp,HIGH(PROGRAMM_ENDE*2)
	rcall EEPROM_WRITE_Z_TEMP		; write	2
;-------------------------------------------------------------------------------
	; ANZEIGE-SONNEN-AUFGANG-UNTERGANG		
	LDS temp,(adr_SONNE_ANZEIGE)
	rcall EEPROM_WRITE_Z_TEMP		; write	0
	; KREIS-KORREKTUR						
	LDS temp,(adr_ENTZERRUNG_KREIS)
	rcall EEPROM_WRITE_Z_TEMP		; write	1
	; TOUCH-BEEP							
	LDS temp,(adr_TOUCH_BEEP_ON)
	rcall EEPROM_WRITE_Z_TEMP		; write	2
	; STUNDEN-KLICK							
	LDS temp,(adr_hh_KLICK_ON)
	rcall EEPROM_WRITE_Z_TEMP		; write	3
	; MESZ / MEZ							
	LDS temp,(adr_MESZ)
	rcall EEPROM_WRITE_Z_TEMP		; write	4
	; OFFSET (L)							
	LDS temp,(adr_DRUCK_OFFSET_L)
	rcall EEPROM_WRITE_Z_TEMP		; write	5
	; OFFSET (H)							
	LDS temp,(adr_DRUCK_OFFSET_H)
	rcall EEPROM_WRITE_Z_TEMP		; write	6
	; MODUS bei PROGRAMMSTART				
	LDS temp,(adr_MODUS_PROGRAMMSTART)
	rcall EEPROM_WRITE_Z_TEMP		; write	7
	; TEST-ZAHL-BYTE0						
	LDS temp,(adr_TEST_ZAHL_BYTE0)
	rcall EEPROM_WRITE_Z_TEMP		; write	8
	; TEST-ZAHL-BYTE1						
	LDS temp,(adr_TEST_ZAHL_BYTE1)
	rcall EEPROM_WRITE_Z_TEMP		; write	9
	; TEST-ZAHL-BYTE2						
	LDS temp,(adr_TEST_ZAHL_BYTE2)
	rcall EEPROM_WRITE_Z_TEMP		; write	10
	; TEST-ZAHL-BYTE3						
	LDS temp,(adr_TEST_ZAHL_BYTE3)
	rcall EEPROM_WRITE_Z_TEMP		; write	11
;-------------------------------------------------------------------------------
	; Z-ADRESSE								
	ldi ZL, LOW(adr_EEPROM_WERKSEINSTELLUNG+100)
	ldi ZH,HIGH(adr_EEPROM_WERKSEINSTELLUNG+100)
	; FARBE-TAG								
	LDS temp,(adr_FARBE_TAG)
	rcall EEPROM_WRITE_Z_TEMP		; write	0
	; FARBE-NACHT							
	LDS temp,(adr_FARBE_NACHT)
	rcall EEPROM_WRITE_Z_TEMP		; write	1
	; NACHTMODUS-ON-hh						
	LDS temp,(adr_NACHTMODUS_ON_hh)
	rcall EEPROM_WRITE_Z_TEMP		; write	2
	; NACHTMODUS-ON-mm						
	LDS temp,(adr_NACHTMODUS_ON_mm)
	rcall EEPROM_WRITE_Z_TEMP		; write	3
	; NACHTMODUS-OFF-hh						
	LDS temp,(adr_NACHTMODUS_OFF_hh)
	rcall EEPROM_WRITE_Z_TEMP		; write	4
	; NACHTMODUS-OFF-mm						
	LDS temp,(adr_NACHTMODUS_OFF_mm)
	rcall EEPROM_WRITE_Z_TEMP		; write	5
	; DISPLAY-ON-hh							
	LDS temp,(adr_DISPLAY_ON_hh)
	rcall EEPROM_WRITE_Z_TEMP		; write	6
	; DISPLAY-ON-mm							
	LDS temp,(adr_DISPLAY_ON_mm)
	rcall EEPROM_WRITE_Z_TEMP		; write	7
	; DISPLAY-OFF-hh						
	LDS temp,(adr_DISPLAY_OFF_hh)
	rcall EEPROM_WRITE_Z_TEMP		; write	8
	; DISPLAY-OFF-mm						
	LDS temp,(adr_DISPLAY_OFF_mm)
	rcall EEPROM_WRITE_Z_TEMP		; write	9

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:
	; Z-ADRESSE								
	ldi ZL, LOW(adr_EEPROM_WERKSEINSTELLUNG)
	ldi ZH,HIGH(adr_EEPROM_WERKSEINSTELLUNG)
	; VERSION								
	rcall EEPROM_READ_Z_TEMP		; read	0
	cpi temp,(VERSION)
	brne EEPROM_KONFIGURATION_WERKSEINSTELLUNG 
	; PROGRAMM-LNGE(LOW)					
	rcall EEPROM_READ_Z_TEMP		; read	1
	cpi temp,LOW(PROGRAMM_ENDE*2)
	brne EEPROM_KONFIGURATION_WERKSEINSTELLUNG 
	; PROGRAMM-LNGE(HIGH)					
	rcall EEPROM_READ_Z_TEMP		; read	2
	cpi temp,HIGH(PROGRAMM_ENDE*2)
	brne EEPROM_KONFIGURATION_WERKSEINSTELLUNG 
	rjmp EEPROM_KONFIGURATION_LADEN_RUN
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_WERKSEINSTELLUNG:
	; WERKSEINSTELLUNG						
	call FARBE_ROT
	call ASCII_W
	call ASCII_E
	call ASCII_R
	call ASCII_K
	call ASCII_SPACE
	call wait_1s
	ret
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_RUN:
	; ANZEIGE-SONNEN-AUFGANG-UNTERGANG		
	rcall EEPROM_READ_Z_TEMP		; read	0
	STS(adr_SONNE_ANZEIGE),temp
	; KREIS-KORREKTUR						
	rcall EEPROM_READ_Z_TEMP		; read	1
	STS(adr_ENTZERRUNG_KREIS),temp
	; TOUCH-BEEP							
	rcall EEPROM_READ_Z_TEMP		; read	2
	STS(adr_TOUCH_BEEP_ON),temp
	; STUNDEN-KLICK							
	rcall EEPROM_READ_Z_TEMP		; read	3
	STS(adr_hh_KLICK_ON),temp
	; MESZ / MEZ							
	rcall EEPROM_READ_Z_TEMP		; read	4
	STS(adr_MESZ),temp
	; OFFSET (L)							
	rcall EEPROM_READ_Z_TEMP		; read	5
	STS(adr_DRUCK_OFFSET_L),temp
	; OFFSET (H)							
	rcall EEPROM_READ_Z_TEMP		; read	6
	STS(adr_DRUCK_OFFSET_H),temp
	; MODUS bei PROGRAMMSTART				
	rcall EEPROM_READ_Z_TEMP		; read	7
	STS(adr_MODUS_PROGRAMMSTART),temp
	; TEST-ZAHL-BYTE0						
	rcall EEPROM_READ_Z_TEMP		; read	8
	STS(adr_TEST_ZAHL_BYTE0),temp
	; TEST-ZAHL-BYTE1						
	rcall EEPROM_READ_Z_TEMP		; read	9
	STS(adr_TEST_ZAHL_BYTE1),temp
	; TEST-ZAHL-BYTE2						
	rcall EEPROM_READ_Z_TEMP		; read	10
	STS(adr_TEST_ZAHL_BYTE2),temp
	; TEST-ZAHL-BYTE3						
	rcall EEPROM_READ_Z_TEMP		; read	11
	STS(adr_TEST_ZAHL_BYTE3),temp
;-------------------------------------------------------------------------------
	; Z-ADRESSE								
	ldi ZL, LOW(adr_EEPROM_WERKSEINSTELLUNG+100)
	ldi ZH,HIGH(adr_EEPROM_WERKSEINSTELLUNG+100)
	; FARBE-TAG								
	rcall EEPROM_READ_Z_TEMP		; read	0
	andi temp,0b00000111			; BITMUSTER
	STS(adr_FARBE_TAG),temp
	; FARBE-NACHT							
	rcall EEPROM_READ_Z_TEMP		; read	1
	andi temp,0b00000111			; BITMUSTER
	STS(adr_FARBE_NACHT),temp
	; NACHTMODUS-ON-hh						
	rcall EEPROM_READ_Z_TEMP		; read	2
	STS(adr_NACHTMODUS_ON_hh),temp
	; NACHTMODUS-ON-mm						
	rcall EEPROM_READ_Z_TEMP		; read	3
	STS(adr_NACHTMODUS_ON_mm),temp
	; NACHTMODUS-OFF-hh						
	rcall EEPROM_READ_Z_TEMP		; read	4
	STS(adr_NACHTMODUS_OFF_hh),temp
	; NACHTMODUS-OFF-mm						
	rcall EEPROM_READ_Z_TEMP		; read	5
	STS(adr_NACHTMODUS_OFF_mm),temp
	; DISPLAY-ON-hh							
	rcall EEPROM_READ_Z_TEMP		; read	6
	STS(adr_DISPLAY_ON_hh),temp
	; DISPLAY-ON-mm							
	rcall EEPROM_READ_Z_TEMP		; read	7
	STS(adr_DISPLAY_ON_mm),temp
	; DISPLAY-OFF-hh						
	rcall EEPROM_READ_Z_TEMP		; read	8
	STS(adr_DISPLAY_OFF_hh),temp
	; DISPLAY-OFF-mm						
	rcall EEPROM_READ_Z_TEMP		; read	9
	STS(adr_DISPLAY_OFF_mm),temp


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
