; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
FUNCTION_ZUFALLSZAHL_TEMP1:
	clr ZL
	clr ZH
	clr R3
FUNCTION_ZUFALLSZAHL_TEMP_s:
	LD R0,Z+
	add R1,R0
	dec R3
	brne FUNCTION_ZUFALLSZAHL_TEMP_s

	ldi temp,128
	add R1,temp

	mul R1,temp1
	mov temp1,R1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT:  TEMP1...4	Produkt													
; 	OUTPUT: TEMP1...4	Produkt													
FUNKTION_32_mal_10:
	clr R0
	mov temp5,temp1
	mov temp6,temp2
	mov temp7,temp3
	mov temp8,temp4
	ldi temp9,9
FUNKTION_32_mal_10_s:
	; 9 x addieren	
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	adc R0, NULL
	; BERLAUF		
	tst R0
	brne FUNKTION_32_mal_10_UEBELAUF
	dec temp9
	brne FUNKTION_32_mal_10_s
	ret
FUNKTION_32_mal_10_UEBELAUF:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT:  TEMP1...4	Produkt													
; 	OUTPUT: TEMP1...4	Produkt													
FUNKTION_32_mal_1000:
	rcall FUNKTION_32_mal_10
	rcall FUNKTION_32_mal_10
	rjmp FUNKTION_32_mal_10
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT:  TEMP1...4	Produkt													
; 	OUTPUT: TEMP1...4	Produkt													
FUNKTION_32_mal_1000000:
	rcall FUNKTION_32_mal_1000
	rjmp FUNKTION_32_mal_1000
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014															
;																				
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor											
;			TEMP3 / TEMP4	2.Faktor											
; 																				
; 	OUTPUT: TEMP1...4	Produkt													
; 																				
;	HILFSREGISTER: 	R0,R1 (werden nicht gesichert !	)							
; 																				
MULTIPLIKATION_16_8_24:
  	mul temp1,temp3
  	mov temp1,R0
  	mov R2,R1
  	mul temp2,temp3
  	mov temp2,R0
  	add temp2,R2

  	clr temp3 
  	adc temp3,R1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16_32:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	mul	temp4,temp2		; ah * bh
	mov	temp7,r0
	mov	temp8,r1
	mul	temp3,temp1		; al * bl
	mov	temp5,r0
	mov	temp6,r1
	mul	temp4,temp1		; ah * bl
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2
	mul	temp2,temp3		; bh * al
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2


	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	muls temp4, temp2		; (signed)ah * (signed)bh
	mov	temp7, r0
	mov	temp8, r1
	mul	temp3, temp1		; al * bl
	mov	temp5, r0
	mov	temp6, r1
	mulsu	temp4, temp1		; (signed)ah * bl
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2
	mulsu	temp2, temp3		; (signed)bh * al
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2

	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl	signiert							
;																				
;	input/Output 	temp1 Divident	(LOW)										
;	input/Output 	temp2 Divident												
;	input/Output 	temp3 Divident												
;	input/Output 	temp4 Divident (HIGH)	signiert							
;																				
;	input			temp5 Divisor	(LOW)	 									
;	input			temp6 Divisor	(HIGH)	signiert							
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister (wird nicht gesichert, wegen Taktersparnis !)	
;																				
FUNCTION_DIVISION_32_16_SIGNIERT:
	clr temp
	; ist Divisor negativ?	
	SBRS temp6,7 			; SPRUNG bei NEGATIV	
	rjmp FUNCTION_DIVISION_32_16_DIVISOR_OK
;-------------------------------------------------------------------------------
	inc temp ; +1 	
	; invertieren (BETRAG bilden)	
	com temp5
	com temp6
	subi temp5, LOW (-1)	; +1	
	sbci temp6, HIGH(-1)
FUNCTION_DIVISION_32_16_DIVISOR_OK:
;-------------------------------------------------------------------------------
	; ist DIVIDENT negativ?
	SBRS temp4,7 			; SPRUNG bei NEGATIV	
	rjmp FUNCTION_DIVISION_32_16_DIVIDENT_OK
;-------------------------------------------------------------------------------
	dec temp ; -1	
	; invertieren (BETRAG bilden)	
	com temp1
	com temp2
	com temp3
	com temp4
	subi temp1, BYTE1(-1)	; +1	
	sbci temp2, BYTE2(-1)
	sbci temp3, BYTE3(-1)
	sbci temp4, BYTE4(-1)
FUNCTION_DIVISION_32_16_DIVIDENT_OK:
;-------------------------------------------------------------------------------
	SBRS temp,0 			; SPRUNG bei BIT-0 gesetzt
	rjmp FUNCTION_DIVISION_32_16	; DIVISION	
;-------------------------------------------------------------------------------
FUNCTION_DIVISION_32_16_DIVIDENT_NEGATIV:
	rcall FUNCTION_DIVISION_32_16	; DIVISION	
	; invertieren (BETRAG bilden)	
	com temp1
	com temp2
	com temp3
	com temp4
	subi temp1, BYTE1(-1)	; +1	
	sbci temp2, BYTE2(-1)
	sbci temp3, BYTE3(-1)
	sbci temp4, BYTE4(-1)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
FUNCTION_DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	push R0
	push R1
	push temp
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
	pop temp
	pop R1
	pop R0	
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_DIVISION32_2_HOCH_TEMP:
	; Hilfsregister	
	push temp
	push temp5
	push temp6
	push temp7
	push temp8

	dec temp
	ldi temp5,1
	clr temp6
	clr temp7
	clr temp8
;-------------------------------------------------------------------------------
; halben Devisor dazu addieren													
FUNKTION_DIVISION32_2_HOCH_TEMP_w:
	LSL temp5
	ROL temp6
	ROL temp7
	ROL temp8
	dec temp
	brne FUNKTION_DIVISION32_2_HOCH_TEMP_w
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp
;-------------------------------------------------------------------------------
FUNKTION_DIVISION32_2_HOCH_TEMP_S:
	LSR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp
	brne FUNKTION_DIVISION32_2_HOCH_TEMP_S
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_BETRAG16_TEMP1_TEMP2:
	tst temp2
	brmi FUNCTION_BETRAG16_TEMP1_TEMP2_RUN
	ret
FUNCTION_BETRAG16_TEMP1_TEMP2_RUN:
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT:	TEMP1 / TEMP2 / TEMP3 / TEMP4 	1.Faktor							
;			TEMP5 							2.Faktor							
; 																				
; 	OUTPUT: 	TEMP1...4	Produkt												
FUNKTION_MULTIPLIKATION_32_8:
	tst temp5
	brne FUNKTION_MULTIPLIKATION_32_8_RUN
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret
;-------------------------------------------------------------------------------
FUNKTION_MULTIPLIKATION_32_8_RUN:
	mov temp9,temp5	; SCHLEIFE	
	mov temp5,temp1	
	mov temp6,temp2	
	mov temp7,temp3	
	mov temp8,temp4	
	clr temp1
	clr temp2
	clr temp3
	clr temp4
FUNKTION_MULTIPLIKATION_32_8_s:
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	brcs FUNKTION_MULTIPLIKATION_32_8_OVERLOW	; OWERLOW
	dec temp9
	brne FUNKTION_MULTIPLIKATION_32_8_s
	ret	
;-------------------------------------------------------------------------------
FUNKTION_MULTIPLIKATION_32_8_OVERLOW:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ldi temp,(88)
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT:
	tst temp4
	brmi FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT_MINUS
	rjmp FUNKTION_DIVISION32_2_HOCH_TEMP
FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT_MINUS:
	; mal (-1)					
	rcall FUNCTION_INVERTIEREN32
	rcall FUNKTION_DIVISION32_2_HOCH_TEMP
	; mal (-1)					
	rjmp FUNCTION_INVERTIEREN32
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Umwandlung einer 16-BIT-ZAHL in eine 32-BIT-ZAHL								
FUNCTION_16_32_SIGNIERT:
	tst temp2
	brmi FUNCTION_16_32_SIGNIERT_NEGATIV
FUNCTION_16_32_SIGNIERT_POSITIV:
	clr temp3
	clr temp4
	ret
FUNCTION_16_32_SIGNIERT_NEGATIV:
	ser temp3
	ser temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_INVERTIEREN32:
	com temp1
	com temp2
	com temp3
	com temp4
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

