; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_X1)														
;			(adr_GRAFIC_X1)														
;			(adr_GRAFIC_Y2)														
;			(adr_GRAFIC_Y2)														
;																				
;																				
; Zeichnet eine LINIE an den KOORDINATEN (X1,Y1) (X2,Y2)						
;																				
GRAFIC_LINIE:
;-------------------------------------------------------------------------------
	; SICHERUNGSKOPIE							
	push temp1
	push temp2
	push temp3
	push temp4
	push temp5
	push temp6
	push temp7
	push temp8
	push temp9
	push XL
	push XH
	push YL
	push YH
;-------------------------------------------------------------------------------
	; KOORDINATEN_LADEN							
	LDS temp1,(adr_GRAFIC_X1)			; X1
	LDS temp2,(adr_GRAFIC_Y1)			; Y1
	LDS temp3,(adr_GRAFIC_X2)			; X2
	LDS temp4,(adr_GRAFIC_Y2)			; Y2
	WDR
;-------------------------------------------------------------------------------
	; ANFANGSPUNKT								
	; call GRAFIC_FARBE_GRUEN		; TEST-PUNKT	
	mov XL,temp1
	clr XH
	mov YL,temp2
	clr YH	
	rcall GRAFIC_PUNKT_X_Y			; PUNKT		
	; ENDPUNKT								
	; call GRAFIC_FARBE_ROT			; TEST-PUNKT	
	mov XL,temp3
	clr XH
	mov YL,temp4
	clr YH	
	rcall GRAFIC_PUNKT_X_Y			; PUNKT		
;-------------------------------------------------------------------------------
;	ANFANG und ENDE gleich X=Y ?												
	cp temp1,temp3	; X1 X2	
	brne GRAFIC_LINIE_NO_GLEICH
	cp temp2,temp4	; Y1 Y2	
	brne GRAFIC_LINIE_NO_GLEICH
	rjmp GRAFIC_LINIE_FERTIG
GRAFIC_LINIE_NO_GLEICH:
; ##############################################################################
; ##############################################################################
; KOORDINATENTAUSCH	(X2 muss grer sein als X1)								
	mov R0,temp3	; X2	
	sub R0,temp1	; X2-X1	
	brcc GRAFIC_LINIE_NO_KOORDINATENTAUSCH
;-------------------------------------------------------------------------------
	; X1/X2 und Y1/Y2 tauschen
	mov R0,temp1
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4
	mov temp1,R2
	mov temp2,R3
	mov temp3,R0
	mov temp4,R1
GRAFIC_LINIE_NO_KOORDINATENTAUSCH:
; ##############################################################################
; ##############################################################################
; Horizontale linie, Y1=Y2 ?													
	cp temp2,temp4	; Y1 Y2	
	brne GRAFIC_LINIE_NO_HORIZONTAL
;-------------------------------------------------------------------------------
	mov XL,temp1	; X1	
	mov YL,temp2	; Y1	
	inc XL
GRAFIC_LINIE_HORIZONTAL_s:
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	inc XL
	cp XL,temp3
	brne GRAFIC_LINIE_HORIZONTAL_s
	rjmp GRAFIC_LINIE_FERTIG
GRAFIC_LINIE_NO_HORIZONTAL:
; ##############################################################################
; ##############################################################################
; Vertikale LINIE X1=X2															
	cp temp1,temp3	; X1 X2	
	brne GRAFIC_LINIE_NO_VERTIKAL
	; positiv / negativ		
	mov R0,temp4
	sub R0,temp2
	brcs GRAFIC_LINIE_VERTIKAL_NEGATIV
;-------------------------------------------------------------------------------
GRAFIC_LINIE_VERTIKAL_POSITIV:
	mov XL,temp1	; X1	
	mov YL,temp2	; Y1	
	inc YL
GRAFIC_LINIE_VERTIKAL_POSITIV_s:
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	inc YL
	cp YL,temp4
	brne GRAFIC_LINIE_VERTIKAL_POSITIV_s
	rjmp GRAFIC_LINIE_FERTIG
;-------------------------------------------------------------------------------
GRAFIC_LINIE_VERTIKAL_NEGATIV:
	mov XL,temp3	; X2	
	mov YL,temp4	; Y2	
	inc YL
GRAFIC_LINIE_VERTIKAL_NEGATIV_s:
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	inc YL
	cp YL,temp2
	brne GRAFIC_LINIE_VERTIKAL_NEGATIV_s
	rjmp GRAFIC_LINIE_FERTIG
GRAFIC_LINIE_NO_VERTIKAL:
; ##############################################################################
; ##############################################################################
; 45 GRD LINIE DELTA(X)=DELTA(Y)												
	; DELTA-X berechnen		
	mov R0,temp3	; X2	
	sub R0,temp1	; X2-X1	
	; DELTA-Y berechnen		
	mov R1,temp4	; Y2		
	sub R1,temp2	; Y2-Y1	
	brcc GRAFIC_LINIE_45GRD_dY_OK
	com R1
	inc R1
GRAFIC_LINIE_45GRD_dY_OK:
	cp R0,R1
	brne GRAFIC_LINIE_NO_45GRD
;-------------------------------------------------------------------------------
	; DELTA-Y positiv/negativ		
	mov R1,temp4	; Y2		
	sub R1,temp2	; Y2-Y1	
	brcs GRAFIC_LINIE_45GRD_NEGATIV
;-------------------------------------------------------------------------------
GRAFIC_LINIE_45GRD_POSITIV:
	mov XL,temp1	; X1	
	mov YL,temp2	; Y1	
	inc XL			; X+1	
	inc YL			; Y-1	
GRAFIC_LINIE_45GRD_POSITIV_s:
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	inc XL
	inc YL
	cp XL,temp3
	brne GRAFIC_LINIE_45GRD_POSITIV_s
	rjmp GRAFIC_LINIE_FERTIG
;-------------------------------------------------------------------------------
GRAFIC_LINIE_45GRD_NEGATIV:
	mov XL,temp1	; X1	
	mov YL,temp2	; Y1	
	inc XL			; X+1	
	dec YL			; Y-1	
GRAFIC_LINIE_45GRD_NEGATIV_s:
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	inc XL
	dec YL
	cp XL,temp3
	brne GRAFIC_LINIE_45GRD_NEGATIV_s
	rjmp GRAFIC_LINIE_FERTIG
GRAFIC_LINIE_NO_45GRD:
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Linie entlang der X-Achse oder entlang der Y-Achse zeichnen ?					
	; DELTA-X berechnen		
	mov R0,temp3	; X2	
	sub R0,temp1	; X2-X1	
	brcc GRAFIC_LINIE_SCHRAG_XACHSE_dX_OK
	com R0
	inc R0
GRAFIC_LINIE_SCHRAG_XACHSE_dX_OK:
	; DELTA-Y berechnen		
	mov R1,temp4	; Y2		
	sub R1,temp2	; Y2-Y1	
	brcc GRAFIC_LINIE_SCHRAG_XACHSE_dY_OK
	com R1
	inc R1
GRAFIC_LINIE_SCHRAG_XACHSE_dY_OK:
	; ANSTIEG auswerten		
	sub R0,R1
	brmi GRAFIC_LINIE_SCHRAG_YACHSE
; ##############################################################################
; ##############################################################################
GRAFIC_LINIE_SCHRAG_XACHSE:
	; DELTA-Y berechnen		
	mov R1,temp4	; Y2		
	sub R1,temp2	; Y2-Y1	
	brcs GRAFIC_LINIE_SCHRAG_XACHSE_NEGATIV
;-------------------------------------------------------------------------------
GRAFIC_LINIE_SCHRAG_XACHSE_POSITIV:
	; DELTA-X berechnen		
	mov temp8,temp3	; X2	
	sub temp8,temp1	; X2-X1	
	; DELTA-Y berechnen		
	mov temp9,temp4	; Y2	
	sub temp9,temp2	; Y2-Y1	(dY)
	; INITIALISIERUNG		
	mov XL,temp1	; X1	
	MOV R5,temp2	; Y1	
	clr R2			; STEP	
;-----------------------
GRAFIC_LINIE_SCHRAG_XACHSE_POSITIV_s:
	inc R2			; STEP+1	
	inc XL			; X+1		
	; dY x STEP : dX			
	mul temp9,R2	; dY x STEP	
	mov temp1,R0	; durch dX	
	mov temp2,R1
	mov temp3,temp8
	rcall GL_DIVISION_16_8	; INP: temp1+2+3 OUT: temp6+7	
	mov YL,R5		; Y1 addieren
	add YL,temp6
	rcall GRAFIC_PUNKT_X_Y	; PUNKT			
	cp temp8,R2		; STEP	
	brne GRAFIC_LINIE_SCHRAG_XACHSE_POSITIV_s
	rjmp GRAFIC_LINIE_FERTIG
;-------------------------------------------------------------------------------
GRAFIC_LINIE_SCHRAG_XACHSE_NEGATIV:
	; DELTA-X berechnen		
	mov temp8,temp3	; X2	
	sub temp8,temp1	; X2-X1	
	; DELTA-Y berechnen		
	mov temp9,temp4	; Y2	
	sub temp9,temp2	; Y2-Y1	(dY)
	; BETRAG bilden			
	com temp9
	inc temp9
	; INITIALISIERUNG		
	mov XL,temp1	; X1	
	MOV R5,temp2	; Y1	
	clr R2			; STEP	
;-----------------------
GRAFIC_LINIE_SCHRAG_XACHSE_NEGATIV_s:
	inc R2			; STEP+1	
	inc XL			; X+1		
	; dY x STEP : dX			
	mul temp9,R2	; dY x STEP	
	mov temp1,R0	; durch dX	
	mov temp2,R1
	mov temp3,temp8
	rcall GL_DIVISION_16_8	; INP: temp1+2+3 OUT: temp6+7	
	mov YL,R5		; Y1 subtrahieren			
	sub YL,temp6
	rcall GRAFIC_PUNKT_X_Y	; PUNKT			
	cp temp8,R2		; STEP	
	brne GRAFIC_LINIE_SCHRAG_XACHSE_NEGATIV_s
	rjmp GRAFIC_LINIE_FERTIG
; ##############################################################################
; ##############################################################################
GRAFIC_LINIE_SCHRAG_YACHSE:
	; DELTA-Y berechnen		
	mov R1,temp4	; Y2		
	sub R1,temp2	; Y2-Y1	
	brcs GRAFIC_LINIE_SCHRAG_YACHSE_NEGATIV
;-------------------------------------------------------------------------------
GRAFIC_LINIE_SCHRAG_YACHSE_POSITIV:
	; DELTA-X berechnen		
	mov temp8,temp3	; X2	
	sub temp8,temp1	; X2-X1	
	; DELTA-Y berechnen		
	mov temp9,temp4	; Y2	
	sub temp9,temp2	; Y2-Y1	(dY)
	; INITIALISIERUNG		
	MOV R5,temp1	; X1	
	mov YL,temp2	; Y1	
	clr R2			; STEP	
;-----------------------
GRAFIC_LINIE_SCHRAG_YACHSE_POSITIV_s:
	inc R2			; STEP+1	
	inc YL			; Y+1		
	; dX x STEP : dY			
	mul temp8,R2	; dX x STEP	
	mov temp1,R0	; durch dY	
	mov temp2,R1
	mov temp3,temp9
	rcall GL_DIVISION_16_8	; INP: temp1+2+3 OUT: temp6+7	
	mov XL,R5		; X1 addieren
	add XL,temp6
	rcall GRAFIC_PUNKT_X_Y	; PUNKT			
	cp temp9,R2		; STEP	
	brne GRAFIC_LINIE_SCHRAG_YACHSE_POSITIV_s
	rjmp GRAFIC_LINIE_FERTIG
;-------------------------------------------------------------------------------
GRAFIC_LINIE_SCHRAG_YACHSE_NEGATIV:
	; DELTA-X berechnen		
	mov temp8,temp3	; X2	
	sub temp8,temp1	; X2-X1	
	; DELTA-Y berechnen		
	mov temp9,temp4	; Y2	
	sub temp9,temp2	; Y2-Y1	(dY)
	; BETRAG bilden			
	com temp9
	inc temp9
	; INITIALISIERUNG		
	MOV R5,temp3	; X2	
	mov YL,temp4	; Y2	
	clr R2			; STEP	
;-----------------------
GRAFIC_LINIE_SCHRAG_YACHSE_NEGATIV_s:
	inc R2			; STEP+1	
	inc YL			; Y+1		
	; dX x STEP : dY			
	mul temp8,R2	; dX x STEP	
	mov temp1,R0	; durch dY	
	mov temp2,R1
	mov temp3,temp9
	rcall GL_DIVISION_16_8	; INP: temp1+2+3 OUT: temp6+7	
	mov XL,R5		; X2 subtahieren	
	sub XL,temp6
	rcall GRAFIC_PUNKT_X_Y	; PUNKT			
	cp temp9,R2		; STEP	
	brne GRAFIC_LINIE_SCHRAG_YACHSE_NEGATIV_s
	rjmp GRAFIC_LINIE_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
GRAFIC_LINIE_FERTIG:
	pop YH
	pop YL
	pop XH
	pop XL
	pop temp9
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp4
	pop temp3
	pop temp2
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 07/2015																
;																				
;	Division 16 bit-Zahl durch 8 bit Zahl										
;																				
;	input 	temp1 (LOW)															
;	input 	temp2 (HIGH)														
;																				
;	input	temp3	Divisor		 												
;																				
; 	OUT:	temp6 (LOW)															
; 	OUT:	temp7 (HIGH)														
;																				
; 	REGISTER: temp+temp6 + temp7 (wird nicht gesichert)							
;																				
GL_DIVISION_16_8:
;-----------------------------------------------------------------------
	; NULL-CHECK				
	tst temp3
	brne GL_16_8_RUN
	clr temp1
	clr temp2
	ret
;-----------------------------------------------------------------------
GL_16_8_RUN:
	; Aufrunden halben Divisor dazuaddieren	
	mov temp,temp3
	LSR temp	
	add temp1,temp
	adc temp2,NULL
;-----------------------------------------------------------------------
	clr temp 			; Leere Hilfsregister
	ldi temp6,1			; Zhler Bit 1 auf 1 setzen)
	clr temp7
;-----------------------------------------------------------------------
GL_div8a:
	clc 				; Carry-Bit leeren
	rol temp1 		
	rol temp2 		
	rol temp 			;  in das Hilfsregister rotieren		
	brcs GL_div8b 			; Eine 1 ist herausgerollt, ziehe ab	
	cp temp,temp3 		; Divisionsergebnis 1 oder 0?			
	brcs GL_div8c 			; berspringe Subtraktion, wenn kleiner	
GL_div8b:
	sub temp,temp3	 	; Subtrahiere Divisor					
	sec 				; Setze carry-bit, Ergebnis ist eine 1	
	rjmp GL_div8d 			
GL_div8c:
	clc 				; Lsche carry-bit, Ergebnis ist eine 0
GL_div8d:
	rol temp6 			; Rotiere carry-bit in das Ergebnis		
	rol temp7
	brcc GL_div8a 			; solange Nullen aus dem Ergebnis rotieren: weitermachen
ret
;########################################################################
;########################################################################
;########################################################################
