; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzt oder lscht einen Punkt an den Koordinaten X,Y							
;																				
; INP:																			
;		XL+XH		(Bereich: 0...179)											
;		YL+YH		(Bereich: 0...159)											
; 																				
;		(links unten: X=0 	Y=0)												
;		(rechts oben: X=179 Y=159)												
;																							
; REGISTER:																					
; 	temp,R0,R1 Hilfsregister (werden aber nicht gesichert !!! wegen Zeitersparnis)			
;   Z (wird gesichert)																		
;   X,Y drfen in dieser Routine nicht gendert werden !									
;																							
GRAFIC_PUNKT_X_Y:
	; PUNKTGROESSE		
	LDS temp,(adr_GRAFIC_PUNKT_GROESSE)
	tst temp
	breq GRAFIC_PUNKT_X_Y_START
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_TEMP
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_START:
	; BERLAUF ?			
	tst XH
	breq GRAFIC_PUNKT_X_Y_w1
	ret
GRAFIC_PUNKT_X_Y_w1:
	tst YH
	breq GRAFIC_PUNKT_X_Y_w2
	ret
GRAFIC_PUNKT_X_Y_w2:
	cpi XL,179+1
	brlo GRAFIC_PUNKT_X_Y_w3
	ret
GRAFIC_PUNKT_X_Y_w3:
	cpi YL,159+1
	brlo GRAFIC_PUNKT_X_Y_RUN
	ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_RUN:
	; Sicherungskopie		
	PUSH ZL
	PUSH ZH
	; auf links unten		
	ldi ZL,LOW (adr_VGA_BILDBEREICH+159*180/2)
	ldi ZH,HIGH(adr_VGA_BILDBEREICH+159*180/2)
	; Y-Koordinate			
	ldi temp,90
	mul temp,YL
	sub ZL,R0
	sbc ZH,R1
	; X-KOORDINATE			
	mov R0,XL
	LSR R0
	add ZL,R0
	adc ZH,NULL
	; NIBBLES ?				
	SBRC XL,0
	rjmp GRAFIC_PUNKT_X_Y_2
;-------------------------------------------------------------------------------
	; untere NIBBLES									
	LD temp,Z					; laden					
	andi temp,0b11110000		; unteres NIBBLES NULL	
	LDS R0,(adr_GRAFIC_FARBE)	; Farbe laden			
	or temp,R0					; Farbe verknpfen		
	ST Z,temp					; speichern				
	; TURBO fr diese Zeile deaktivieren				
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH160+159)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH160+159)
	sub ZL,YL
	sbc ZH,YH
	ST Z,NULL
	; Sicherungskopie (wiederherstellen)	
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_2:
	; oberes NIBBLES									
	LD temp,Z					; laden					
	andi temp,0b00001111		; obere NIBBLES NULL	
	LDS R0,(adr_GRAFIC_FARBE)	; Farbe laden			
	SWAP R0						; NIBBLES tausch		
	or temp,R0					; Farbe verknpfen		
	ST Z,temp					; speichern				
	; TURBO fr diese Zeile deaktivieren				
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH160+159)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH160+159)
	sub ZL,YL
	sbc ZH,YH
	ST Z,NULL
	; Sicherungskopie (wiederherstellen)	
	pop ZH
	pop ZL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
GRAFIC_PUNKT_X_Y_GROESSE_TEMP:
	cpi temp,1
	brne GRAFIC_PUNKT_X_Y_GROESSE_2w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_1
GRAFIC_PUNKT_X_Y_GROESSE_2w:
	cpi temp,2
	brne GRAFIC_PUNKT_X_Y_GROESSE_3w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_2
GRAFIC_PUNKT_X_Y_GROESSE_3w:
	cpi temp,3
	brne GRAFIC_PUNKT_X_Y_GROESSE_4w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_3
GRAFIC_PUNKT_X_Y_GROESSE_4w:
	cpi temp,4
	brne GRAFIC_PUNKT_X_Y_GROESSE_5w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_4
GRAFIC_PUNKT_X_Y_GROESSE_5w:
	cpi temp,5
	brne GRAFIC_PUNKT_X_Y_GROESSE_6w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_5
GRAFIC_PUNKT_X_Y_GROESSE_6w:
	cpi temp,6
	brne GRAFIC_PUNKT_X_Y_GROESSE_7w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_6
GRAFIC_PUNKT_X_Y_GROESSE_7w:
	cpi temp,7
	brne GRAFIC_PUNKT_X_Y_GROESSE_8w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_7
GRAFIC_PUNKT_X_Y_GROESSE_8w:
	cpi temp,8
	brne GRAFIC_PUNKT_X_Y_GROESSE_9
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_8
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_9:
	sbiw XL,8	; X-8
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_X_Y_START	;1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;3
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;5
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;6
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;7
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;8
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;9
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;11
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;13
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;14
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;15
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;16
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;17
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;18
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;19
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;20
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;21
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;22
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;23
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;24
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;25
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;26
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;27
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;28
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;29
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;30
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;31
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;32
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;33
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;34
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;35
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;36
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;37
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;38
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;39
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;40
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;41
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;42
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;43
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;44
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;45
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;46
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;47
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;48
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;49
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;50
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;51
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;52
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;53
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;54
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;55
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;56
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;57
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;58
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;59
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;60
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;61
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;62
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;63
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;64
	adiw XL,7	; X+7	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_8:
	sbiw XL,7	; X-7
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6A
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14A
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22A
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30A
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 32
	adiw XL,6	; X+6	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_7:
	sbiw XL,6	; X-6
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 32
	adiw XL,5	; X+5	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_6:
	sbiw XL,5	; X-5
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,4	; X+4	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_5:
	sbiw XL,4	; X-4
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,3	; X+3	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_4:
	sbiw XL,3	; X-3
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,2	; X+2	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_3:
	sbiw XL,2	; X-2
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_2:
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,2	; Y+2
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,2	; X+2
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_1:
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
;----------------------------------------------------------------------------------------------------
	; MITTELPUNKT					
	rjmp GRAFIC_PUNKT_X_Y_START	; PUNKT setzen	
; ##############################################################################
; ##############################################################################
; ##############################################################################
