; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;		(adr_GRAFIC_X1)															
;		(adr_GRAFIC_Y1)															
;		(adr_GRAFIC_WINKEL_L)													
;		(adr_GRAFIC_WINKEL_H)													
;		(adr_GRAFIC_LAENGE)														
;																				
; OUT: 	(adr_GRAFIC_X1)															
;		(adr_GRAFIC_Y1)															
;  		(adr_GRAFIC_X2)															
;		(adr_GRAFIC_Y2)															
;																				
; Zeichnet einen Zeiger vom Punkt X,Y im Winkel und Lnge						
;																				
GRAFIC_ZEIGER:
	; KOORDINATEN errechnen					
	rcall GRAFIC_ZEIGER_KOORDINATEN
	; ZEIGER								
	rjmp GRAFIC_LINIE
; ##############################################################################
; ##############################################################################
; ##############################################################################
GRAFIC_ZEIGER_KOORDINATEN:
	push ZL
	PUSH ZH
	; (X)SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	; BERECHNUNG							
	rcall GRAFIC_ZEIGER_BERECHNUNG_Z_R0_TEMP1	
	; entzerren (X=X*WERT:256)				
	LDS temp,(adr_ENTZERRUNG_KREIS)
	mul temp,temp1
	ldi temp,(256/2)	; aufrunden (halben Devisor dazu addieren)
	add R0,temp
	adc R1,NULL					; :256 (Ergebnis in R1)
	; positiv / negativ						
	SBRC R3,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_KOORDINATEN_X_NEGATIV
	; addieren								
	LDS temp,(adr_GRAFIC_X1)
	add temp,R1
	STS(adr_GRAFIC_X2),temp
	rjmp GRAFIC_ZEIGER_KOORDINATEN_X_FERTIG
GRAFIC_ZEIGER_KOORDINATEN_X_NEGATIV:
	; subtrahieren							
	LDS temp,(adr_GRAFIC_X1)
	sub temp,R1
	STS(adr_GRAFIC_X2),temp
GRAFIC_ZEIGER_KOORDINATEN_X_FERTIG:
;---------------------------------------------------------------
	; (Y) COSINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	; BERECHNUNG							
	rcall GRAFIC_ZEIGER_BERECHNUNG_Z_R0_TEMP1	
	; positiv / negativ						
	SBRC R3,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_KOORDINATEN_Y_NEGATIV
	; addieren								
	LDS temp,(adr_GRAFIC_Y1)
	add temp,temp1
	STS(adr_GRAFIC_Y2),temp
	rjmp GRAFIC_ZEIGER_KOORDINATEN_Y_FERTIG
GRAFIC_ZEIGER_KOORDINATEN_Y_NEGATIV:
	; subtrahieren							
	LDS temp,(adr_GRAFIC_Y1)
	sub temp,temp1
	STS(adr_GRAFIC_Y2),temp
;---------------------------------------------------------------
GRAFIC_ZEIGER_KOORDINATEN_Y_FERTIG:
	pop ZH
	pop ZL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 07/2015																
GRAFIC_ZEIGER_BERECHNUNG_Z_R0_TEMP1:
	; WINKEL-CHECK							
	LDS temp1,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp2,(adr_GRAFIC_WINKEL_H)
	rcall GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2
	LSL temp1		; WINKEL x2				
	ROL temp2	
	add ZL,temp1	; WINKEL addieren		
	adc ZH,temp2
	; aus Tabelle laden						
	LPM temp1, Z+  	; aus Tabelle laden(LOW)	
	LPM temp2, Z+  	; aus Tabelle laden(HIGH)	
	mov R3,temp2	; (VORZEICHEN)			
	SBRS R3,7	; Sprung bei negativ	
	rjmp GRAFIC_ZEIGER_BERECHNUNG_w
	; invertieren							
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
GRAFIC_ZEIGER_BERECHNUNG_w:
	; WERT mal LNGE						
	LDS temp2,(adr_GRAFIC_ZEIGER_LAENGE)
	MUL temp1,temp2
	mov temp1,R0
	mov temp2,R1
	; RUNDEN (halben Divisor dazu addieren)	
	subi temp1,LOW (-64)	; +64
	sbci temp2,HIGH(-64)
	; durch 128								
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	LSR temp2	; :8
	ROR temp1
	LSR temp2	; :16
	ROR temp1
	LSR temp2	; :32
	ROR temp1
	LSR temp2	; :64
	ROR temp1
	LSR temp2	; :128
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 07/2015																
GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2:
	cpi temp2,HIGH(360)
	breq GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2_L
	brsh GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2_ERROR
	ret
GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2_L:
	cpi temp1,LOW (360+1)
	brsh GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2_ERROR
	ret
GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2_ERROR:
	subi temp1,LOW (360)	; 360 GRD subtrahieren	
	SBCI temp2,HIGH(360)	
	rjmp GRAFIC_ZEIGER_360_GRD_CHECK_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################








