; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_INITIALISIERUNG:
	STS(adr_HYT939_RH_OLD),NULL
	rjmp HYGROMETER_ACTION
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER:
	LDS temp,(adr_ss)
	andi temp,0b00000111
	tst temp
	breq HYGROMETER_ACTION
	ret
;-------------------------------------------------------------------------------
HYGROMETER_ACTION:
	rcall HYGROMETER_FARBE		; FARBE
	call GRAFIC_PUNKTGROESSE_0
	rcall HYGROMETER_ANZEIGE_MARKIERUNG

	call HYT939_MESSUNG

	call FARBE_SCHWARZ	; FARBE
	rcall HYGROMETER_ANZEIGE_MARKIERUNG

	call HYGROMETER_FARBE		; FARBE
	call HYGROMETER_ANZEIGE_WERT
	; VERGLEICH					
	LDS R0 ,(adr_HYT939_RH)
	LDS R1,(adr_HYT939_RH_OLD)
	cp R0,R1
	brne HYGROMETER_RUN
	ret
;-------------------------------------------------------------------------------
HYGROMETER_RUN:
	call HYGROMETER_FARBE		; FARBE
	rcall HYGROMETER_SKALA
	
	ldi temp,70
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp

	call GRAFIC_PUNKTGROESSE_2
	call FARBE_SCHWARZ	; FARBE
	LDS temp1,(adr_HYT939_RH_OLD)
	call HYGROMETER_ZEIGER_TEMP1

	call HYGROMETER_FARBE		; FARBE
	LDS temp1,(adr_HYT939_RH)
	STS(adr_HYT939_RH_OLD),temp1
	call HYGROMETER_ZEIGER_TEMP1

	; Mittelpunkt	
	call GRAFIC_PUNKTGROESSE_6
	ldi XL,LOW (180/2)
	ldi XH,HIGH(180/2)
	ldi YL,LOW (160/2)
	ldi YH,HIGH(160/2)
	call GRAFIC_PUNKT_X_Y

	call WAIT_500ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_ZEIGER_TEMP1:
	ldi temp,173
	mul temp1,temp
	LSL R0
	ROL R1
	LSL R0
	ROL R1
	ldi temp,128
	add R0,temp
	adc R1,NULL

	ldi ZL, LOW(225)
	ldi ZH,HIGH(225)
	add ZL,R1
	adc ZH,NULL
	STS(adr_GRAFIC_WINKEL_L),ZL
	STS(adr_GRAFIC_WINKEL_H),ZH
	jmp GRAFIC_ZEIGER
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_SKALA:
	call GRAFIC_PUNKTGROESSE_2
	ldi XL,LOW (180/2)
	ldi XH,HIGH(180/2)
	ldi YL,LOW (160/2)
	ldi YH,HIGH(160/2)
	STS(adr_GRAFIC_X1),XL
	STS(adr_GRAFIC_Y1),YL
	call GRAFIC_PUNKT_X_Y			; Mittelpunkt	

	ldi temp,75
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp

	ldi ZL, LOW(225)
	ldi ZH,HIGH(225)
	ldi temp9,11
HYGROMETER_SKALA_s:
	STS(adr_GRAFIC_WINKEL_L),ZL
	STS(adr_GRAFIC_WINKEL_H),ZH
	call GRAFIC_PUNKT_AUF_KREIS
	adiw ZL,27
	dec temp9
	brne HYGROMETER_SKALA_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_ANZEIGE_WERT:
	call ASCII_CURSOR_ZEILE_11
	call ASCII_LEER10
	call HYT939_ANZEIGE_FEUCHTIGKEIT_KURZ
	call ASCII_CURSOR_ZEILE_NEXT
	call ASCII_LEER10
	call HYT939_ANZEIGE_TEMPERATUR_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_ANZEIGE_MARKIERUNG:
	clr XL
	clr XH
	clr YL
	clr YH
	jmp GRAFIC_PUNKT_X_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYGROMETER_FARBE:
	call FARBE_TAG_NACHT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
