; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_INITIALISIERUNG:
	; Mittelpunkt X1/Y1			
	ldi temp1,180/2
	ldi temp2,160/2
	STS(adr_GRAFIC_X1),temp1
	STS(adr_GRAFIC_Y1),temp2
	call ANALOGUHR_FARBE		; FARBE	
	rjmp ANALOGUHR_ZIFFERNBLATT
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR:
;-------------------------------------------------------------------------------
; DCF-TRGER anzeigen (kleiner PUNKT im ANTENNEN-SYMBOL)						
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne ANALOGUHR_NO_PUNKT
	LDS temp1,(adr_DCF_TRAEGER)
	SBRS temp1,0
	call ANALOGUHR_FARBE		; FARBE	
	SBRC temp1,0
	call FARBE_SCHWARZ			; FARBE	
	ldi XL,LOW (4)
	ldi XH,HIGH(4)
	ldi YL,LOW (157)
	ldi YH,HIGH(157)
	call GRAFIC_PUNKT_X_Y
ANALOGUHR_NO_PUNKT:
;-------------------------------------------------------------------------------
; bei jeder neuen SEKUNDE zeichnen												
	LDS temp1,(adr_ss)
	LDS temp2,(adr_ANALOGUHR_OLD_ss)
	cp temp1,temp2
	brne ANALOGUHR_RUN
	ret
;-------------------------------------------------------------------------------
ANALOGUHR_RUN:
	STS(adr_ANALOGUHR_OLD_ss),temp1
	; ANTENNENSYMBOL				
	call ASCII_CURSOR_ZEILE_0
	LDS temp1,(adr_DCF_HEUTE_EMPFANGEN)
	SBRS temp1,0	
	call FARBE_ROT
	SBRC temp1,0	
	call FARBE_SCHWARZ
	ldi temp,19		; Antenne	
	call ASCII_TEMP
;-------------------------------------------------------------------------------
	; Mittelpunkt X1/Y1			
	ldi temp1,180/2
	ldi temp2,160/2
	STS(adr_GRAFIC_X1),temp1
	STS(adr_GRAFIC_Y1),temp2
;-------------------------------------------------------------------------------
	; ZEIGER-SEKUNDEN-OLD		
	STS(adr_GRAFIC_FARBE),NULL	; schwarz	
	LDS temp1,(adr_ANALOGUHR_ZEIGER_OLD_ss)
	rcall ANALOGUHR_SEKUNDEN_ZEIGER_TEMP1
	LDS temp1,(adr_ss)
	STS(adr_ANALOGUHR_ZEIGER_OLD_ss),temp1
;-------------------------------------------------------------------------------
; ZEIGER alle lschen															
	LDS temp1,(adr_mm)
	LDS temp2,(adr_ANALOGUHR_ZEIGER_OLD_mm)
	cp temp1,temp2
	breq ANALOGUHR_CLEAR_FERTIG
;-------------------------------------------------------------------------------
	; STUNDEN-SEIGER-OLD	
	LDS temp1,(adr_ANALOGUHR_ZEIGER_OLD_hh)
	LDS temp2,(adr_ANALOGUHR_ZEIGER_OLD_hhmm)
	rcall ANALOGUHR_STUNDEN_ZEIGER_TEMP1_TEMP2
	LDS temp1,(adr_hh)
	LDS temp2,(adr_mm)
	STS(adr_ANALOGUHR_ZEIGER_OLD_hh),temp1
	STS(adr_ANALOGUHR_ZEIGER_OLD_hhmm),temp2
	; MINUTEN-ZEIGER-OLD	
	LDS temp1,(adr_ANALOGUHR_ZEIGER_OLD_mm)
	rcall ANALOGUHR_MINUTEN_ZEIGER_TEMP1
	LDS temp1,(adr_mm)
	STS(adr_ANALOGUHR_ZEIGER_OLD_mm),temp1
ANALOGUHR_CLEAR_FERTIG:
;-------------------------------------------------------------------------------
	; MITTELPUNKT			
	call ANALOGUHR_FARBE	; FARBE	
	ldi temp,5
	STS(adr_GRAFIC_PUNKT_GROESSE),temp
	LDS XL,(adr_GRAFIC_X1)
	clr XH
	LDS YL,(adr_GRAFIC_Y1)
	clr XH
	call GRAFIC_PUNKT_X_Y
	; SEKUNDEN-ZEIGER		
	LDS temp1,(adr_ss)
	rcall ANALOGUHR_SEKUNDEN_ZEIGER_TEMP1
	; MINUTEN-ZEIGER		
	LDS temp1,(adr_mm)
	rcall ANALOGUHR_MINUTEN_ZEIGER_TEMP1
	; STUNDEN-ZEIGER		
	LDS temp1,(adr_hh)
	LDS temp2,(adr_mm)
	rcall ANALOGUHR_STUNDEN_ZEIGER_TEMP1_TEMP2
	; ZIFFERNBLATT				
	rcall ANALOGUHR_ZIFFERNBLATT
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL
;-------------------------------------------------------------------------------
	; SONNEN-AUFGANG-UNTERGANG	
	LDS temp,(adr_SONNE_ANZEIGE)
	tst temp
	breq ANALOGUHR_SONNE_FERTIG
	call ASCII_CURSOR_ZEILE_12	
	call FARBE_GELB
	call ANZEIGE_SONNENAUFGANG_KURZ
	call ASCII_LEER10
	call ASCII_LEER2
	call FARBE_ROT
	call ANZEIGE_SONNENUNTERGANG_KURZ
ANALOGUHR_SONNE_FERTIG:
;-------------------------------------------------------------------------------
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_SEKUNDEN_ZEIGER_TEMP1:
	; PUNKT-GRSSE				
	STS(adr_GRAFIC_PUNKT_GROESSE),EINS
	; BERECHNUNG				
	ldi temp,6
	mul temp,temp1
	STS(adr_GRAFIC_WINKEL_L),R0
	STS(adr_GRAFIC_WINKEL_H),R1
	; ZEIGER-LNGE				
	ldi temp,74
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp
	; ZEIGER-SEKUNDE			
	rcall GRAFIC_ZEIGER
;-------------------------------------------------------------------------------	
	; ZEIGER-LNGE				
	ldi temp,20
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp
	LDS temp1,(adr_GRAFIC_WINKEL_L)
	LDS temp2,(adr_GRAFIC_WINKEL_H)
	subi temp1, LOW (-180)
	sbci temp2, HIGH(-180)
	STS(adr_GRAFIC_WINKEL_L),temp1
	STS(adr_GRAFIC_WINKEL_H),temp2
	rjmp GRAFIC_ZEIGER
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_MINUTEN_ZEIGER_TEMP1:
	; PUNKT-GRSSE				
	ldi temp,3
	STS(adr_GRAFIC_PUNKT_GROESSE),temp
	; BERECHNUNG				
	ldi temp,6
	mul temp,temp1
	STS(adr_GRAFIC_WINKEL_L),R0
	STS(adr_GRAFIC_WINKEL_H),R1
	; ZEIGER-LNGE				
	ldi temp,65
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp
	; ZEIGER-SEKUNDE			
	rjmp GRAFIC_ZEIGER
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_STUNDEN_ZEIGER_TEMP1_TEMP2:
	; PUNKT-GRSSE				
	ldi temp,3
	STS(adr_GRAFIC_PUNKT_GROESSE),temp
	; 24-->12h					
	cpi temp1,12+1
	brlo ANALOGUHR_STUNDEN_ZEIGER_TEMP1_TEMP2_w
	sbci temp1,12
ANALOGUHR_STUNDEN_ZEIGER_TEMP1_TEMP2_w:
	; BERECHNUNG hh				
	ldi temp,30
	mul temp,temp1
	; BERECHNUNG mm				
	LSR temp2
	add R0,temp2
	adc R1,NULL	
	STS(adr_GRAFIC_WINKEL_L),R0
	STS(adr_GRAFIC_WINKEL_H),R1
	; ZEIGER-LNGE				
	ldi temp,45
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp
	; ZEIGER-SEKUNDE			
	rjmp GRAFIC_ZEIGER
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_ZIFFERNBLATT:
	ldi temp,78
	STS(adr_GRAFIC_ZEIGER_LAENGE),temp
;-------------------------------------------------------------------------------
	ldi temp,3
	STS(adr_GRAFIC_PUNKT_GROESSE),temp	
	clr ZL
	clr ZH
	ldi temp9,4
ANALOGUHR_ZIFFERNBLATT_s1:
	STS(adr_GRAFIC_WINKEL_L),ZL
	STS(adr_GRAFIC_WINKEL_H),ZH
	rcall GRAFIC_PUNKT_AUF_KREIS
	adiw ZL,30
	adiw ZL,30
	adiw ZL,30
	dec temp9 
	brne ANALOGUHR_ZIFFERNBLATT_s1
;-------------------------------------------------------------------------------
	ldi temp,2
	STS(adr_GRAFIC_PUNKT_GROESSE),temp	
	clr ZL
	clr ZH
	ldi temp9,12
ANALOGUHR_ZIFFERNBLATT_s2:
	STS(adr_GRAFIC_WINKEL_L),ZL
	STS(adr_GRAFIC_WINKEL_H),ZH
	rcall GRAFIC_PUNKT_AUF_KREIS
	adiw ZL,30
	dec temp9 
	brne ANALOGUHR_ZIFFERNBLATT_s2
;-------------------------------------------------------------------------------
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL
	clr ZL
	clr ZH
	ldi temp9,60
ANALOGUHR_ZIFFERNBLATT_s3:
	STS(adr_GRAFIC_WINKEL_L),ZL
	STS(adr_GRAFIC_WINKEL_H),ZH
	rcall GRAFIC_PUNKT_AUF_KREIS
	adiw ZL,6
	dec temp9 
	brne ANALOGUHR_ZIFFERNBLATT_s3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_DIGITAL_ZEIT:
	; ZEIT-ZIFFERN				
	call FARBE_GRUEN
	call ASCII_CURSOR_ZEILE_0
	LDS temp1,(adr_hh)
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_mm)
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ss)
	call ANZEIGE_2_STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANALOGUHR_FARBE:
	call FARBE_TAG_NACHT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




