; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_INITIALISIERUNG:
	; auf EINGANG						
	cbi (TASTE_A_DDR) ,(TASTE_A_PIN_NR) 
	cbi (TASTE_B_DDR) ,(TASTE_B_PIN_NR) 
	cbi (TASTE_C_DDR) ,(TASTE_C_PIN_NR) 
	cbi (TASTE_D_DDR) ,(TASTE_D_PIN_NR) 
	; PULL UP ein						
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR) 		
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR) 		
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR) 		
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR) 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_CHECK_TEMP1:
	rcall TASTEN_ABFRAGE
	mov temp1,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	clr temp
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn...	
	ori temp,0b00000001
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn...	
	ori temp,0b00000010
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)	; springe, wenn...	
	ori temp,0b00000100
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)	; springe, wenn...	
	ori temp,0b00001000
	STS(adr_TASTE),temp					; speichern			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
	STS(adr_TASTE),NULL
	call BEEP_KURZ
	call WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_MENUE:
	LDS temp,(adr_TASTE)			; TASTE						
	LDS temp1,(adr_TASTE_MENUE)		; MENUE						
	tst temp
	brne TASTEN_MENUE_RUN
	tst temp1
	brne TASTEN_MENUE_RUN
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_RUN:
	STS(adr_MODUS),NULL				; MODUS auf nix tun			
	STS(adr_MENUE),EINS				; MENUE=1					
;-------------------------------------------------------------------------------
TASTEN_MENUE_PLUS:
	cpi temp,(TASTE_MENUE_PLUS)		; vergleich TASTENWERT		
	brne TASTEN_MENUE_PLUS_FERTIG
	inc temp1						; MENUE+1					
	STS(adr_TASTE_MENUE),temp1
TASTEN_MENUE_PLUS_FERTIG:
;-------------------------------------------------------------------------------
TASTEN_MENUE_MINUS:
	cpi temp,(TASTE_MENUE_MINUS)	; vergleich TASTENWERT		
	brne TASTEN_MENUE_MINUS_FERTIG
	dec temp1						; MENUE-1					
	STS(adr_TASTE_MENUE),temp1
	; berlauf	?
	tst temp1
	brpl TASTEN_MENUE_MINUS_FERTIG
TASTEN_MENUE_MINUS_UEBERLAUF:
	STS(adr_TASTE_MENUE),NULL		; MENUE=0					
	call EEPROM_KONFIGURATION_SPEICHERN
	call BEEP_LANG
	jmp MODUS_1_MENUE_0				; ANALOGUHR					
TASTEN_MENUE_MINUS_FERTIG:
;-------------------------------------------------------------------------------
	; GRAFIC clear					
	tst temp
	breq TASTEN_MENUE_ACTION
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
TASTEN_MENUE_ACTION:
	; TEXT "EDIT"					
	call ASCII_CURSOR_ZEILE_3
	call FARBE_GRUEN
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_SPACE10
	call ASCII_SPACE4
	LDS temp1,(adr_TASTE_MENUE)
	call ANZEIGE_3_STELLEN_TEMP1_FORMATIERT
;-------------------------------------------------------------------------------
	LDS temp1,(adr_TASTE_MENUE)		; MENUE						
	ldi ZL,LOW (TASTEN_MENUE_SRUNGMARKE)	; Z-initialisieren	
	ldi ZH,HIGH(TASTEN_MENUE_SRUNGMARKE)
	add ZL,temp1
	adc ZH,NULL
	ijmp 					; SPRUNG nach Z	(rjmp->1Words jmp->2Words) 
;-------------------------------------------------------------------------------
TASTEN_MENUE_SRUNGMARKE:
	rjmp TASTEN_MENUE_00
	rjmp TASTEN_MENUE_01
	rjmp TASTEN_MENUE_02
	rjmp TASTEN_MENUE_03
	rjmp TASTEN_MENUE_04
	rjmp TASTEN_MENUE_05
	rjmp TASTEN_MENUE_06
	rjmp TASTEN_MENUE_07
	rjmp TASTEN_MENUE_08
	rjmp TASTEN_MENUE_09
	rjmp TASTEN_MENUE_10
	rjmp TASTEN_MENUE_11
	rjmp TASTEN_MENUE_12
	rjmp TASTEN_MENUE_13
	rjmp TASTEN_MENUE_14
	rjmp TASTEN_MENUE_15
	rjmp TASTEN_MENUE_16
	rjmp TASTEN_MENUE_17
	rjmp TASTEN_MENUE_18
	rjmp TASTEN_MENUE_19
	rjmp TASTEN_MENUE_20
	; BERLAUF		
	rjmp TASTEN_MENUE_00
;-------------------------------------------------------------------------------
TASTEN_MENUE_00:
	rjmp TASTEN_MENUE_MINUS_UEBERLAUF
;-------------------------------------------------------------------------------
TASTEN_MENUE_01:
	; hh					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_S
	call ASCII_T
	call ASCII_U
	call ASCII_N
	call ASCII_D
	call ASCII_E

	LDS temp1,(adr_hh)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_hh),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_02:
	; mm					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_M
	call ASCII_I
	call ASCII_N
	call ASCII_U
	call ASCII_T
	call ASCII_E

	LDS temp1,(adr_mm)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_mm),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_03:
	; ss					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_S
	call ASCII_E
	call ASCII_K
	call ASCII_U
	call ASCII_N
	call ASCII_D
	call ASCII_E

	LDS temp1,(adr_ss)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_ss),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_04:
	; TAG					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_T
	call ASCII_A
	call ASCII_G

	LDS temp1,(adr_TAG)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_TAG),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_05:
	; MONAT					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_M
	call ASCII_O
	call ASCII_N
	call ASCII_A
	call ASCII_T

	LDS temp1,(adr_MONAT)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_MONAT),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_06:
	; JAHR					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_J
	call ASCII_A
	call ASCII_H
	call ASCII_R

	LDS temp1,(adr_JAHR)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_JAHR),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_07:
	; MESZ						
	call ASCII_CURSOR_ZEILE_6
	call ASCII_M
	call ASCII_E
	call ASCII_S
	call ASCII_Z

	LDS temp1,(adr_MESZ)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	andi temp1,0b00000001		; BITMUSTER
	STS (adr_MESZ),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS

	LDS temp1,(adr_MESZ)
	call ANZEIGE_3_STELLEN_TEMP1
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_08:
	; MESZ						
	call ASCII_CURSOR_ZEILE_6
	call ASCII_A
	call ASCII_N
	call ASCII_Z
	call ASCII_E
	call ASCII_I
	call ASCII_G
	call ASCII_E
	call ASCII_SPACE
	call ASCII_S
	call ASCII_O
	call ASCII_N
	call ASCII_N
	call ASCII_E


	LDS temp1,(adr_SONNE_ANZEIGE)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	andi temp1,0b00000001		; BITMUSTER
	STS (adr_SONNE_ANZEIGE),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS

	LDS temp1,(adr_SONNE_ANZEIGE)
	call ANZEIGE_3_STELLEN_TEMP1
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_09:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_10:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_11:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_12:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_13:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_14:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_15:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_16:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_17:
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_18:
	; KREIS-KORREKTUR			
	call ASCII_CURSOR_ZEILE_6
	call ASCII_K
	call ASCII_R
	call ASCII_E
	call ASCII_I
	call ASCII_S

	LDS temp1,(adr_ENTZERRUNG_KREIS)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_ENTZERRUNG_KREIS),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS

	LDS temp1,(adr_ENTZERRUNG_KREIS)
	call ANZEIGE_3_STELLEN_TEMP1
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_19:
	; PROGRAMMSTART				
	call ASCII_CURSOR_ZEILE_6
	call ASCII_P
	call ASCII_R
	call ASCII_O
	call ASCII_G
	call ASCII_R
	call ASCII_A
	call ASCII_M
	call ASCII_M
	call ASCII_S
	call ASCII_T
	call ASCII_A
	call ASCII_R
	call ASCII_T

	LDS temp1,(adr_MODUS_PROGRAMMSTART)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	andi temp1,0b00000111
	STS (adr_MODUS_PROGRAMMSTART),temp1

	call ASCII_CURSOR_ZEILE_9
	call FARBE_WEISS

	LDS temp1,(adr_MODUS_PROGRAMMSTART)
	call ANZEIGE_3_STELLEN_TEMP1
	ret
;-------------------------------------------------------------------------------
TASTEN_MENUE_20:
	call ASCII_R
	call ASCII_E
	call ASCII_S
	call ASCII_E
	call ASCII_T
	clr temp1
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	tst temp1
	brne TASTEN_MENUE_20_w
	ret
TASTEN_MENUE_20_w:
	; ANZEIGE				
	call GRAFIC_CLEAR
	call ANZEIGE_TEXT_WAIT_KURZ
	call wait_1s
	call wait_1s
	CLI							; INTERRUPTS sperren	
	call wait_1s
	jmp RESET
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WERT_PLUS_MINUS_TEMP1:
	LDS temp,(adr_TASTE)			; TASTE						
	cpi temp,(TASTE_PLUS)
	brne TASTEN_WERT_PLUS_MINUS_TEMP1_N
	inc temp1
	ret
TASTEN_WERT_PLUS_MINUS_TEMP1_N:
	cpi temp,(TASTE_MINUS)
	brne TASTEN_WERT_PLUS_MINUS_TEMP1_F
	dec temp1
	ret
TASTEN_WERT_PLUS_MINUS_TEMP1_F:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


