; ##############################################################################
; ##############################################################################
; ##############################################################################
; lscht alle definierten TOUCHS, aber nicht den BILDSCHIRM						
TOUCH_CLEAR:
	; alle TASTEN lschen			
	STS(adr_TOUCH_ANZAHL_TASTEN),NULL
	; CLEAR							
	ldi ZL, LOW(adr_TOUCH_SPEICHER256)
	ldi ZH,HIGH(adr_TOUCH_SPEICHER256)
	;SCHLEIFE						
	clr temp
TOUCH_CLEAR_s:
	ST Z+,NULL
	dec temp
	brne TOUCH_CLEAR_s

	call wait_1ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; X auf GND																		
; Y auf EINGANG und PULL-UP ein													
TOUCH_STANDBY_MODUS:
	; X auf AUSGANG	
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW		
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
;------------------------------------------------------------------------------
	; Y auf AUSGANG	
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf EINGANG	/ PULL-UP ein	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_INITIALISIERUNG:
	; auf EINGANG	
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP AUS	
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
;------------------------------------------------------------------------------
	; X auf AUSGANG		
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW / HIGH	
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	call wait_1ms
	; MESSUNG			
	call ADC_MESSEN_3							; X (min)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	; Korrekturwert		
	mov R0,temp1
	LSR R0
	push R0
	add temp1,R0
	STS(adr_TOUCH_ADC_X_MIN),temp1
	; MESSUNG			
	call ADC_MESSEN_1						; X (max)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	; Korrekturwert		
	pop R0
	sub temp1,R0
	STS(adr_TOUCH_ADC_X_MAX),temp1
	; X auf EINGANG		
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; PULL-UP AUS		
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
;------------------------------------------------------------------------------
	; Y auf AUSGANG		
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf LOW / HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	call wait_1ms
	; MESSUNG +KORREKTUR
	call ADC_MESSEN_2						; Y (min)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	; Korrekturwert		
	mov R0,temp1
	LSR R0
	push R0
	add temp1,R0
	STS(adr_TOUCH_ADC_Y_MIN),temp1
	; MESSUNG +KORREKTUR
	call ADC_MESSEN_0						; Y (max)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	; Korrekturwert		
	pop R0
	sub temp1,R0
	STS(adr_TOUCH_ADC_Y_MAX),temp1
	rjmp TOUCH_STANDBY_MODUS
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_CHECK_TEMP1:
	; Kurzschluss gegen GND	?				
	; auf EINGANG							
	ldi temp1,1								; ERROR-CODE
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP EIN							
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	call wait_1ms							; PAUSE	
	sbis (TOUCH_XP_PIN),(TOUCH_XP_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_XN_PIN),(TOUCH_XN_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_YN_PIN),(TOUCH_YN_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
;------------------------------------------------------------------------------
	; Kurzschluss gegen +Ub?				
	; auf AUSGANG							
	ldi temp1,2								; ERROR-CODE
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; auf LOW								
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	call wait_1ms							; PAUSE	
	sbic (TOUCH_XP_PIN),(TOUCH_XP_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_XN_PIN),(TOUCH_XN_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_YN_PIN),(TOUCH_YN_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
;------------------------------------------------------------------------------
	; X-SCHICHT auf LOW						
	; auf EINGANG / AUSGANG					
	ldi temp1,3								; ERROR-CODE
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	;*X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP EIN / AUS						
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	;*X+	
	sbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	call wait_1ms
	sbic (TOUCH_XP_PIN),(TOUCH_XP_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_XN_PIN),(TOUCH_XN_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_YN_PIN),(TOUCH_YN_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
;------------------------------------------------------------------------------
	; Y-SCHICHT auf LOW						
	; auf EINGANG / AUSGANG					
	ldi temp1,4								; ERROR-CODE
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	;*Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP EIN / AUS						
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	;*Y+	
	sbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	call wait_1ms
	sbis (TOUCH_XP_PIN),(TOUCH_XP_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbis (TOUCH_XN_PIN),(TOUCH_XN_PIN_NR)	; ERROR, wenn PIN auf GND
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
	sbic (TOUCH_YN_PIN),(TOUCH_YN_PIN_NR)	; ERROR, wenn PIN auf HIGH
	rjmp TOUCH_CHECK_TEMP1_ERROR
;------------------------------------------------------------------------------
	clr temp1								; ERROR-CODE
	STS(adr_TOUCH_VORHANDEN),EINS
	rjmp TOUCH_STANDBY_MODUS
;------------------------------------------------------------------------------
TOUCH_CHECK_TEMP1_ERROR:
	rjmp TOUCH_STANDBY_MODUS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: "RUECKGABEWERT" 0=TOUCH nicht bettigt									
TOUCH_ABFRAGE:
	; RCKGABEWERT = NULL					
	STS(adr_TOUCH_RUECKGABEWERT) ,NULL
	; zurck, bis Y+ gegen GND gezogen wird	
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)
	ret
	; MESSUNG								
	rjmp TOUCH_MESSUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_MESSUNG:
	LDS temp,(adr_TOUCH_VORHANDEN)
	tst temp
	brne TOUCH_MESSUNG_RUN
	ret
TOUCH_MESSUNG_RUN:
	; Entprellung beim Antippen des Touchs		
	; mehrere ms muss der TOUCH gedrckt sein		
	call wait_1ms 							; kurze PAUSE
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; PIN abfragen, TOUCH noch bettigt ?
	ret
;-------------------------------------------------------------------------------
; X-EXAKTMESSUNG, Bestromung von X, MESSUNG an Y, PULL-UPs von Y aus, um Messfehler zu verringern								
	; Y auf EINGANG			
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y PULL-UP aus			
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; X auf AUSGANG			
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW	und HIGH	
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; ADC Y					
	call wait_1ms 							; kurze PAUSE
	call ADC_MESSEN_0
;-------------------------------------------------------------------------------
; Y-EXAKTMESSUNG, Bestromung von Y, MESSUNG an X, PULL-UPs von X aus, um Messfehler zu verringern								
	; X auf Eingang			
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X PULL-UP aus			
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; Y auf AUGANG			
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf LOW	und HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; ADC X					
	call wait_1ms 							; kurze PAUSE
	call ADC_MESSEN_1
	; STANDBY-MODUS						
	call TOUCH_STANDBY_MODUS
;-------------------------------------------------------------------------------
	; BERECHNUNG						
	call TOUCH_BERECHNUNG_KOORDINATEN_X
	call TOUCH_BERECHNUNG_KOORDINATEN_Y
	; TOUCH noch bettigt ?				
	call wait_1ms 							; kurze PAUSE	
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; PIN abfragen	
	ret
;-------------------------------------------------------------------------------
	; Rckkabewert berechnen			
	call TOUCH_RUECKGABEWERT_BERECHNEN
;-------------------------------------------------------------------------------
	; RECHTECK zeichnen					
	LDS temp,(adr_TOUCH_RUECKGABEWERT)	
	cpi temp,255
	breq TOUCH_MESSUNG_NO_RECHTECK
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL	; Grsse
	call FARBE_GELB				; FARBE	
	call GRAFIC_RECHTECK
	call BEEP_TOUCH
TOUCH_MESSUNG_NO_RECHTECK:
;-------------------------------------------------------------------------------
	; RCKGABEWERT=100, wenn kein TOUCH definiert	
	LDS temp,(adr_TOUCH_RUECKGABEWERT)	
	cpi temp,255
	brne TOUCH_MESSUNG_NO_100
	LDS temp,(adr_TOUCH_ANZAHL_TASTEN)
	tst temp
	brne TOUCH_MESSUNG_NO_100
	ldi temp,100
	STS(adr_TOUCH_RUECKGABEWERT),temp
	call GRAFIC_CLEAR
	call WAIT_500ms							; PAUSE					
TOUCH_MESSUNG_NO_100:
;-------------------------------------------------------------------------------
; Entprellung, bist TOUCH mehrere ms lang nicht mehr berhrt wird				
TOUCH_MESSUNG_ENTPRELLUNG_LOSLASSEN:
	WDR
	; LOOP, bis Y+ nicht gegen GND gezogen wird
	sbis (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)
	rjmp TOUCH_MESSUNG_ENTPRELLUNG_LOSLASSEN
	call wait_10ms							; PAUSE					
;-------------------------------------------------------------------------------
	; RECHTECK lschen ?				
	LDS temp,(adr_TOUCH_RUECKGABEWERT)	
	cpi temp,255
	breq TOUCH_MESSUNG_NO_RECHTECK_CLEAR
	call FARBE_SCHWARZ
	call GRAFIC_RECHTECK
TOUCH_MESSUNG_NO_RECHTECK_CLEAR:
;-------------------------------------------------------------------------------
	call DISPLAY_ON							; DISPLAY ON			
	call wait_10ms							; PAUSE					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DEFINIERT einen TOUCH (aus TABELLE)											
; INP: Z (TABELLE)																
; .db <X1> <Y1> <X2(OFFSET> <Y2(OFFSET)><Rckgabewert> <TEXT-ZEILE1> <NULL> <TEXT-ZEILE2> <NULL>	
TOUCH_TASTE_DEFINIEREN_Z:
	; X1+Y1+OFFSET fr X2+Y2 laden		
	LPM temp1, Z+  	; X1			
	LPM temp2, Z+  	; Y1			
	LPM temp3, Z+  	; X2(OFFS)		
	LPM temp4, Z+  	; Y2(OFFS)		
	LPM temp5, Z+	;Rckgabewert	
	; X2+Y2 berechnen aus Offset		
	add temp3,temp1
	add temp4,temp2
	; KKORDINATEN fr Rechteck			
	STS(adr_GRAFIC_X1),temp1
	STS(adr_GRAFIC_Y1),temp2
	STS(adr_GRAFIC_X2),temp3
	STS(adr_GRAFIC_Y2),temp4
	; im SRAM speichern					
	rcall TOUCH_TASTE_IM_SRAM_SPEICHERN
;-------------------------------------------------------------------------------
	; TEXT auf SPALTE positionieren		
	LDS temp1,(adr_GRAFIC_X1)
	LSR temp1
	LSR temp1
	LSR temp1
	inc temp1
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),temp1
;-------------------------------------------------------------------------------
	; TEXT auf SPALTE positionieren		
	LDS temp,(adr_GRAFIC_Y1)
	ldi temp2,0
	cpi temp,159-(3*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,1
	cpi temp,159-(4*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,2
	cpi temp,159-(5*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,3
	cpi temp,159-(6*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,4
	cpi temp,159-(7*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,5
	cpi temp,159-(8*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,6
	cpi temp,159-(9*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,7
	cpi temp,159-(10*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,8
	cpi temp,159-(11*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,9
	cpi temp,159-(12*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,10
	cpi temp,159-(13*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,11
	cpi temp,159-(14*12)
	brsh TOUCH_TASTE_DEFINIEREN_SPALTE
	ldi temp2,12
TOUCH_TASTE_DEFINIEREN_SPALTE:
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp2
;-------------------------------------------------------------------------------
TOUCH_TASTE_DEFINIEREN_TEXT_Z1s:
	LPM temp, Z+
	tst temp
	breq TOUCH_TASTE_DEFINIEREN_TEXT_Z2
	call ASCII_TEMP
	rjmp TOUCH_TASTE_DEFINIEREN_TEXT_Z1s
;-------------------------------------------------------------------------------
TOUCH_TASTE_DEFINIEREN_TEXT_Z2:
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),temp1
	inc temp2
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp2
TOUCH_TASTE_DEFINIEREN_TEXT_Z2s:
	LPM temp, Z+
	tst temp
	breq TOUCH_TASTE_DEFINIEREN_TEXT_FERTIG
	call ASCII_TEMP
	rjmp TOUCH_TASTE_DEFINIEREN_TEXT_Z2s
TOUCH_TASTE_DEFINIEREN_TEXT_FERTIG:
;-------------------------------------------------------------------------------
	; 2x RECHTECK zeichen				
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL
	call GRAFIC_RECHTECK
	LDS temp1,(adr_GRAFIC_X1)
	LDS temp2,(adr_GRAFIC_Y1)
	LDS temp3,(adr_GRAFIC_X2)
	LDS temp4,(adr_GRAFIC_Y2)
	inc temp1
	inc temp2
	dec temp3
	dec temp4
	STS(adr_GRAFIC_X1),temp1
	STS(adr_GRAFIC_Y1),temp2
	STS(adr_GRAFIC_X2),temp3
	STS(adr_GRAFIC_Y2),temp4
	call GRAFIC_RECHTECK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Speichert einen TOUCH im SRAM (TABELLE)										
; pro TOUCH 5-BYTE																
; maximal 51 TOUCHs programmierbar												
; AUFBAU: (X1),(Y1),(X2),(Y2),(Rckgabewert)	  								
TOUCH_TASTE_IM_SRAM_SPEICHERN:
	; Y-ZEIGER				
	ldi YL,LOW (adr_TOUCH_SPEICHER256)
	ldi YH,HIGH(adr_TOUCH_SPEICHER256)
	LDS R0,(adr_TOUCH_ANZAHL_TASTEN)
	ldi temp,5
	mul temp,R0
	add YL,R0
	adc YH,R1
	ST Y+,temp1	; X1
	ST Y+,temp2	; Y1
	ST Y+,temp3	; X2
	ST Y+,temp4	; Y2
	ST Y+,temp5	; Rckgabewert	
	; ANZAHL +1					
	LDS temp,(adr_TOUCH_ANZAHL_TASTEN)
	inc temp
	cpi temp,(50+1)
	brlo TOUCH_TASTE_IM_SRAM_SPEICHERN_OK
;-------------------------------------------------------------------------------
	; ERROR						
	STS(adr_ERROR_WERT),temp
	ldi temp,(ERROR_TOUCH_SPEICHER)
	STS(adr_ERROR_CODE),temp
	ret
;-------------------------------------------------------------------------------
TOUCH_TASTE_IM_SRAM_SPEICHERN_OK:
	STS(adr_TOUCH_ANZAHL_TASTEN),TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_RUECKGABEWERT_BERECHNEN:
	; RCKGABEWERT=255						
	ldi temp,255
	STS(adr_TOUCH_RUECKGABEWERT),temp
	; KOORDINATEN laden					
	LDS XL,(adr_TOUCH_X)
	LDS YL,(adr_TOUCH_Y)
	; Z-ZEIGER initialisieren			
	ldi ZL,LOW (adr_TOUCH_SPEICHER256)
	ldi ZH,HIGH(adr_TOUCH_SPEICHER256)
;-------------------------------------------------------------------------------
TOUCH_RUECKGABEWERT_BERECHNEN_S:
	; TOUCH- Speicher auslesen			
	LD temp1,Z+	; X1 
	LD temp2,Z+	; Y1
	LD temp3,Z+	; X2
	LD temp4,Z+ ; Y2
	LD temp5,Z+	; RCKGABEWERT	
	; Touch definiert ?					
	tst temp5
	brne TOUCH_RUECKGABEWERT_BERECHNEN_RUN
	ret
;-------------------------------------------------------------------------------
TOUCH_RUECKGABEWERT_BERECHNEN_RUN:
	cp XL,temp1
	brlo TOUCH_RUECKGABEWERT_BERECHNEN_S
	cp temp3,XL
	brlo TOUCH_RUECKGABEWERT_BERECHNEN_S
	cp YL,temp2
	brlo TOUCH_RUECKGABEWERT_BERECHNEN_S	
	cp temp4,YL	
	brlo TOUCH_RUECKGABEWERT_BERECHNEN_S
;-------------------------------------------------------------------------------
	; KOORDINATEN speichern fr RECHTECK
	subi temp1,-2
	subi temp2,-2
	subi temp3, 2
	subi temp4, 2
	STS(adr_GRAFIC_X1),temp1
	STS(adr_GRAFIC_Y1),temp2
	STS(adr_GRAFIC_X2),temp3
	STS(adr_GRAFIC_Y2),temp4
	; RCKGABEWERT=255						
	STS(adr_TOUCH_RUECKGABEWERT),temp5
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KOORDINATE=(PIXEL) x (ADC)-(MIN) / (MAX)-(MIN)								
TOUCH_BERECHNUNG_KOORDINATEN_X:
	; (ADC)-(MIN)				
	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	LDS temp,(adr_TOUCH_ADC_X_MIN)
	sub temp1,temp
	; BERLAUF	?				
	brcc TOUCH_BERECHNUNG_KOORDINATEN_X_w
	clr temp1
TOUCH_BERECHNUNG_KOORDINATEN_X_w:
	; (PIXEL) x Ergebnis		
	ldi temp,(VGA_Xsitze)
	mul temp,temp1
	mov temp1,R0
	mov temp2,R1
	; (MAX)-(MIN)				
	LDS temp3,(adr_TOUCH_ADC_X_MAX)
	LDS temp,(adr_TOUCH_ADC_X_MIN)
	sub temp3,temp
	; DIVISION					
	rcall TOUCH_DIVISION_16_8
	; Ergebnis grer als PIXEL ?
	cpi temp1,(VGA_Xsitze)
	brlo TOUCH_BERECHNUNG_KOORDINATEN_X_OK
	ldi temp1,(VGA_Xsitze-1)
TOUCH_BERECHNUNG_KOORDINATEN_X_OK:
	STS(adr_TOUCH_X),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KOORDINATE=(PIXEL) x (ADC)-(MIN) / (MAX)-(MIN)								
TOUCH_BERECHNUNG_KOORDINATEN_Y:
	; (ADC)-(MIN)				
	LDS temp1,(adr_ADC_1_L)
	LDS temp2,(adr_ADC_1_H)
	LSR temp2	; :2
	ROR temp1
	LSR temp2	; :4
	ROR temp1
	LDS temp,(adr_TOUCH_ADC_Y_MIN)
	sub temp1,temp
	; BERLAUF	?				
	brcc TOUCH_BERECHNUNG_KOORDINATEN_Y_w
	clr temp1
TOUCH_BERECHNUNG_KOORDINATEN_Y_w:
	; (PIXEL) x Ergebnis		
	ldi temp,(VGA_Ysitze)
	mul temp,temp1
	mov temp1,R0
	mov temp2,R1
	; (MAX)-(MIN)				
	LDS temp3,(adr_TOUCH_ADC_Y_MAX)
	LDS temp, (adr_TOUCH_ADC_Y_MIN)
	sub temp3,temp
	; DIVISION					
	rcall TOUCH_DIVISION_16_8
	; Ergebnis grer als PIXEL ?
	cpi temp1,(VGA_Ysitze)
	brlo TOUCH_BERECHNUNG_KOORDINATEN_Y_OK
	ldi temp1,(VGA_Ysitze-1)
TOUCH_BERECHNUNG_KOORDINATEN_Y_OK:
	STS(adr_TOUCH_Y),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 07/2015																
;																				
;	Division 16 bit-Zahl durch 8 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)													
;	input/Output 	temp2 (HIGH)												
;																				
;	input			temp3	Divisor		 										
;																				
TOUCH_DIVISION_16_8:
	clr temp 			; Leere Hilfsregister
	ldi temp6,1			; Zhler Bit 1 auf 1 setzen)
	clr temp7
;-----------------------------------------------------------------------
Tdiv8a:
	clc 				; Carry-Bit leeren
	rol temp1 		
	rol temp2 		
	rol temp 			;  in das Hilfsregister rotieren		
	brcs Tdiv8b 		; Eine 1 ist herausgerollt, ziehe ab	
	cp temp,temp3 		; Divisionsergebnis 1 oder 0?			
	brcs Tdiv8c 		; berspringe Subtraktion, wenn kleiner	
Tdiv8b:
	sub temp,temp3	 	; Subtrahiere Divisor					
	sec 				; Setze carry-bit, Ergebnis ist eine 1	
	rjmp Tdiv8d 			
Tdiv8c:
	clc 				; Lsche carry-bit, Ergebnis ist eine 0
Tdiv8d:
	rol temp6 			; Rotiere carry-bit in das Ergebnis		
	rol temp7
	brcc Tdiv8a 		; solange Nullen aus dem Ergebnis rotieren: weitermachen
;-----------------------------------------------------------------------
	;Zurckschreiben	
	mov temp1, temp6
	mov temp2, temp7
ret
;########################################################################
;########################################################################
;########################################################################




; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_ANZEIGE_WARTUNG:
	call GRAFIC_CLEAR
	call FARBE_WEISS
	call ASCII_CURSOR_ZEILE_0
	call ASCII_T
	call ASCII_O
	call ASCII_U
	call ASCII_C
	call ASCII_H

	call FARBE_GRUEN
	call ASCII_CURSOR_ZEILE_NEXT
	call ASCII_X
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_TOUCH_ADC_X_MIN)
	call ANZEIGE_3_STELLEN_TEMP1
	call ASCII_SPACE
	LDS temp1,(adr_TOUCH_ADC_X_MAX)
	call ANZEIGE_3_STELLEN_TEMP1

	call ASCII_CURSOR_ZEILE_NEXT
	call ASCII_Y
	call ASCII_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_TOUCH_ADC_Y_MIN)
	call ANZEIGE_3_STELLEN_TEMP1
	call ASCII_SPACE
	LDS temp1,(adr_TOUCH_ADC_Y_MAX)
	call ANZEIGE_3_STELLEN_TEMP1


	call wait_1s
	call wait_1s
	call wait_1s
	call GRAFIC_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_A:
	call FARBE_GRUEN			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_101*2)
	ldi ZH,HIGH(TOUCH_TASTE_101*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_102*2)
	ldi ZH,HIGH(TOUCH_TASTE_102*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_103*2)
	ldi ZH,HIGH(TOUCH_TASTE_103*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_TAG_NACHT			; FARBE	/ TAG / NACHT	
	ldi ZL,LOW (TOUCH_TASTE_104*2)
	ldi ZH,HIGH(TOUCH_TASTE_104*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_105*2)
	ldi ZH,HIGH(TOUCH_TASTE_105*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_106*2)
	ldi ZH,HIGH(TOUCH_TASTE_106*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_107*2)
	ldi ZH,HIGH(TOUCH_TASTE_107*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_108*2)
	ldi ZH,HIGH(TOUCH_TASTE_108*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_109*2)
	ldi ZH,HIGH(TOUCH_TASTE_109*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_110*2)
	ldi ZH,HIGH(TOUCH_TASTE_110*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_ROT					; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_111*2)
	ldi ZH,HIGH(TOUCH_TASTE_111*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_TAG_NACHT			; FARBE	/ TAG / NACHT	
	ldi ZL,LOW (TOUCH_TASTE_112*2)
	ldi ZH,HIGH(TOUCH_TASTE_112*2)
	call TOUCH_TASTE_DEFINIEREN_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_B:
	call FARBE_TAG_NACHT			; FARBE	/ TAG / NACHT	
	ldi ZL,LOW (TOUCH_TASTE_113*2)
	ldi ZH,HIGH(TOUCH_TASTE_113*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_114*2)
	ldi ZH,HIGH(TOUCH_TASTE_114*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_115*2)
	ldi ZH,HIGH(TOUCH_TASTE_115*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_116*2)
	ldi ZH,HIGH(TOUCH_TASTE_116*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_117*2)
	ldi ZH,HIGH(TOUCH_TASTE_117*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_118*2)
	ldi ZH,HIGH(TOUCH_TASTE_118*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_119*2)
	ldi ZH,HIGH(TOUCH_TASTE_119*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_120*2)
	ldi ZH,HIGH(TOUCH_TASTE_120*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_121*2)
	ldi ZH,HIGH(TOUCH_TASTE_121*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_122*2)
	ldi ZH,HIGH(TOUCH_TASTE_122*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_123*2)
	ldi ZH,HIGH(TOUCH_TASTE_123*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_124*2)
	ldi ZH,HIGH(TOUCH_TASTE_124*2)
	call TOUCH_TASTE_DEFINIEREN_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_C:
	call FARBE_ROT			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_125*2)
	ldi ZH,HIGH(TOUCH_TASTE_125*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_GRUEN			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_126*2)
	ldi ZH,HIGH(TOUCH_TASTE_126*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_BLAU			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_127*2)
	ldi ZH,HIGH(TOUCH_TASTE_127*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_GELB			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_128*2)
	ldi ZH,HIGH(TOUCH_TASTE_128*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_MAGENTA		; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_129*2)
	ldi ZH,HIGH(TOUCH_TASTE_129*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_CYAN			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_130*2)
	ldi ZH,HIGH(TOUCH_TASTE_131*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_WEISS			; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_131*2)
	ldi ZH,HIGH(TOUCH_TASTE_131*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_132*2)
	ldi ZH,HIGH(TOUCH_TASTE_132*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_133*2)
	ldi ZH,HIGH(TOUCH_TASTE_133*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_134*2)
	ldi ZH,HIGH(TOUCH_TASTE_134*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_135*2)
	ldi ZH,HIGH(TOUCH_TASTE_135*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_136*2)
	ldi ZH,HIGH(TOUCH_TASTE_136*2)
	call TOUCH_TASTE_DEFINIEREN_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_D:
	call FARBE_TAG_NACHT			; FARBE	/ TAG / NACHT	
	ldi ZL,LOW (TOUCH_TASTE_137*2)
	ldi ZH,HIGH(TOUCH_TASTE_137*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_138*2)
	ldi ZH,HIGH(TOUCH_TASTE_138*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_139*2)
	ldi ZH,HIGH(TOUCH_TASTE_139*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_140*2)
	ldi ZH,HIGH(TOUCH_TASTE_140*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_141*2)
	ldi ZH,HIGH(TOUCH_TASTE_141*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_142*2)
	ldi ZH,HIGH(TOUCH_TASTE_142*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_143*2)
	ldi ZH,HIGH(TOUCH_TASTE_143*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_144*2)
	ldi ZH,HIGH(TOUCH_TASTE_144*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_145*2)
	ldi ZH,HIGH(TOUCH_TASTE_145*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	ldi ZL,LOW (TOUCH_TASTE_146*2)
	ldi ZH,HIGH(TOUCH_TASTE_146*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_ROT					; FARBE	
	ldi ZL,LOW (TOUCH_TASTE_147*2)
	ldi ZH,HIGH(TOUCH_TASTE_147*2)
	call TOUCH_TASTE_DEFINIEREN_Z
	call FARBE_TAG_NACHT			; FARBE	/ TAG / NACHT	
	ldi ZL,LOW (TOUCH_TASTE_148*2)
	ldi ZH,HIGH(TOUCH_TASTE_148*2)
	call TOUCH_TASTE_DEFINIEREN_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
