; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Wertet den Rckgabewert der TOUCHS aus.										
;																				
; 27=ESC-TASTE																	
; 100=HAUPTMENUE																
; 100...HAUPTMENUE-TASTEN														
; 																				
TOUCH_MODUS:
	; RCKGABEWERT abfragen		
	LDS temp1,(adr_TOUCH_RUECKGABEWERT)
	; 255-ERROR					
	cpi temp1,255
	brne TOUCH_MODUS_NO255
	clr temp1
	STS(adr_TOUCH_RUECKGABEWERT),NULL
TOUCH_MODUS_NO255:
	; ESC-TASTE bettigt ?		
	cpi temp1,27
	breq TOUCH_MODUS_TASTE_27
	; HAUPT-TASTE bettigt ?	
	cpi temp1,100
	brsh TOUCH_MODUS_HAUPT_TASTE
	rjmp TOUCH_MODUS_RUN
;-------------------------------------------------------------------------------
; MENUE-TASTE																	
TOUCH_MODUS_HAUPT_TASTE:
	subi temp1,100		; -100	
	STS(adr_MODUS),temp1
	STS(adr_MENUE),NULL
	STS(adr_TOUCH_RUECKGABEWERT),NULL
	rjmp TOUCH_MODUS_RUN
;-------------------------------------------------------------------------------
; ESC-TASTE																		
TOUCH_MODUS_TASTE_27:
	STS(adr_MENUE),NULL
	STS(adr_TOUCH_RUECKGABEWERT),NULL
;-------------------------------------------------------------------------------
; RUN																			
TOUCH_MODUS_RUN:
	; ERROR	?					
	LDS temp1,(adr_MODUS)	; MODUS			
	cpi temp1,48+1
	brlo TOUCH_MODUS_RUN_OK
	; ERROR						
	STS(adr_ERROR_WERT),temp1	; WERT	
	ldi temp,(ERROR_TOUCH_MENUE); CODE	
	STS(adr_ERROR_CODE),temp
	ret
;-------------------------------------------------------------------------------
TOUCH_MODUS_RUN_OK:
	; Z-initialisieren					
	ldi ZL,LOW (TOUCH_MODUS_SPRUNGMARKE)
	ldi ZH,HIGH(TOUCH_MODUS_SPRUNGMARKE)
	add ZL,temp1
	adc ZH,NULL
	ijmp 					; SPRUNG nach Z	(rjmp->1Words jmp->2Words) 
TOUCH_MODUS_SPRUNGMARKE:
	rjmp MODUS_0	; Hauptmenue	
; HAUPTMENUE(A)								
	rjmp MODUS_1	; UHR-analog	
	rjmp MODUS_2	; UHR-DIGITAL	
	rjmp MODUS_3	; UHR			
	rjmp MODUS_4	; HYGRO-METER	
	rjmp MODUS_5	; BARO-METER	
	rjmp MODUS_6
	rjmp MODUS_7
	rjmp MODUS_8
	rjmp MODUS_9	; NACHTMODUS
	rjmp MODUS_10	; BACK	
	rjmp MODUS_11	; OFF	
	rjmp MODUS_12	; NEXT	
; HAUPTMENUE(B)								
	rjmp MODUS_13	; EDIT ZEIT / DATUM		
	rjmp MODUS_14	; EDIT NACHT / TAG		
	rjmp MODUS_15	; EDIT ZAHL (TESTZAHL)	
	rjmp MODUS_16	; EDIT KREIS			
	rjmp MODUS_17	; EDIT TOUCH-BEEP		
	rjmp MODUS_18	; EDIT-STUNDEN-KLICK	
	rjmp MODUS_19	; EDIT-ANZEIGE-SONNEN-AUF-UNTERGANG
	rjmp MODUS_20	; EDIT-DRUCK-OFFSET		
	rjmp MODUS_21
	rjmp MODUS_22	; BACK	
	rjmp MODUS_23
	rjmp MODUS_24	; NEXT	
; HAUPTMENUE(C)								
	rjmp MODUS_25	; ROT	
	rjmp MODUS_26	; GRN	
	rjmp MODUS_27	; BLAU	
	rjmp MODUS_28	; GELB	
	rjmp MODUS_29	; MAGENTA
	rjmp MODUS_30	; CYAN	
	rjmp MODUS_31	; WEISS	
	rjmp MODUS_32	; BLACK	
	rjmp MODUS_33	; REGENBOGEN
	rjmp MODUS_34	; BACK	
	rjmp MODUS_35	; STERNENHIMMEL
	rjmp MODUS_36	; NEXT	
; HAUPTMENUE(D)								
	rjmp MODUS_37	; VGA-TESTS		
	rjmp MODUS_38	; SYSTEM-TESTS	
	rjmp MODUS_39	; SYSTEM-STATUS	
	rjmp MODUS_40	; DCF-STATUS	
	rjmp MODUS_41	; SYSTEM-INFO	
	rjmp MODUS_42
	rjmp MODUS_43	; FEHLER-LISTE	
	rjmp MODUS_44
	rjmp MODUS_45
	rjmp MODUS_46	; BACK	
	rjmp MODUS_47
	rjmp MODUS_48	; NEXT	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Hauptmenue(A)																	
MODUS_0:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_0_MENUE_0
	rjmp MODUS_0_MENUE_1
;-------------------------------------------------------------------------------
MODUS_0_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; TASTEN HAUPTMENUE(A)	
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_A
	; MODUS					
	ldi temp,0
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1
;-------------------------------------------------------------------------------
MODUS_0_MENUE_1:
	; NIX tun				
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; UHR-ANALOG																	
MODUS_1:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_1_MENUE_0
	rjmp MODUS_1_MENUE_1
;-------------------------------------------------------------------------------
MODUS_1_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	call ANALOGUHR_INITIALISIERUNG
	; MODUS					
	STS(adr_MODUS),EINS		; MODUS=1	
	STS(adr_MENUE),EINS		; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_1_MENUE_1:
	; UHR-ANALOG			
	jmp ANALOGUHR
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; UHR-DIGIATAL																	
MODUS_2:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_2_MENUE_0
	rjmp MODUS_2_MENUE_1
;-------------------------------------------------------------------------------
MODUS_2_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,2
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS		; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_2_MENUE_1:
	; UHR-DIGIATAL			
	jmp UHR_DIGITAL
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_3:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_3_MENUE_0
	rjmp MODUS_3_MENUE_1
;-------------------------------------------------------------------------------
MODUS_3_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,3
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_3_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HYGRO-METRER																	
MODUS_4:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_4_MENUE_0
	rjmp MODUS_4_MENUE_1
;-------------------------------------------------------------------------------
MODUS_4_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,4
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; BAROMETER_INITIALISIERUNG
	call HYGROMETER_INITIALISIERUNG
;-------------------------------------------------------------------------------
MODUS_4_MENUE_1:
	jmp HYGROMETER
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BARO-METRER																	
MODUS_5:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_5_MENUE_0
	rjmp MODUS_5_MENUE_1
;-------------------------------------------------------------------------------
MODUS_5_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,5
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
	; BAROMETER_INITIALISIERUNG
	call BAROMETER_INITIALISIERUNG
;-------------------------------------------------------------------------------
MODUS_5_MENUE_1:
	jmp BAROMETER
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_6:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_6_MENUE_0
	rjmp MODUS_6_MENUE_1
;-------------------------------------------------------------------------------
MODUS_6_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,6
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_6_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_7:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_7_MENUE_0
	rjmp MODUS_7_MENUE_1
;-------------------------------------------------------------------------------
MODUS_7_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,7
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_7_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_8:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_8_MENUE_0
	rjmp MODUS_8_MENUE_1
;-------------------------------------------------------------------------------
MODUS_8_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,8
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_8_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; NACHTMODUS / TAGMODUS															
MODUS_9:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_9_MENUE_0
	rjmp MODUS_9_MENUE_1
;-------------------------------------------------------------------------------
MODUS_9_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,9
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
	; HAUPTMENUE	
	STS(adr_MODUS),NULL
	STS(adr_MENUE),NULL
	; NACHTMODUS ?	
	LDS temp,(adr_NACHTMODUS_ON)
	SBRS temp,0
	jmp NACHTMODUS_ON
	jmp NACHTMODUS_OFF
;-------------------------------------------------------------------------------
MODUS_9_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-BACK																		
MODUS_10:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_10_MENUE_0
	rjmp MODUS_10_MENUE_1
;-------------------------------------------------------------------------------
MODUS_10_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_D
	; MODUS					
	ldi temp,10
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_10_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OFF																			
MODUS_11:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_11_MENUE_0
	rjmp MODUS_11_MENUE_1
;-------------------------------------------------------------------------------
MODUS_11_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,11
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	call DISPLAY_OFF
;-------------------------------------------------------------------------------
MODUS_11_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-NEXT																		
MODUS_12:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_12_MENUE_0
	rjmp MODUS_12_MENUE_1
;-------------------------------------------------------------------------------
MODUS_12_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_B
	; MODUS					
	ldi temp,12
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
;-------------------------------------------------------------------------------
MODUS_12_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT ZEIT / DATUM																
MODUS_13:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_13_MENUE_0
	rjmp MODUS_13_MENUE_1
;-------------------------------------------------------------------------------
MODUS_13_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,13
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
	; EDIT ZEIT				
	call EDIT_ZEIT_INITIALISIERUNG
;-------------------------------------------------------------------------------
MODUS_13_MENUE_1:
	jmp EDIT_ZEIT_ANZEIGE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT-NACHTMODUS																
MODUS_14:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_14_MENUE_0
	rjmp MODUS_14_MENUE_1
;-------------------------------------------------------------------------------
MODUS_14_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,14
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
	; EDIT_NACHTMODUS_INITIALISIERUNG
	call EDIT_NACHTMODUS_INITIALISIERUNG
;-------------------------------------------------------------------------------
MODUS_14_MENUE_1:
	jmp EDIT_NACHTMODUS_ANZEIGE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT-ZAHL																		
MODUS_15:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_15_MENUE_0
	rjmp MODUS_15_MENUE_1
;-------------------------------------------------------------------------------
MODUS_15_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,15
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE=1	
	; EDIT_ZAHL_INITIALISIERUNG
	call EDIT_ZAHL_INITIALISIERUNG
;-------------------------------------------------------------------------------
MODUS_15_MENUE_1:
	; LADEN						
	LDS temp1,(adr_TEST_ZAHL_BYTE0)
	LDS temp2,(adr_TEST_ZAHL_BYTE1)
	LDS temp3,(adr_TEST_ZAHL_BYTE2)
	LDS temp4,(adr_TEST_ZAHL_BYTE3)
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_TEST_ZAHL_BYTE0),temp1
	STS(adr_TEST_ZAHL_BYTE1),temp2
	STS(adr_TEST_ZAHL_BYTE2),temp3
	STS(adr_TEST_ZAHL_BYTE3),temp4

	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KREIS-KORREKTUR																
MODUS_16:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_16_MENUE_0
	rjmp MODUS_16_MENUE_1
;-------------------------------------------------------------------------------
MODUS_16_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,16
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_16_MENUE_1:
	; LADEN						
	LDS temp1,(adr_ENTZERRUNG_KREIS)
	clr temp2
	clr temp3
	clr temp4
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_ENTZERRUNG_KREIS),temp1


	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT TOUCH-BEEP																
MODUS_17:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_17_MENUE_0
	rjmp MODUS_17_MENUE_1
;-------------------------------------------------------------------------------
MODUS_17_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,17
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_17_MENUE_1:
	; LADEN						
	LDS temp1,(adr_TOUCH_BEEP_ON)
	clr temp2
	clr temp3
	clr temp4
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_TOUCH_BEEP_ON),temp1
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT-STUNDEN-KLICK															
MODUS_18:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_18_MENUE_0
	rjmp MODUS_18_MENUE_1
;-------------------------------------------------------------------------------
MODUS_18_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,18
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_18_MENUE_1:
	; LADEN						
	LDS temp1,(adr_hh_KLICK_ON)
	clr temp2
	clr temp3
	clr temp4
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_hh_KLICK_ON),temp1
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT-ANZEIGE-SONNEN-AUF-UNTERGANG
MODUS_19:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_19_MENUE_0
	rjmp MODUS_19_MENUE_1
;-------------------------------------------------------------------------------
MODUS_19_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,19
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_19_MENUE_1:
	; LADEN						
	LDS temp1,(adr_SONNE_ANZEIGE)
	clr temp2
	clr temp3
	clr temp4
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_SONNE_ANZEIGE),temp1
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EDIT-DRUCK-OFFSET																
MODUS_20:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_20_MENUE_0
	rjmp MODUS_20_MENUE_1
;-------------------------------------------------------------------------------
MODUS_20_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,20
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_20_MENUE_1:
	; LADEN						
	LDS temp1,(adr_DRUCK_OFFSET_L)
	LDS temp2,(adr_DRUCK_OFFSET_H)
	clr temp3
	clr temp4
	; EDIT						
	call EDIT_ZAHL_TEMP1_4
	; speichern					
	STS(adr_DRUCK_OFFSET_L),temp1
	STS(adr_DRUCK_OFFSET_H),temp2
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_21:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_21_MENUE_0
	rjmp MODUS_21_MENUE_1
;-------------------------------------------------------------------------------
MODUS_21_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,21
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_21_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-BACK																		
MODUS_22:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_22_MENUE_0
	rjmp MODUS_22_MENUE_1
;-------------------------------------------------------------------------------
MODUS_22_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_A
	; MODUS					
	ldi temp,22
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_22_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_23:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_23_MENUE_0
	rjmp MODUS_23_MENUE_1
;-------------------------------------------------------------------------------
MODUS_23_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,23
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_23_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-NEXT																		
MODUS_24:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_24_MENUE_0
	rjmp MODUS_24_MENUE_1
;-------------------------------------------------------------------------------
MODUS_24_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_C
	; MODUS					
	ldi temp,24
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_24_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ROT																			
MODUS_25:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_25_MENUE_0
	rjmp MODUS_25_MENUE_1
;-------------------------------------------------------------------------------
MODUS_25_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,25
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; ROT					
	call FARBE_ROT
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_25_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; GRN																			
MODUS_26:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_26_MENUE_0
	rjmp MODUS_26_MENUE_1
;-------------------------------------------------------------------------------
MODUS_26_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,26
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; GRN					
	call FARBE_GRUEN
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_26_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BLAU																			
MODUS_27:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_27_MENUE_0
	rjmp MODUS_27_MENUE_1
;-------------------------------------------------------------------------------
MODUS_27_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,27
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; BLAU					
	call FARBE_BLAU
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_27_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; GELB																			
MODUS_28:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_28_MENUE_0
	rjmp MODUS_28_MENUE_1
;-------------------------------------------------------------------------------
MODUS_28_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,28
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; GELB					
	call FARBE_GELB
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_28_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MAGENTA																		
MODUS_29:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_29_MENUE_0
	rjmp MODUS_29_MENUE_1
;-------------------------------------------------------------------------------
MODUS_29_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,29
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; MAGENTA				
	call FARBE_MAGENTA
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_29_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CYAN																			
MODUS_30:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_30_MENUE_0
	rjmp MODUS_30_MENUE_1
;-------------------------------------------------------------------------------
MODUS_30_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,30
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; CYAN					
	call FARBE_CYAN
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_30_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; WEISS																			
MODUS_31:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_31_MENUE_0
	rjmp MODUS_31_MENUE_1
;-------------------------------------------------------------------------------
MODUS_31_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,31
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; WEISS					
	call FARBE_WEISS
	ldi temp3,(VGA_Xsitze-1)
	ldi temp4,(VGA_Ysitze-1)
	STS(adr_GRAFIC_X1),NULL			; X1
	STS(adr_GRAFIC_Y1),NULL			; Y1
	STS(adr_GRAFIC_X2),temp3		; X2
	STS(adr_GRAFIC_Y2),temp4		; Y2
	call GRAFIC_BOX
;-------------------------------------------------------------------------------
MODUS_31_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BLACK/SCHWARZ																	
MODUS_32:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_32_MENUE_0
	rjmp MODUS_32_MENUE_1
;-------------------------------------------------------------------------------
MODUS_32_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,32
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; CLEAR					
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
MODUS_32_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGENBOGEN																	
MODUS_33:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_33_MENUE_0
	rjmp MODUS_33_MENUE_1
;-------------------------------------------------------------------------------
MODUS_33_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,33
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; FARBBALKEN			
	call VGA_TEST_FARBBALKEN
;-------------------------------------------------------------------------------
MODUS_33_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-BACK																		
MODUS_34:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_34_MENUE_0
	rjmp MODUS_34_MENUE_1
;-------------------------------------------------------------------------------
MODUS_34_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_B
	; MODUS					
	ldi temp,34
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_34_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; STERNENHIMMEL																	
MODUS_35:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_35_MENUE_0
	rjmp MODUS_35_MENUE_1
;-------------------------------------------------------------------------------
MODUS_35_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,35
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_35_MENUE_1:
	jmp VGA_TEST_STERNENHIMMEL
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-NEXT																		
MODUS_36:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_36_MENUE_0
	rjmp MODUS_36_MENUE_1
;-------------------------------------------------------------------------------
MODUS_36_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_D
	; MODUS					
	ldi temp,36
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_36_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VGA-TESTPROGRAMM																
MODUS_37:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_37_MENUE_0
	rjmp MODUS_37_MENUE_1
;-------------------------------------------------------------------------------
MODUS_37_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,37
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; TEST-PROGRAMM			
	call VGA_TEST_PROGRAMM
;-------------------------------------------------------------------------------
MODUS_37_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SYSTEM-TEST																	
MODUS_38:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_38_MENUE_0
	rjmp MODUS_38_MENUE_1
;-------------------------------------------------------------------------------
MODUS_38_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,38
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; SYSTEMTEST			
	call ANZEIGE_SYSTEMCHECK
;-------------------------------------------------------------------------------
MODUS_38_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SYSTEM-STATUS																	
MODUS_39:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_39_MENUE_0
	rjmp MODUS_39_MENUE_1
;-------------------------------------------------------------------------------
MODUS_39_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,39
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
	; Begrung				
	call ANZEIGE_BEGRUESSUNG
	call WAIT_1s
	call WAIT_1s
	call GRAFIC_CLEAR
	; SYSTEM-STATUS			
	call ANZEIGE_SYSTEM_STATUS
;-------------------------------------------------------------------------------
MODUS_39_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DCF-STATUS																	
MODUS_40:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_40_MENUE_0
	rjmp MODUS_40_MENUE_1
;-------------------------------------------------------------------------------
MODUS_40_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,40
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_40_MENUE_1:
	jmp DCF_ANZEIGE_STATUS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SYSTEM-INFO																	
MODUS_41:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_41_MENUE_0
	rjmp MODUS_41_MENUE_1
;-------------------------------------------------------------------------------
MODUS_41_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,41
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_41_MENUE_1:
	; SYSTEM-INFO			
	jmp ANZEIGE_SYSTEM_INFO
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_42:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_42_MENUE_0
	rjmp MODUS_42_MENUE_1
;-------------------------------------------------------------------------------
MODUS_42_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,42
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_42_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; FEHLER-LISTE																	
MODUS_43:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_43_MENUE_0
	rjmp MODUS_43_MENUE_1
;-------------------------------------------------------------------------------
MODUS_43_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,43
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_43_MENUE_1:
	jmp ANZEIGE_FEHLERSPEICHER
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_44:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_44_MENUE_0
	rjmp MODUS_44_MENUE_1
;-------------------------------------------------------------------------------
MODUS_44_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,44
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_44_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reserve																		
MODUS_45:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_45_MENUE_0
	rjmp MODUS_45_MENUE_1
;-------------------------------------------------------------------------------
MODUS_45_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; MODUS					
	ldi temp,45
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_45_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-BACK																		
MODUS_46:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_46_MENUE_0
	rjmp MODUS_46_MENUE_1
;-------------------------------------------------------------------------------
MODUS_46_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_C
	; MODUS					
	ldi temp,46
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_46_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RESET																			
MODUS_47:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_47_MENUE_0
	rjmp MODUS_47_MENUE_1
;-------------------------------------------------------------------------------
MODUS_47_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; ANZEIGE				
	call ANZEIGE_TEXT_WAIT_KURZ
	call wait_1s
	CLI							; INTERRUPTS sperren	
	call wait_1s
	jmp RESET
	; MODUS					
	ldi temp,47
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_47_MENUE_1:
	jmp ANZEIGE_RESERVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PAGE-NEXT																		
MODUS_48:
	LDS temp,(adr_MENUE)	; MENUE			
	cpi temp,0
	breq MODUS_48_MENUE_0
	rjmp MODUS_48_MENUE_1
;-------------------------------------------------------------------------------
MODUS_48_MENUE_0:
	; INITIALISIEREN		
	call TOUCH_CLEAR
	call GRAFIC_CLEAR
	; HAUPTMENUE			
	call TOUCH_TASTEN_DEFINIEREN_HAUPTMENUE_A
	; MODUS					
	ldi temp,48
	STS(adr_MODUS),temp
	STS(adr_MENUE),EINS	; MENUE
;-------------------------------------------------------------------------------
MODUS_48_MENUE_1:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################








