; ##############################################################################
; ##############################################################################
; ##############################################################################
DS1307_INITIALISIERUNG:
	; START								
	;ldi temp1,(DS1307_ADRESSE)
	;rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; INP: temp1(SLAVE_ADRESSE) out: FEHLER_CODE
	; ADRESS-ZEIGER					
	;ldi temp1,7				
	;rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; inp: temp1 OUT: FEHLER_CODE	
	; Byte-7 (Control)				
	;ldi temp1,0b00010000						; SEKUNDENTAKT am PIN aktivieren
	;rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; inp: temp1 OUT: FEHLER_CODE	
	;rcall TWI_STOP								; STOP							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS1307_CHECK_TEMP1:
	ldi temp1,(DS1307_ADRESSE)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; INP: temp1(SLAVE_ADRESSE) out: FEHLER_CODE
	call TWI_STOP								; STOP				
	; ERROR ?				
	tst  R0 									;TWI_FEHLER_CODE	
	brne DS1307_CHECK_TEMP1_ERROR
	STS(adr_DS1307_VORHANDEN),EINS				; vorhanden !		
	clr temp1
	ret
;-------------------------------------------------------------------------------
DS1307_CHECK_TEMP1_ERROR:
	ldi temp1,12
	STS(adr_DS1307_VORHANDEN),NULL				; nicht vorhanden !
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PUNKT auf DISPLAY																
DS1307_KONTROLL_PUNKT:
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL
	clr XL
	clr XH
	clr YL
	clr XH
	jmp GRAFIC_PUNKT_X_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS1307_RTC_STELLEN_SOFORT:
	LDS temp,(adr_DS1307_VORHANDEN)
	tst temp
	brne DS1307_RTC_STELLEN_SOFORT_RUN
	ret
DS1307_RTC_STELLEN_SOFORT_RUN:
	rjmp DS1307_UHR_STELLEN_INITIALISIEREN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur bei SEKUNDE "5" und volle Stunde stellen									
DS1307_RTC_STELLEN_AUTOMATIK:
	; SEKUNDE=5		
	LDS temp,(adr_ss)
	cpi temp,5
	breq DS1307_RTC_STELLEN_AUTOMATIK_w1
	ret
DS1307_RTC_STELLEN_AUTOMATIK_w1:
	; MINUTE=0		
	LDS temp,(adr_mm)
	cpi temp,0
	breq DS1307_RTC_STELLEN_AUTOMATIK_w2
	ret
DS1307_RTC_STELLEN_AUTOMATIK_w2:
	; WRITE aktiv ?
	LDS temp,(adr_DS1307_WRITE_AKTIV)
	tst temp
	brne DS1307_RTC_STELLEN_AUTOMATIK_w3
	ret
DS1307_RTC_STELLEN_AUTOMATIK_w3:
	; VORHANDEN		
	LDS temp,(adr_DS1307_VORHANDEN)
	tst temp
	brne DS1307_RTC_STELLEN_AUTOMATIK_RUN
	ret
;-------------------------------------------------------------------------------
DS1307_RTC_STELLEN_AUTOMATIK_RUN:
	STS(adr_DS1307_WRITE_AKTIV),NULL
	rjmp DS1307_UHR_STELLEN_INITIALISIEREN
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																								
;ADR 	BIT 7 	BIT 6 	BIT 5 	BIT 4 	BIT 3 	BIT 2 	BIT 1 	BIT 0 		FUNCTION 	RANGE 	
;00h 	CH 						10 Seconds 						Seconds 	Seconds 	00-59 	
;01h 	0 						10 Minutes 						Minutes 	Minutes 	00-59 	
;02h 	0 		12 		10 Hour 10 Hour 						Hours 		Hours 		00-23 	
;03h 	0 		0 		0 		0 		0 						DAY 		Day 		01-07 	
;04h 	0 		0 		10 Date 								Date 		Date 		01-31 	
;05h 	0 		0 		0 		10 Month 						Month 		Month 		01-12 	
;06h 					10 Year 								Year 		Year 		00-99 	
;07h 	OUT 	0 		0 		SQWE 	0 		0 		RS1 	RS0 		Control 	- 		
;08h-3Fh 																	RAM 56 x 8 	00h-FFh 
;																								
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DS1307 ZEIT / DATUM / RAM  setzen												
DS1307_UHR_STELLEN_INITIALISIEREN:
; -- SLAVE ADRESSE																
	ldi temp1,(DS1307_ADRESSE)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; INP: temp1(SLAVE_ADRESSE) out: FEHLER_CODE
; -- ADRESS-ZEIGER																
	ldi temp1,0
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-0 (SEKUNDEN) ----------------------------------------------------------
	LDS temp1,(adr_ss)
	; Bit0 behandeln
	andi temp1,0b01111111
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-1 (MINUTEN) -----------------------------------------------------------
	LDS temp1,(adr_mm)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-2 (STUNDEN) -----------------------------------------------------------
	LDS temp1,(adr_hh)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-3 (WOCHENTAG) ---------------------------------------------------------
	LDS temp1,(adr_WOCHENTAG)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-4 (TAG) ---------------------------------------------------------------
	LDS temp1,(adr_TAG)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-5 (MONAT) -------------------------------------------------------------
	LDS temp1,(adr_MONAT)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- BYTE-6 (JAHR) --------------------------------------------------------------
	LDS temp1,(adr_JAHR)
	rcall DS1307_UHR_STELLEN_BCD		; INP/OUT: temp1				
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
;-- Byte-7 (Control)------------------------------------------------------------
	ldi temp1,0b00010000				; SEKUNDENTAKT am PIN aktivieren
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
; STOP																			
	rcall TWI_STOP
;-------------------------------------------------------------------------------
	; ERROR						
	tst  R0 	;TWI_FEHLER_CODE
	brne DS1307_UHR_STELLEN_INITIALISIEREN_ERROR
	; SCHWARZER PUNKT	
	call FARBE_SCHWARZ
	call DS1307_KONTROLL_PUNKT
	ret
;-------------------------------------------------------------------------------
DS1307_UHR_STELLEN_INITIALISIEREN_ERROR:
	ldi temp1,(DS1307_ERROR_WRITE)
	ldi temp2,0
	STS(adr_WARNUNG_CODE),temp1				; WARNUNG			
	call FEHLERSPEICHER_WRITE_TEMP1_TEMP2 ; FEHLER_CODE=temp1	FEHLER_WERT=temp2	
	; GRNER PUNKT	
	call FARBE_ROT
	call DS1307_KONTROLL_PUNKT
ret
; ##############################################################################
; INP/OUT: temp1																
DS1307_UHR_STELLEN_BCD:
	cpi temp1,100
	brsh DS1307_UHR_STELLEN_BCD_ERROR
	cpi temp1,90
	brsh DS1307_UHR_STELLEN_90
	cpi temp1,80
	brsh DS1307_UHR_STELLEN_80
	cpi temp1,70
	brsh DS1307_UHR_STELLEN_70
	cpi temp1,60
	brsh DS1307_UHR_STELLEN_60
	cpi temp1,50
	brsh DS1307_UHR_STELLEN_50
	cpi temp1,40
	brsh DS1307_UHR_STELLEN_40
	cpi temp1,30
	brsh DS1307_UHR_STELLEN_30
	cpi temp1,20
	brsh DS1307_UHR_STELLEN_20
	cpi temp1,10
	brsh DS1307_UHR_STELLEN_10
	rjmp DS1307_UHR_STELLEN_00
DS1307_UHR_STELLEN_00:
	ret
DS1307_UHR_STELLEN_10:
	subi temp1,10 			; -10				
	ori temp1, 0b00010000	; 10er Bit setzen	
	ret
DS1307_UHR_STELLEN_20:
	subi temp1,20 			; -20				
	ori temp1, 0b00100000	; 20er Bit setzen	
	ret
DS1307_UHR_STELLEN_30:
	subi temp1,30 			; -30				
	ori temp1, 0b00110000	; 30er Bit setzen	
	ret
DS1307_UHR_STELLEN_40:
	subi temp1,40 			; -40				
	ori temp1, 0b01000000	; 40er Bit setzen	
	ret
DS1307_UHR_STELLEN_50:
	subi temp1,50 			; -50				
	ori temp1, 0b01010000	; 50er Bit setzen	
	ret
DS1307_UHR_STELLEN_60:
	subi temp1,60 			; -60				
	ori temp1, 0b01100000	; 60er Bit setzen	
	ret
DS1307_UHR_STELLEN_70:
	subi temp1,70 			; -70				
	ori temp1, 0b01110000	; 70er Bit setzen	
	ret
DS1307_UHR_STELLEN_80:
	subi temp1,80 			; -80				
	ori temp1, 0b10000000	; 80er Bit setzen	
	ret
DS1307_UHR_STELLEN_90:
	subi temp1,90 			; -90				
	ori temp1, 0b10010000	; 90er Bit setzen	
	ret
DS1307_UHR_STELLEN_BCD_ERROR:
	clr temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 7 BITES auslesen																
DS1307_UHR_AUSLESEN:
	; CLEAR		
	STS(adr_TAG),NULL
	STS(adr_MONAT),NULL
	STS(adr_JAHR), NULL
	STS(adr_hh),NULL
	STS(adr_mm),NULL
	STS(adr_ss),NULL
	STS(adr_WOCHENTAG),NULL
; -- SLAVE ADRESSE + MT					
	ldi temp1,(DS1307_ADRESSE)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1; INP: temp1(SLAVE_ADRESSE) out: FEHLER_CODE
; -- ADRESS-ZEIGER setzen				
	ldi temp1,0
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1	; inp: temp1 OUT: FEHLER_CODE
; -- SLAVE ADRESSE + MR					
	ldi temp1,(DS1307_ADRESSE)
	rcall TWI_MASTER_RECEIVER_START_TEMP1	; INP: temp1(SLAVE_ADRESSE) out: FEHLER_CODE
	; BYTE 0
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+0),temp1
	; BYTE 1
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+1),temp1
	; BYTE 2
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+2),temp1
	; BYTE 3
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+3),temp1
	; BYTE 4
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+4),temp1
	; BYTE 5
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+5),temp1
	; BYTE 6
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; OUT: temp1								
	STS	(adr_TWI_BEREICH_READ+6),temp1
	; BYTE 7
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS	(adr_TWI_BEREICH_READ+7),temp1
	; STOP						
	rcall TWI_STOP
	; ERROR						
	tst  R0 ;TWI_FEHLER_CODE
	brne DS1307_UHR_AUSLESEN_ERROR
	rjmp DS1307_UHR_AUSWERTEN
;-------------------------------------------------------------------------------
DS1307_UHR_AUSLESEN_ERROR:
	ldi temp1,(DS1307_ERROR_AUSLESEN)
	ldi temp2,0
	STS(adr_WARNUNG_CODE),temp1				; WARNUNG			
	call FEHLERSPEICHER_WRITE_TEMP1_TEMP2 	; FEHLER_CODE=temp1	FEHLER_WERT=temp2	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS1307_UHR_AUSWERTEN:
;-------------------------------------------------------------------------------
	; BYTE-0 auswerten (Sekunden)		
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+0)	
	; bereinigen (ev. gesetztes Bit7)	
	andi temp,0b01111111
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_ss),temp1
;-------------------------------------------------------------------------------
	; BYTE-1 auswerten (Minuten)		
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+1)	
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_mm),temp1
;-------------------------------------------------------------------------------
	; BYTE-2 auswerten (STUNDEN)		
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+2)	
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_hh),temp1

;-------------------------------------------------------------------------------
	; BYTE-3 auswerten (WOCHENTAG 01..07)	
	; laden									
	LDS temp1,(adr_TWI_BEREICH_READ+3)
	; speichern
	STS(adr_WOCHENTAG),temp1 

;-------------------------------------------------------------------------------
	; BYTE-4 auswerten (TAG 01...31) 	
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+4)	
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_TAG),temp1

;-------------------------------------------------------------------------------
	; BYTE-5 auswerten (MONAT 01..12)	
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+5)	
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_MONAT),temp1
;-------------------------------------------------------------------------------
	; BYTE-6 auswerten (JAHR 00...99)	
	; laden								
	clr temp1
	LDS temp,(adr_TWI_BEREICH_READ+6)	
	; kopieren in Hilfsregister			
	mov temp1,temp						
	; Hilfsregister selektieren			
	andi temp1,0b00001111
	; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	LSR temp
	; 10 x addieren						
	add temp1,temp	
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	; speichern							
	STS(adr_JAHR),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################







