; ##############################################################################
; ##############################################################################
; ##############################################################################
; TWI-DRUCKSENSOR																
HP03S_INITIALISIERUNG:
	sbi (HP03S_XCLR_DDR) ,(HP03S_XCLR_PIN_NR)	; auf AUSGANG		
	sbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (H), sonst SLAVE(ADC) nicht erkannt	
	call wait_1ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_CHECK_TEMP1:
	sbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (H), sonst SLAVE(ADC) nicht erkannt	
	call wait_10ms
	ldi temp1,(HP03S_EEPROM_ADRESSE)			; 80				
	call TWI_MASTER_TRANSMITTER_START_TEMP1		; START-MT			
	call TWI_STOP								; STOP				
	; ERROR ?				
	tst  R0 									;TWI_FEHLER_CODE
	brne HP03S_CHECK_TEMP1_ERROR

	ldi temp1,(HP03S_ADC_ADRESSE)				; 119				
	call TWI_MASTER_TRANSMITTER_START_TEMP1		; START-TRANSMITTER	
	call TWI_STOP								; STOP				
	cbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (L)			
	; ERROR ?				
	tst  R0 									;TWI_FEHLER_CODE
	brne HP03S_CHECK_TEMP1_ERROR
	call HP03S_EEPROM_READ						; EEPROM read		
	STS(adr_HP03S_VORHANDEN),EINS				; vorhanden !		
	clr temp1
	ret
;-------------------------------------------------------------------------------
HP03S_CHECK_TEMP1_ERROR:
	STS(adr_HP03S_VORHANDEN),NULL				; nicht vorhanden !	
	ldi temp1,66
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_MESSUNG:
	LDS temp,(adr_HP03S_VORHANDEN)
	tst temp
	brne HP03S_MESSUNG_RUN
	ret
;-------------------------------------------------------------------------------
HP03S_MESSUNG_RUN:
	call HP03S_MESSUNG_DRUCK
	call HP03S_MESSUNG_TEMPERATUR
	call HP03S_BERECHNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzen Sie Pin XCLR auf low bevor Sie die Koeffizienten auslesen, 			
; andernfalls knnen die ausgelesenen Daten fehlerhaft sein.					
HP03S_EEPROM_READ:
	cbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (L)			
	ldi temp1,(HP03S_EEPROM_ADRESSE)			; 80				
	call TWI_MASTER_TRANSMITTER_START_TEMP1		; START-MT			
	ldi temp1,(0x10)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1		; ADRESSE 			
	ldi temp1,(HP03S_EEPROM_ADRESSE)
	call TWI_MASTER_RECEIVER_START_TEMP1		; START-MR			
	ldi ZL,low (adr_HP03S_C1_MSB)				; Z initialisieren	
	ldi ZH,high(adr_HP03S_C1_MSB)
	ldi temp9,17								; Schleife			
;-------------------------------------------------------------------------------
HP03S_EEPROM_READ_s:
	call TWI_MASTER_RECEIVER_DATA_TEMP1			; BYTE read			
	ST Z+,temp1									; im SRAM ablegen Z+1
	dec temp9
	brne HP03S_EEPROM_READ_s
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	ST Z+,temp1									; im SRAM ablegen 	
	call TWI_STOP								; STOP				
	sbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (H)			
	call wait_1ms
	; KOEFFIZIENTEN_CHECK					
	rjmp HP03S_EEPROM_KOEFFIZIENTEN_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_EEPROM_KOEFFIZIENTEN_CHECK:
;C1 (MSB:LSB)Sensitivity coefficient	0x0100--0xFFFF
	LDS temp2,(adr_HP03S_C1_MSB)
	cpi temp2,HIGH(0x0100)
	brlo HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; kleiner, dann...	
;C2 (MSB:LSB) Offset coefficient 		0x00--0x1FFF	
	LDS temp2,(adr_HP03S_C2_MSB)
	cpi temp2,HIGH(0x1FFF)+1
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; grer, dann...	
;C3 (MSB:LSB) Temperatur coefficient of sensitivity 0x00--0x0400 
	LDS temp2,(adr_HP03S_C3_MSB)
	cpi temp2,HIGH(0x0400)+1
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; grer, dann...	
;C4 (MSB:LSB) Temperatur coefficient of offset 0x00--0x1000		
	LDS temp2,(adr_HP03S_C4_MSB)
	cpi temp2,HIGH(0x1000)+1
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; grer, dann...	
;C5 (MSB:LSB) Reference temperature 	0x1000--0xFFFF	
	LDS temp2,(adr_HP03S_C5_MSB)
	cpi temp2,HIGH(0x1000)
	brlo HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; kleiner, dann...	
;C6 (MSB:LSB) Temperatur coefficient of temperature 0x00--0x4000
	LDS temp2,(adr_HP03S_C6_MSB)
	cpi temp2,HIGH(0x4000)+1
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; grer, dann...	
;C7 (MSB:LSB) Offset fine tuning 0x0960--0xA28 2400--2600
	LDS temp2,(adr_HP03S_C7_MSB)
	cpi temp2,HIGH(0x0960)
	brlo HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; kleiner, dann...	
	cpi temp2,HIGH(0xA28)+1
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR	; grer, dann...	
;A Sensor specific parameter 0x01--0x3F 1--63
	LDS temp,(adr_HP03S_A)
	tst temp
	breq HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
	cpi temp,(63+1)
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
;B Sensor specific parameter 0x01--0x3F 1--63
	LDS temp,(adr_HP03S_B)
	tst temp
	breq HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
	cpi temp,(63+1)
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
;C Sensor specific parameter 0x01--0x0F 1--15
	LDS temp,(adr_HP03S_C)
	tst temp
	breq HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
	cpi temp,(63+1)
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
;D Sensor specific parameter 0x01--0x0F 1--15
	LDS temp,(adr_HP03S_D)
	tst temp
	breq HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
	cpi temp,(63+1)
	brsh HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR
ret
;-------------------------------------------------------------------------------
HP03S_EEPROM_KOEFFIZIENTEN_CHECK_ERROR:
	ldi temp,(HP03S_ERROR_KOEFFIZIENT)
	STS(adr_WARNUNG_CODE),temp					; WARNUNG			
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzen Sie Pin XCLR auf high bevor Sie die Messwerte auslesen, 				
; andernfalls sind die ausgelesenen Daten fehlerhaft. 							
; Verwerfen Sie den ersten Messwert um mgliche Fehler zu vermeiden.			
;	OUT:(adr_HP03S_D1_LSB)														
;		(adr_HP03S_D1_MSB)														
HP03S_MESSUNG_DRUCK:
	sbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (H)			

	call HP03S_MESSUNG_DRUCK_RUN				; DUMMY				
	LDS temp1,(adr_HP03S_D1_LSB)
	LDS temp2,(adr_HP03S_D1_MSB)
	LDS temp3,(adr_HP03S_D1_DUMMY_L)
	LDS temp4,(adr_HP03S_D1_DUMMY_H)

	cp temp1,temp3
	brne HP03S_MESSUNG_DRUCK_S
	cp temp2,temp4
	brne HP03S_MESSUNG_DRUCK_S
	ret
HP03S_MESSUNG_DRUCK_S:
	WDR
	STS(adr_HP03S_D1_DUMMY_L),temp1
	STS(adr_HP03S_D1_DUMMY_H),temp2
	rjmp HP03S_MESSUNG_DRUCK
;-------------------------------------------------------------------------------
HP03S_MESSUNG_DRUCK_RUN:
	ldi temp1,(HP03S_ADC_ADRESSE)			
	call TWI_MASTER_TRANSMITTER_START_TEMP1	; START-TRANSMITTER	
	ldi temp1,(0xFF)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; write Byte		
	ldi temp1,(0xF0)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; write Byte		
	rcall TWI_STOP							; STOP				
	call wait_20ms							; PAUSE 40ms Minimum !
	call wait_20ms
;-------------------------------------------------------------------------------
	ldi temp1,(HP03S_ADC_ADRESSE)			
	call TWI_MASTER_TRANSMITTER_START_TEMP1	; START-TRANSMITTER	
	ldi temp1,(0xFD)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; write Byte		
	call TWI_STOP							; STOP				
;-------------------------------------------------------------------------------
	ldi temp1,(HP03S_ADC_ADRESSE)
	call TWI_MASTER_RECEIVER_START_TEMP1	; START-RECEIVER	
	call TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_HP03S_D1_MSB),temp1
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_HP03S_D1_LSB),temp1
	call TWI_STOP								; STOP				
	; ERROR								
	tst  R0 ;TWI_FEHLER_CODE
	brne HP03S_MESSUNG_DRUCK_ERROR
	ret
;-------------------------------------------------------------------------------
HP03S_MESSUNG_DRUCK_ERROR:
	STS(adr_HP03S_D1_LSB),NULL
	STS(adr_HP03S_D1_MSB),NULL
	STS(adr_HP03S_D1_DUMMY_L),NULL
	STS(adr_HP03S_D1_DUMMY_H),NULL
	ldi temp,(HP03S_ERROR_MESSUNG)
	STS(adr_WARNUNG_CODE),temp					; WARNUNG			
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzen Sie Pin XCLR auf high bevor Sie die Messwerte auslesen, 				
; andernfalls sind die ausgelesenen Daten fehlerhaft. 							
; Verwerfen Sie den ersten Messwert um mgliche Fehler zu vermeiden.			
HP03S_MESSUNG_TEMPERATUR:
	sbi (HP03S_XCLR_PORT),(HP03S_XCLR_PIN_NR)	;  XCLR (H)			
	ldi temp1,(HP03S_ADC_ADRESSE)			
	call TWI_MASTER_TRANSMITTER_START_TEMP1		; START-TRANSMITTER	
	ldi temp1,(0xFF)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1		; write Byte		
	ldi temp1,(0xE8)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1		; write Byte		
	call TWI_STOP								; STOP				
	call wait_20ms								; PAUSE 40ms Minimum !
	call wait_20ms
;-------------------------------------------------------------------------------
	ldi temp1,(HP03S_ADC_ADRESSE)			
	call TWI_MASTER_TRANSMITTER_START_TEMP1			; START-TRANSMITTER	
	ldi temp1,(0xFD)
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1			; write Byte		
	call TWI_STOP									; STOP				
;-------------------------------------------------------------------------------
	ldi temp1,(HP03S_ADC_ADRESSE)
	call TWI_MASTER_RECEIVER_START_TEMP1			; START-RECEIVER	
	call TWI_MASTER_RECEIVER_DATA_TEMP1				; BYTE read			
	STS(adr_HP03S_D2_MSB),temp1
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_HP03S_D2_LSB),temp1
	call TWI_STOP									; STOP				
	; ERROR								
	tst  R0 ;TWI_FEHLER_CODE
	brne HP03S_MESSUNG_TEMPERATUR_ERROR
	ret
;-------------------------------------------------------------------------------
HP03S_MESSUNG_TEMPERATUR_ERROR:
	STS(adr_HP03S_D2_MSB),NULL
	STS(adr_HP03S_D2_LSB),NULL
	ldi temp,(HP03S_ERROR_MESSUNG)
	STS(adr_WARNUNG_CODE),temp					; WARNUNG			
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; lt. Datenblatt																
HP03S_BERECHNUNG_DATENBLATT_BEISPIEL:
	ldi temp1, LOW(29908)	; C1 = 29908
	ldi temp2,HIGH(29908)
	STS(adr_HP03S_C1_LSB),temp1
	STS(adr_HP03S_C1_MSB),temp2
	ldi temp1, LOW(3724)	; C2 = 3724
	ldi temp2,HIGH(3724)
	STS(adr_HP03S_C2_LSB),temp1
	STS(adr_HP03S_C2_MSB),temp2
	ldi temp1, LOW(312)		; C3 = 312
	ldi temp2,HIGH(312)
	STS(adr_HP03S_C3_LSB),temp1
	STS(adr_HP03S_C3_MSB),temp2
	ldi temp1, LOW(441)		; C4 = 441
	ldi temp2,HIGH(441)
	STS(adr_HP03S_C4_LSB),temp1
	STS(adr_HP03S_C4_MSB),temp2
	ldi temp1, LOW(9191)	; C5 = 9191
	ldi temp2,HIGH(9191)
	STS(adr_HP03S_C5_LSB),temp1
	STS(adr_HP03S_C5_MSB),temp2
	ldi temp1, LOW(3990)	; C6 = 3990
	ldi temp2,HIGH(3990)
	STS(adr_HP03S_C6_LSB),temp1
	STS(adr_HP03S_C6_MSB),temp2
	ldi temp1, LOW(2500)	; C7 = 2500
	ldi temp2,HIGH(2500)
	STS(adr_HP03S_C7_LSB),temp1
	STS(adr_HP03S_C7_MSB),temp2
	ldi temp1,1				; A = 1		
	STS(adr_HP03S_A),temp1
	ldi temp1,4				; B = 4		
	STS(adr_HP03S_B),temp1
	ldi temp1,4				; C = 4		
	STS(adr_HP03S_C),temp1
	ldi temp1,9				; D = 9		
	STS(adr_HP03S_D),temp1
	ldi temp1, LOW(30036)	; D1 = 30036
	ldi temp2,HIGH(30036)
	STS(adr_HP03S_D1_LSB),temp1
	STS(adr_HP03S_D1_MSB),temp2
	ldi temp1, LOW(4107)	; D2 = 4107
	ldi temp2,HIGH(4107)
	STS(adr_HP03S_D2_LSB),temp1
	STS(adr_HP03S_D2_MSB),temp2
	rjmp HP03S_BERECHNUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; lt. Datenblatt																
HP03S_BERECHNUNG_TESTWERTE:
	; D1						
	ldi temp1, LOW(38183)
	ldi temp2,HIGH(38183)
	STS(adr_HP03S_D1_LSB),temp1
	STS(adr_HP03S_D1_MSB),temp2
	; D2						
	ldi temp1, LOW(35486-8000)
	ldi temp2,HIGH(35486-8000)
	STS(adr_HP03S_D2_LSB),temp1
	STS(adr_HP03S_D2_MSB),temp2
	rjmp HP03S_BERECHNUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_BERECHNUNG:
; Schritt 1 dUT berechnen														
; Fall1: D2>=C5 dUT = D2-C5-((D2-C5)/2^7) * ((D2-C5)/2^7) * A / 2^C				
; Fall2: D2< C5 dUT = D2-C5-((D2-C5)/2^7) * ((D2-C5)/2^7) * B / 2^C				
	; DIFFERENZ (D2-C5)							
	LDS temp1,(adr_HP03S_D2_LSB)
	LDS temp2,(adr_HP03S_D2_MSB)
	LDS temp3,(adr_HP03S_C5_LSB)
	LDS temp4,(adr_HP03S_C5_MSB)
	sub temp1,temp3
	sbc temp2,temp4
	; DIFFERENZ speichern						
	push temp1									;	  z.B: -5084		
	push temp2
	; Umschaltung A oder B						
	LDS temp9,(adr_HP03S_A) 					; (A) D2>=C5 z.B: 1		
	SBRC temp2,7								; Sprung, wenn positiv	
	LDS temp9,(adr_HP03S_B)						; (B) D2< C5 z.B: 4		
	; DIFFERENZ x DIFFERENZ (ist immer positiv)	
	call FUNCTION_BETRAG16_TEMP1_TEMP2			; BETRAG bilden			
	mov temp3,temp1
	mov temp4,temp2
	call FUNKTION_MULTIPLIKATION_16_16_32		; MULTIPLIKATION		
	; mal A bzw. B (temp9)						
	mov temp5,temp9								; (A) oder (B)			
	call FUNKTION_MULTIPLIKATION_32_8
	; durch 2^(7+7+C)							
	LDS temp,(adr_HP03S_C)						; (C)					
	subi temp,(-14)								; (C)+14				
	call FUNKTION_DIVISION32_2_HOCH_TEMP		; durch 2^temp			
	mov temp3,temp1
	mov temp4,temp2
	; DIFFERENZ minus ERGEBNIS				
	pop temp2									; DIFFERENZ laden		
	pop temp1
	sub temp1,temp3
	sbc temp2,temp4
	; dUT speichern								
	STS(adr_HP03S_dUT_LSB),temp1				; z.B: -5478			
	STS(adr_HP03S_dUT_MSB),temp2
; Schritt 2:																			
; OFF = (C2 + (C4 - 1024) * dUT / 2^14) * 4												
; OFF = (3724+(441-1024)*(-5478)/2^14*4 = 15675											
	; C4-1024							
	LDS temp1,(adr_HP03S_C4_LSB)						; BSP: 441					
	LDS temp2,(adr_HP03S_C4_MSB)
	ldi temp3, LOW(1024)
	ldi temp4,HIGH(1024)
	sub temp1,temp3
	sbc temp2,temp4
	; mal dUT								
	LDS temp3,(adr_HP03S_dUT_LSB)						; BSP -5478					
	LDS temp4,(adr_HP03S_dUT_MSB)
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT		; MULTIPLIKATION (SIGNIERT)	
	; durch 2^14						
	ldi temp,14
	call FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT		; durch 2^temp	(SIGNIERT)	
	; + C2								
	LDS temp3,(adr_HP03S_C2_LSB)						; BSP: 3724					
	LDS temp4,(adr_HP03S_C2_MSB)
	add temp1,temp3
	adc temp2,temp4
	; mal 4								
	ldi temp3,4
	ldi temp4,0
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT		; MULTIPLIKATION (SIGNIERT)	
	; OFF speichern						
	STS(adr_HP03S_OFF_LSB),temp1						; BSP: 15676				
	STS(adr_HP03S_OFF_MSB),temp2
; Schritt 2a:																			
; SENS = C1 + (C3 * dUT)/2^10															
	; C3 x dUT							
	LDS temp1,(adr_HP03S_C3_LSB)
	LDS temp2,(adr_HP03S_C3_MSB)
	LDS temp3,(adr_HP03S_dUT_LSB)
	LDS temp4,(adr_HP03S_dUT_MSB)
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT		; MULTIPLIKATION (SIGNIERT)	
	; durch 2^10						
	ldi temp,10
	call FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT		; durch 2^temp	(SIGNIERT)	
	; + C1								
	LDS temp3,(adr_HP03S_C1_LSB)						; BSP: 29908		
	LDS temp4,(adr_HP03S_C1_MSB)
	add temp1,temp3
	adc temp2,temp4
	; ERGEBNIS SENS save im SRAM			
	STS(adr_HP03S_SENS_LSB),temp1						; BSP 28238		
	STS(adr_HP03S_SENS_MSB),temp2
; Schritt 2b:																			
; X = SENS * (D1 - 7168) / 2^14 - OFF													
	; D1-7168					
	LDS temp1,(adr_HP03S_D1_LSB)
	LDS temp2,(adr_HP03S_D1_MSB)
	ldi temp3, LOW(7168)
	ldi temp4,HIGH(7168)
	sub temp1,temp3
	sbc temp2,temp4
	; mal SENS							
	LDS temp3,(adr_HP03S_SENS_LSB)
	LDS temp4,(adr_HP03S_SENS_MSB)
	call FUNKTION_MULTIPLIKATION_16_16_32	; MULTIPLIKATION	
	; durch 2^14						
	ldi temp,14
	call FUNKTION_DIVISION32_2_HOCH_TEMP	; durch 2^temp		
	; minus OFF							
	LDS temp3,(adr_HP03S_OFF_LSB)
	LDS temp4,(adr_HP03S_OFF_MSB)
	sub temp1,temp3
	sbc temp2,temp4
	; X speichern						
	STS(adr_HP03S_X_LSB),temp1	
	STS(adr_HP03S_X_MSB),temp2
; Schritt 2c:																			
; P = X * 10 / 2^5 + C7																	
	LDS temp1,(adr_HP03S_X_LSB)
	LDS temp2,(adr_HP03S_X_MSB)
	ldi temp3, LOW(10)
	ldi temp4,HIGH(10)
	call FUNKTION_MULTIPLIKATION_16_16_32	; MULTIPLIKATION	
	; durch 2^5							
	ldi temp,5
	call FUNKTION_DIVISION32_2_HOCH_TEMP	; durch 2^temp		
	; + C7								
	LDS temp3,(adr_HP03S_C7_LSB)
	LDS temp4,(adr_HP03S_C7_MSB)
	add temp1,temp3
	adc temp2,temp4
	; OFFSET addieren					
	LDS temp3,(adr_DRUCK_OFFSET_L)
	LDS temp4,(adr_DRUCK_OFFSET_H)
	add temp1,temp3
	adc temp2,temp4
	; P speichern						
	STS(adr_HP03S_P_L),temp1				; BSP: 9918
	STS(adr_HP03S_P_H),temp2
; Schritt 3:																			
; T = 250 + dUT * C6 / 2^16 - dUT / 2^D													
	; dUT * C6							
	LDS temp1,(adr_HP03S_dUT_LSB)	; 1.FAKTOR	
	LDS temp2,(adr_HP03S_dUT_MSB)
	LDS temp3,(adr_HP03S_C6_LSB)	; 2.FAKTOR	
	LDS temp4,(adr_HP03S_C6_MSB)
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT		; MULTIPLIKATION (SIGNIERT)	
	;  : 2^16							
	ldi temp,16
	call FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT		; durch 2^temp	(SIGNIERT)	
	; + 250								
	ldi temp3, LOW(250)
	ldi temp4,HIGH(250)
	add temp1,temp3
	adc temp2,temp4
	push temp1											; ZWISCHENERGENERGEBNIS speichern	
	push temp2
	; dUT / 2^D							
	LDS temp1,(adr_HP03S_dUT_LSB)
	LDS temp2,(adr_HP03S_dUT_MSB)
	call FUNCTION_16_32_SIGNIERT						; 16 auf 32-BIT (SIGNIERT)
	LDS temp,(adr_HP03S_D)
	call FUNKTION_DIVISION32_2_HOCH_TEMP_SIGNIERT		; durch 2^temp	(SIGNIERT)	
	mov temp3,temp1
	mov temp4,temp2
	; ZWISCHENERGEBNIS minus ...		
	pop temp2											; ZWISCHENERGENERGEBNIS laden		
	pop temp1
	sub temp1,temp3
	sbc temp2,temp4
	; ERGEBNIS T save im SRAM			
	STS(adr_HP03S_TEMPERATUR_L),temp1	
	STS(adr_HP03S_TEMPERATUR_H),temp2
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_ANZEIGE_DRUCK_KURZ:
	LDS temp1,(adr_HP03S_P_L)
	LDS temp2,(adr_HP03S_P_H)
	clr temp3
	clr temp4
 	call FUNCTION_HEX_ASC_32
	; NULLSTELLENUNTERDRCKUNG			
	cpi temp5,'0'
	brne ANZEIGE_DRUCK_KURZ_1000
	call ASCII_SPACE2
	rjmp ANZEIGE_DRUCK_KURZ_w
ANZEIGE_DRUCK_KURZ_1000:
	mov temp, temp5			; 5.ZIFFER	
	call ASCII_TEMP
	call ASCII_PUNKT		; PUNKT		
ANZEIGE_DRUCK_KURZ_w:
	mov temp, temp4			; 4.ZIFFER	
	call ASCII_TEMP
	mov temp, temp3			; 3.ZIFFER	
	call ASCII_TEMP	
	mov temp, temp2			; 2.ZIFFER	
	call ASCII_TEMP	
	call ASCII_KOMMA		; KOMMA		
	mov temp, temp1			; 1.ZIFFER	 (1-er Stelle)	
	jmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
HP03S_ANZEIGE_TEMPERATUR_KURZ:
	LDS temp1,(adr_HP03S_TEMPERATUR_L)
	LDS temp2,(adr_HP03S_TEMPERATUR_H)
	jmp ANZEIGE_3_STELLEN_KOMMA1_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################
