; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_INITIALISIERUNG:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_CHECK_TEMP1:
	; ADRESSE			
	ldi temp1,(HYT939_ADRESSE)					; 40				
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	call TWI_STOP								; STOP				
	; ERROR ?				
	tst  R0 ;TWI_FEHLER_CODE
	brne HYT939_CHECK_TEMP1_ERROR
	STS(adr_HYT939_VORHANDEN),EINS				; vorhanden !		
	clr temp1
	ret
;-------------------------------------------------------------------------------
HYT939_CHECK_TEMP1_ERROR:
	ldi temp1,66
	STS(adr_HYT939_VORHANDEN),NULL				; nicht vorhanden !
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_MESSUNG:
	; SENSOR vorhanden ?		
	LDS temp,(adr_HYT939_VORHANDEN)
	tst temp
	brne HYT939_MESSUNG_RUN
	ret
;-------------------------------------------------------------------------------
HYT939_MESSUNG_RUN:
	; MR (Measurement Requests)					
	; Die Messung dauert ca. 50ms				
	ldi temp1,(HYT939_ADRESSE)					; ADRESSE			
	call TWI_MASTER_TRANSMITTER_START_TEMP1		; START-TRANSMITTER	
	call TWI_STOP								; STOP				
	call wait_50ms
	; ERRROR ?									
	tst  R0 ;TWI_FEHLER_CODE
	brne HYT939_MESSUNG_ERROR
HYT939_MESSUNG_s:
	; DF (Data Fetch)							
	ldi temp1,(HYT939_ADRESSE)					; ADRESSE			
	call TWI_MASTER_RECEIVER_START_TEMP1		; START-RECEIVER	
	call TWI_MASTER_RECEIVER_DATA_TEMP1			; BYTE read			
	STS(adr_HYT939_DATA_MSB),temp1	;
	call TWI_MASTER_RECEIVER_DATA_TEMP1			; BYTE read			
	STS(adr_HYT939_DATA_LSB),temp1	;
	call TWI_MASTER_RECEIVER_DATA_TEMP1			; BYTE read			
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp1 ;
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1 ;
	call TWI_STOP								; STOP				
	; ERRROR ?									
	tst  R0 ;TWI_FEHLER_CODE
	brne HYT939_MESSUNG_ERROR
	; Bit15: CMode Bit / Bit14:Stale Bit abfragen
	LDS temp,(adr_HYT939_DATA_MSB)
	andi temp,0b11000000
	tst temp
	breq HYT939_MESSUNG_w
	rjmp HYT939_MESSUNG_s
;-------------------------------------------------------------------------------
HYT939_MESSUNG_w:
	; Temperatur-DATA 2 x rechts				
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp2
	; BERECHNUNG					
	rjmp HYT939_BERECHNUNG
;-------------------------------------------------------------------------------
HYT939_MESSUNG_ERROR:
	STS(adr_HYT939_DATA_LSB),NULL
	STS(adr_HYT939_DATA_MSB),NULL
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),NULL
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),NULL
	call HYT939_BERECHNUNG
	ldi temp,(HYT939_ERROR_MESSUNG)
	STS(adr_WARNUNG_CODE),temp					; WARNUNG			
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_BERECHNUNG:
	; rF [%] = 100 * rFraw / 2^14													
	LDS temp1,(adr_HYT939_DATA_LSB)
	LDS temp2,(adr_HYT939_DATA_MSB)
	ldi temp3, LOW(100)
	ldi temp4,HIGH(100)
	call FUNKTION_MULTIPLIKATION_16_16_32		; MULTIPLIKATION	
	ldi temp,14
	call FUNKTION_DIVISION32_2_HOCH_TEMP		; durch 2^temp		
	; rF>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_RH),temp1					; Ergebnis			
	;T [C] = 165 / 2^14 * Traw - 40
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	ldi temp3, LOW(165)
	ldi temp4,HIGH(165)
	call FUNKTION_MULTIPLIKATION_16_16_32		; MULTIPLIKATION	
	ldi temp,14
	call FUNKTION_DIVISION32_2_HOCH_TEMP		; durch 2^temp		
	ldi temp3, LOW(40)
	ldi temp4,HIGH(40)
	sub temp1,temp3								; Subtraktion		
	sbc temp2,temp4
	; T>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),temp1	; Ergebnis			
	ret
;-------------------------------------------------------------------------------
HYT939_BERECHNUNG_ERROR:
	STS(adr_HYT939_RH),NULL
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),NULL
	ldi temp,(HYT939_ERROR_BERECHNUNG)
	STS(adr_WARNUNG_CODE),temp					; WARNUNG			
	ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_ANZEIGE_FEUCHTIGKEIT_KURZ:
	LDS temp1,(adr_HYT939_RH)
	call ANZEIGE_2_STELLEN_TEMP1
	jmp ASCII_PROZENT
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_ANZEIGE_TEMPERATUR_KURZ:
	LDS temp1,(adr_HYT939_TEMPERATUR_SIGNIERT)
	call ANZEIGE_2_STELLEN_TEMP1
	;call ASCII_GRD
	jmp ASCII_C
; ##############################################################################
; ##############################################################################
; ##############################################################################


