;																		
;																		
; Dieses Assembler-Programm	generiert ein VGA-SIGNAL					
;																		
; ANALOGUHR + DCF77														
;																		
; 640x480 - 60HZ 														
; 																		
; 180x160 PIXEL															
;																		
; ATmega1284P-22MHz (bertaktet mit 10%)								
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 09/2015														
;																		

;																		
; GRN leuchtet: alle-ok und alles schn								
; GELB leuchtet:														
; ROT  leuchtet: die automatische Taktkorrektur im Interrupt versagt	
; ROT+GELB leuchtet: Zeilennummern stimmen nicht 						

;																		
; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;																		
; Die Pixel generiert der PORT-B, ist aber	dadurch komplett belegt		
;																		


;												
; Anschlussbelegung PINS						
;												
; PA0 ==> TOUCH (ADC)							
; PA1 ==> TOUCH (ADC)							
; PA2 ==> TOUCH (ADC)							
; PA3 ==> TOUCH (ADC)							
; PA4 ==> OUT-RELAIS							
; PA5 ==> OUT-RELAIS							
; PA6 ==> 										
; PA7 ==> 										
;												
; PB0 ==> ROT									
; PB1 ==> GRN									
; PB2 ==> BLAU									
; PB3 ==>										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> TEST-AUSGANG-B						
; PC4 ==> TEST-AUSGANG-A						
; PC5 ==> LED GRN								
; PC6 ==> LED GELB								
; PC7 ==> LED ROT								
;												
; PD0 ==> VSYNC									
; PD1 ==> HSYNC									
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> OUT ca.32kHz							
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; VERSION										
.equ VERSION								= 1
; KONSTANTEN									
.equ TAKT									= 22000000	; 22 MHz		
; TASTEN-WERTE									
.equ TASTE_MENUE_PLUS						= 1
.equ TASTE_MENUE_MINUS						= 2
.equ TASTE_PLUS								= 4
.equ TASTE_MINUS							= 8
; VGA-TOUCH-DISPLAY-PIXEL						
; LS-7:			1024x600 16:9					
; LS-8:			1024x768  4:3					
.equ VGA_Xsitze								= 180
.equ VGA_Ysitze								= 160
.equ VGA_ZEILEN_PRO_PIXEL					= 3
.equ VGA_BYTES_PRO_ZEILE					= 90
; DCF-PHASENKORREKTUR-WARTEZEIT					
.equ DCF_PHASENKORREKTUR_WARTEZEIT			= 16	    ;(6) nach einigen Sekunden Phase schieben					
; TWI MASTER EINSTELLUNGEN						
.equ TWI_BIT_RATE							= 50		; 0..255  Bit-Rate					
.equ TWI_PRESCALER							= 3			; 0...3 (0=1 / 1=4 / 2=16 / 3=64)	
.equ TWI_SCL_BERECHNET						= TAKT/(16+(2*TWI_BIT_RATE)*(exp2(TWI_PRESCALER))*(exp2(TWI_PRESCALER)))
; TWI DS1307 (RTC)								
.equ DS1307_ADRESSE							= 104		; 104			
.equ DS1307_ERROR_WRITE						= 150		; ERROR-CODE	
.equ DS1307_ERROR_AUSLESEN					= 151		; ERROR-CODE	
; TWI HYT939 (%) 								
.equ HYT939_ADRESSE							= 40		; 40			
.equ HYT939_ERROR_MESSUNG					= 160		; ERROR-CODE	
.equ HYT939_ERROR_BERECHNUNG				= 161		; ERROR-CODE	
; TWI HP03S	(DRUCK)								
.equ HP03S_EEPROM_ADRESSE					= 80		; 80			
.equ HP03S_ADC_ADRESSE						= 119		; 119			
.equ HP03S_ERROR_MESSUNG					= 170		; ERROR-CODE	
.equ HP03S_ERROR_BERECHNUNG					= 171		; ERROR-CODE	
.equ HP03S_ERROR_KOEFFIZIENT				= 172		; ERROR-CODE	
; TIMER-0-WERTE	(RESERVE)						
.equ TIMER0_CTC_FREQUENZ					= 10000
.equ TIMER0_N								= 8
.equ TIMER0_CTC								=(TAKT/(2*TIMER0_N*TIMER0_CTC_FREQUENZ))-1
.equ TIMER0_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER0_N)*(1+TIMER0_CTC))
; TIMER-1-WERTE	(VGA-BILD)						
.equ TIMER1_CTC_FREQUENZ					= 31496/2
.equ TIMER1_N								= 1
.equ TIMER1_CTC								=(TAKT/(2*TIMER1_N*TIMER1_CTC_FREQUENZ))-1
.equ TIMER1_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER1_N)*(1+TIMER1_CTC))
; TIMER-2-WERTE (ca. 32kHz fr Sensor)			
.equ TIMER2_CTC_FREQUENZ					= 32000
.equ TIMER2_N								= 8
.equ TIMER2_CTC								=(TAKT/(2*TIMER2_N*TIMER2_CTC_FREQUENZ))-1
.equ TIMER2_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER2_N)*(1+TIMER2_CTC))
; TIMER-3-WERTE (20ms fr Uhr + DCF)			
.equ TIMER3_CTC_FREQUENZ					= 25
.equ TIMER3_N								= 64
.equ TIMER3_CTC								=(TAKT/(2*TIMER3_N*TIMER3_CTC_FREQUENZ))-1
.equ TIMER3_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER3_N)*(1+TIMER3_CTC))
; TOUCH(Y+)										
.equ TOUCH_YP_PIN_NR						= 0
.equ TOUCH_YP_DDR							= DDRA
.equ TOUCH_YP_PORT							= PORTA
.equ TOUCH_YP_PIN							= PINA
; TOUCH(X+)										
.equ TOUCH_XP_PIN_NR						= 1
.equ TOUCH_XP_DDR							= DDRA
.equ TOUCH_XP_PORT							= PORTA
.equ TOUCH_XP_PIN							= PINA
; TOUCH(Y-)										
.equ TOUCH_YN_PIN_NR						= 2
.equ TOUCH_YN_DDR							= DDRA
.equ TOUCH_YN_PORT							= PORTA
.equ TOUCH_YN_PIN							= PINA
; TOUCH(X-)										
.equ TOUCH_XN_PIN_NR						= 3
.equ TOUCH_XN_DDR							= DDRA
.equ TOUCH_XN_PORT							= PORTA
.equ TOUCH_XN_PIN							= PINA
; RELAIS-POWER									
.equ RELAIS_POWER_PIN_NR					= 4
.equ RELAIS_POWER_DDR						= DDRA
.equ RELAIS_POWER_PORT						= PORTA
; RELAIS-KLICK									
.equ RELAIS_KLICK_PIN_NR					= 5
.equ RELAIS_KLICK_DDR						= DDRA
.equ RELAIS_KLICK_PORT						= PORTA
; TEST-A-PIN (OUT)								
.equ TESTA_PIN_NR							= 6
.equ TESTA_DDR								= DDRA
.equ TESTA_PORT								= PORTA
; TEST-B-PIN (OUT)								
.equ TESTB_PIN_NR							= 7
.equ TESTB_DDR								= DDRA
.equ TESTB_PORT								= PORTA
; VGA-RGB-DATA-PORT								
.equ RGB_DATA_DDR							= DDRB
.equ RGB_DATA_PORT							= PORTB
; VGA-ROT-GRN-BLAU								
.equ R_DATA_PIN_NR							= 0
.equ G_DATA_PIN_NR							= 1
.equ B_DATA_PIN_NR							= 2
; TWI-SCL										
.equ TWI_SCL_PIN_NR							= 0
.equ TWI_SCL_PORT							= PORTC
.equ TWI_SCL_PIN							= PINC
; TWI-SDA										
.equ TWI_SDA_PIN_NR							= 1
.equ TWI_SDA_PORT							= PORTC
.equ TWI_SDA_PIN							= PINC
; BEEP											
.equ BEEP_PIN_NR							= 2
.equ BEEP_DDR								= DDRC
.equ BEEP_PORT								= PORTC
; XCLR-HP03S (OUT)								
.equ HP03S_XCLR_PIN_NR						= 3			
.equ HP03S_XCLR_DDR							= DDRC		
.equ HP03S_XCLR_PORT						= PORTC	
; TASTE-A (MENUE +)								
.equ TASTE_A_PIN_NR							= 4
.equ TASTE_A_DDR							= DDRC
.equ TASTE_A_PORT							= PORTC
.equ TASTE_A_PIN							= PINC
; TASTE-B (MENUE -)								
.equ TASTE_B_PIN_NR							= 5
.equ TASTE_B_DDR							= DDRC
.equ TASTE_B_PORT							= PORTC
.equ TASTE_B_PIN							= PINC
; TASTE-C (WERT +)								
.equ TASTE_C_PIN_NR							= 6
.equ TASTE_C_DDR							= DDRC
.equ TASTE_C_PORT							= PORTC
.equ TASTE_C_PIN							= PINC
; TASTE-D (WERT -)								
.equ TASTE_D_PIN_NR							= 7
.equ TASTE_D_DDR							= DDRC
.equ TASTE_D_PORT							= PORTC
.equ TASTE_D_PIN							= PINC
; VGA-V-SYNCHRON(BILDANFANG)					
.equ VSYNC_PIN_NR							= 0
.equ VSYNC_DDR								= DDRD
.equ VSYNC_PORT								= PORTD
; VGA-H-SYNCHRON (ZEILE)						
.equ HSYNC_PIN_NR							= 1
.equ HSYNC_DDR								= DDRD
.equ HSYNC_PORT								= PORTD
; DCF-EINGANG									
.equ DCF_PIN_NR								= 2
.equ DCF_DDR								= DDRD
.equ DCF_PORT								= PORTD
.equ DCF_PIN								= PIND
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 4
.equ LED_GRUEN_DDR							= DDRD
.equ LED_GRUEN_PORT							= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR						= 5
.equ LED_GELB_DDR							= DDRD
.equ LED_GELB_PORT							= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR							= 6
.equ LED_ROT_DDR							= DDRD
.equ LED_ROT_PORT							= PORTD
; FEHLER-CODES-TWI								
.equ ERROR_TWI_MT_START						= 110
.equ ERROR_TWI_MT_SLA						= 112
.equ ERROR_TWI_MT_DATA						= 114
.equ ERROR_TWI_MR_START						= 120
.equ ERROR_TWI_MR_SLA						= 121
.equ ERROR_TWI_MR_DATA						= 122
.equ ERROR_TWI_MR_DATAEND					= 123
; ERROR-CODES-DCF								
.equ ERROR_DCF_PHASE						= 10
.equ ERROR_DCF_MINUTENENDE					= 59
.equ ERROR_DCF_NO_ANFANGSBIT				= 100
.equ ERROR_DCF_RESERVEANTENNE				= 215	; nur INFO, kein ERROR	
.equ ERROR_DCF_ZEITUMSTELLUNG				= 216	; nur INFO, kein ERROR	
.equ ERROR_DCF_MESZ							= 118
.equ ERROR_DCF_SCHALTSEKUNDE				= 119
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT		= 120
.equ ERROR_DCF_MINUTE						= 127
.equ ERROR_DCF_PARITAET_MINUTE				= 128
.equ ERROR_DCF_STUNDE						= 134
.equ ERROR_DCF_PARITAET_STUNDE				= 135
.equ ERROR_DCF_TAG							= 141
.equ ERROR_DCF_WOCHENTAG					= 144
.equ ERROR_DCF_MONAT						= 149
.equ ERROR_DCF_JAHR							= 157
.equ ERROR_DCF_PARITAET_DATUM				= 158
; ERROR-CODES-SYSTEM							
.equ ERROR_FARBE							= 200
.equ ERROR_KALENDERTAG						= 210
; ERROR-CODES-TOUCH								
.equ ERROR_TOUCH_SPEICHER					= 220
.equ ERROR_TOUCH_MENUE						= 222

; REGISTER												
.def HILFSREGISTER_R0=R0	; wichtiges Rechenregister	
.def HILFSREGISTER_R1=R1	; wichtiges Rechenregister	
.def HILFSREGISTER_R2=R2	; wichtiges Rechenregister	
.def HILFSREGISTER_R3=R3	; wichtiges Rechenregister	
.def HILFSREGISTER_R4=R4	; wichtiges Rechenregister	
.def HILFSREGISTER_R5=R5	; wichtiges Rechenregister	
.def HILFSREGISTER_R6=R6	; wichtiges Rechenregister	
.def HILFSREGISTER_R7=R7	; wichtiges Rechenregister	
.def SREG_KOPIE		= R8	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def temp_KOPIE		= R9	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YL_KOPIE		= R10	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YH_KOPIE		= R11	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZL_KOPIE		= R12	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZH_KOPIE		= R13	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN							=SRAM_START+0		
.equ adr_MODUS_PROGRAMMSTART			=SRAM_START+1		; MODUS bei PROGRAMMSTART	
.equ adr_MODUS							=SRAM_START+2		; MODUS (z.B. 1=Uhr)		
.equ adr_MENUE							=SRAM_START+3		; MENUE						

.equ adr_TASTE							=SRAM_START+4		; TASTEN-WERT				
.equ adr_TASTE_MENUE					=SRAM_START+5

.equ adr_ERROR_CODE						=SRAM_START+6		; ERROR CODE 				
.equ adr_ERROR_WERT						=SRAM_START+7		; ERROR CODE (WERT)			

.equ adr_WARNUNG_CODE					=SRAM_START+8		; Warnung Code				
.equ adr_WARNUNG_WERT					=SRAM_START+9		; Warnung Code (WERT)		

.equ adr_ENTZERRUNG_KREIS				=SRAM_START+10		; Anpassung Kreis an Bildschirm

.equ adr_DRUCK_OFFSET_L					=SRAM_START+15		; OFFSET (manuell)	
.equ adr_DRUCK_OFFSET_H					=SRAM_START+16

.equ adr_FARBE_TAG						=SRAM_START+20
.equ adr_FARBE_NACHT					=SRAM_START+21
.equ adr_FARBE_AKTUELL					=SRAM_START+22
.equ adr_NACHTMODUS_ON					=SRAM_START+23		; NACHTMODUS
.equ adr_NACHTMODUS_ON_hh				=SRAM_START+24		; NACHTMODUS-ON				
.equ adr_NACHTMODUS_ON_mm				=SRAM_START+25
.equ adr_NACHTMODUS_OFF_hh				=SRAM_START+26		; NACHTMODUS-OFF			
.equ adr_NACHTMODUS_OFF_mm				=SRAM_START+27
.equ adr_DISPLAY_ON_hh					=SRAM_START+28		; DISPLAY-ON				
.equ adr_DISPLAY_ON_mm					=SRAM_START+29
.equ adr_DISPLAY_OFF_hh					=SRAM_START+30		; DISPLAY-OFF				
.equ adr_DISPLAY_OFF_mm					=SRAM_START+31

.equ adr_HYT939_VORHANDEN				=SRAM_START+40
.equ adr_HYT939_DATA_MSB				=SRAM_START+41
.equ adr_HYT939_DATA_LSB				=SRAM_START+42
.equ adr_HYT939_TEMPERATUR_DATA_MSB		=SRAM_START+43
.equ adr_HYT939_TEMPERATUR_DATA_LSB		=SRAM_START+44
.equ adr_HYT939_RH						=SRAM_START+45		; ERGEBNIS %			
.equ adr_HYT939_RH_OLD					=SRAM_START+46		; ERGEBNIS % (OLD)		
.equ adr_HYT939_TEMPERATUR_SIGNIERT		=SRAM_START+47		; ERGEBNIS Temperatur	


.equ adr_DS1307_VORHANDEN				=SRAM_START+56 		; RTC		
.equ adr_DS1307_WRITE_AKTIV				=SRAM_START+58		; RTC		

.equ adr_HP03S_VORHANDEN				=SRAM_START+60		; vorhanden	 
.equ adr_HP03S_C1_MSB					=SRAM_START+61		; EEPROM	 
.equ adr_HP03S_C1_LSB					=SRAM_START+62 		; EEPROM	 
.equ adr_HP03S_C2_MSB					=SRAM_START+63 		; EEPROM	 
.equ adr_HP03S_C2_LSB					=SRAM_START+64		; EEPROM	 
.equ adr_HP03S_C3_MSB					=SRAM_START+65   	; EEPROM	 
.equ adr_HP03S_C3_LSB					=SRAM_START+66 		; EEPROM	 
.equ adr_HP03S_C4_MSB					=SRAM_START+67		; EEPROM	 
.equ adr_HP03S_C4_LSB					=SRAM_START+68 		; EEPROM	 
.equ adr_HP03S_C5_MSB					=SRAM_START+69 		; EEPROM	 
.equ adr_HP03S_C5_LSB					=SRAM_START+70 		; EEPROM	 
.equ adr_HP03S_C6_MSB					=SRAM_START+71 		; EEPROM	 
.equ adr_HP03S_C6_LSB					=SRAM_START+72 		; EEPROM	 
.equ adr_HP03S_C7_MSB					=SRAM_START+73 		; EEPROM	 
.equ adr_HP03S_C7_LSB					=SRAM_START+74 		; EEPROM	 
.equ adr_HP03S_A						=SRAM_START+75		; EEPROM	 
.equ adr_HP03S_B						=SRAM_START+76		; EEPROM	 
.equ adr_HP03S_C						=SRAM_START+77		; EEPROM	 
.equ adr_HP03S_D						=SRAM_START+78		; EEPROM	 
.equ adr_HP03S_D1_DUMMY_L				=SRAM_START+79		; Zwischenergebnis		
.equ adr_HP03S_D1_DUMMY_H				=SRAM_START+80
.equ adr_HP03S_D1_MSB					=SRAM_START+81		; Rohdaten Luftdruck 	
.equ adr_HP03S_D1_LSB					=SRAM_START+82 
.equ adr_HP03S_D2_MSB					=SRAM_START+83 		; Rohdaten Temperatur	
.equ adr_HP03S_D2_LSB					=SRAM_START+84 
.equ adr_HP03S_dUT_MSB					=SRAM_START+85		; dUT 		
.equ adr_HP03S_dUT_LSB					=SRAM_START+86
.equ adr_HP03S_OFF_MSB					=SRAM_START+87		; OFFSET	
.equ adr_HP03S_OFF_LSB					=SRAM_START+88
.equ adr_HP03S_SENS_MSB					=SRAM_START+89		; SENS		
.equ adr_HP03S_SENS_LSB					=SRAM_START+90
.equ adr_HP03S_X_MSB					=SRAM_START+91		; X			
.equ adr_HP03S_X_LSB					=SRAM_START+92
.equ adr_HP03S_TEMPERATUR_L				=SRAM_START+93		; TEMPERATUR
.equ adr_HP03S_TEMPERATUR_H				=SRAM_START+94
.equ adr_HP03S_P_L						=SRAM_START+97		; P=DRUCK	
.equ adr_HP03S_P_H						=SRAM_START+98
.equ adr_HP03S_P_OLD_L					=SRAM_START+99		; P=DRUCK (OLD)	
.equ adr_HP03S_P_OLD_H					=SRAM_START+100

.equ adr_TWI_BEREICH_READ				=SRAM_START+200		; BEREICH fr Master TWI/I2C	

.equ adr_ANALOGUHR_OLD_ss				=SRAM_START+820		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_ss		=SRAM_START+821		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_mm		=SRAM_START+822		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_hh		=SRAM_START+823		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_hhmm		=SRAM_START+824		; ANALOGUHR					

.equ adr_DCF_ss20						=SRAM_START+900		; 20ms Sekunden					
.equ adr_DCF_ss							=SRAM_START+901		; SEKUNDEN						
.equ adr_DCF_mm							=SRAM_START+902		; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh							=SRAM_START+903		; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG						=SRAM_START+904		; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG					=SRAM_START+905		; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT						=SRAM_START+906		; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR						=SRAM_START+907		; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_MESZ						=SRAM_START+908		; SOMMERZEIT aus DCF-Protokoll	
.equ adr_DCF_PHASE						=SRAM_START+909		; 
.equ adr_DCF_PHASE_WAIT					=SRAM_START+910		; 
.equ adr_DCF_SIGNAL_INVERTIEREN			=SRAM_START+911		; 
.equ adr_DCF_SIGNAL_ZAEHLER				=SRAM_START+912		; 
.equ adr_DCF_TRAEGER					=SRAM_START+913		; 
.equ adr_DCF_TRAEGER_OLD				=SRAM_START+914		; 
.equ adr_DCF_SAMPLES_A					=SRAM_START+915		; SAMPLES_A (100ms)				
.equ adr_DCF_SAMPLES_B					=SRAM_START+916		; SAMPLES_B (200ms)				
.equ adr_DCF_MINUTENENDE				=SRAM_START+917
.equ adr_DCF_PROTOKOLL_OK				=SRAM_START+918
.equ adr_DCF_NO_BERECHNUNG				=SRAM_START+919
.equ adr_DCF_ERROR_CODE					=SRAM_START+920		; DCF-ERROR-CODE				
.equ adr_DCF_GUELTIG					=SRAM_START+921		; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_HEUTE_EMPFANGEN			=SRAM_START+922		; DCF wurde heute schon empfangen
.equ adr_DCF_BEREICH60					=SRAM_START+928		; 60 BYTES fr DCF-FELD		

.equ adr_ss20							=SRAM_START+1000	; 20ms Sekunden				
.equ adr_ss								=SRAM_START+1001	; Sekunden					
.equ adr_mm								=SRAM_START+1002	; Minuten					
.equ adr_hh								=SRAM_START+1003	; Stunden					
.equ adr_TAG							=SRAM_START+1004	; TAG						
.equ adr_TAG_OLD						=SRAM_START+1005	; TAG old					
.equ adr_MONAT							=SRAM_START+1006	; Monat						
.equ adr_JAHR							=SRAM_START+1007	; JAHR						
.equ adr_WOCHENTAG						=SRAM_START+1008	; 1=Mo 7=So					
.equ adr_MESZ							=SRAM_START+1009	; 0=MEZ 1=MESZ				
.equ adr_hh_KLICK_ON					=SRAM_START+1010	; 0=OFF 1=ON				

.equ adr_SONNE_ANZEIGE					=SRAM_START+1013	; 0=aus / 1=ein				
.equ adr_SONNE_AUFGANG_mm				=SRAM_START+1014	; SONNENAUFGANG				
.equ adr_SONNE_AUFGANG_hh				=SRAM_START+1015	; SONNENAUFGANG				
.equ adr_SONNE_UNTERGANG_mm				=SRAM_START+1016	; SONNENUNTERGANG			
.equ adr_SONNE_UNTERGANG_hh				=SRAM_START+1017	; SONNENUNTERGANG			

.equ adr_ADC_0_L						=SRAM_START+1020
.equ adr_ADC_0_H						=SRAM_START+1021
.equ adr_ADC_1_L						=SRAM_START+1022
.equ adr_ADC_1_H						=SRAM_START+1023
.equ adr_ADC_2_L						=SRAM_START+1024
.equ adr_ADC_2_H						=SRAM_START+1025
.equ adr_ADC_3_L						=SRAM_START+1026
.equ adr_ADC_3_H						=SRAM_START+1027
.equ adr_ADC_4_L						=SRAM_START+1028
.equ adr_ADC_4_H						=SRAM_START+1029
.equ adr_ADC_5_L						=SRAM_START+1030
.equ adr_ADC_5_H						=SRAM_START+1031
.equ adr_ADC_6_L						=SRAM_START+1032
.equ adr_ADC_6_H						=SRAM_START+1033
.equ adr_ADC_7_L						=SRAM_START+1034
.equ adr_ADC_7_H						=SRAM_START+1035


.equ adr_GRAFIC_FARBE					=SRAM_START+1100	; 0=wei 1=schwarz			
.equ adr_GRAFIC_PUNKT_GROESSE			=SRAM_START+1101	; PUNKT-GRSSE 0...9		
.equ adr_GRAFIC_ASCII_CURSOR_ZEILE		=SRAM_START+1102	; CURSOR VGA-ZEILE 			
.equ adr_GRAFIC_ASCII_CURSOR_SPALTE		=SRAM_START+1103	; CURSOR-SPALTE (0..		
.equ adr_GRAFIC_X1						=SRAM_START+1104	; X1-KOORDINATEN
.equ adr_GRAFIC_Y1						=SRAM_START+1105	; Y1-KOORDINATEN
.equ adr_GRAFIC_X2						=SRAM_START+1106	; X2-KOORDINATEN
.equ adr_GRAFIC_Y2						=SRAM_START+1107	; Y2-KOORDINATEN
.equ adr_GRAFIC_RADIUS_L				=SRAM_START+1108	; RADIUS					
.equ adr_GRAFIC_RADIUS_H				=SRAM_START+1109	; RADIUS					
.equ adr_GRAFIC_WINKEL_L				=SRAM_START+1110	; WINKEL					
.equ adr_GRAFIC_WINKEL_H				=SRAM_START+1111	; WINKEL					
.equ adr_GRAFIC_ZEIGER_LAENGE			=SRAM_START+1112	; STRECKEN-LNGE			

.equ adr_BS_ss_OLD						=SRAM_START+1120	; BETRIEBSSTUNDEN			
.equ adr_BS_ss							=SRAM_START+1121	; BETRIEBSSTUNDEN			
.equ adr_BS_mm							=SRAM_START+1122	; BETRIEBSSTUNDEN			
.equ adr_BS_hh							=SRAM_START+1123	; BETRIEBSSTUNDEN			
.equ adr_BS_TAG_L						=SRAM_START+1124	; BETRIEBSSTUNDEN			
.equ adr_BS_TAG_H						=SRAM_START+1125	; BETRIEBSSTUNDEN			

.equ adr_TEST_ZAHL_BYTE0				=SRAM_START+1130	; TEST-ZAHL					
.equ adr_TEST_ZAHL_BYTE1				=SRAM_START+1131	; TEST-ZAHL					
.equ adr_TEST_ZAHL_BYTE2				=SRAM_START+1132	; TEST-ZAHL					
.equ adr_TEST_ZAHL_BYTE3				=SRAM_START+1133	; TEST-ZAHL					

.equ adr_EDIT_ZAHL_BYTE0				=SRAM_START+1140	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_BYTE1				=SRAM_START+1141	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_BYTE2				=SRAM_START+1142	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_BYTE3				=SRAM_START+1143	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_DUMMY0				=SRAM_START+1144	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_DUMMY1				=SRAM_START+1145	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_DUMMY2				=SRAM_START+1146	; ZAHL-EDIT					
.equ adr_EDIT_ZAHL_DUMMY3				=SRAM_START+1147	; ZAHL-EDIT					


.equ adr_TOUCH_VORHANDEN				=SRAM_START+1150	; 1=ja 0=nein	
.equ adr_TOUCH_BEEP_ON					=SRAM_START+1151	; 1=ON 0=OFF	
.equ adr_TOUCH_ADC_X_MIN				=SRAM_START+1152	; physikalisch	
.equ adr_TOUCH_ADC_X_MAX				=SRAM_START+1153	; physikalisch	
.equ adr_TOUCH_ADC_Y_MIN				=SRAM_START+1154	; physikalisch	
.equ adr_TOUCH_ADC_Y_MAX				=SRAM_START+1155	; physikalisch	
.equ adr_TOUCH_X						=SRAM_START+1156	; KOORDINATEN	
.equ adr_TOUCH_Y						=SRAM_START+1157	; KOORDINATEN	
.equ adr_TOUCH_RUECKGABEWERT			=SRAM_START+1158	; RCKGABEWERT vom TOUCH 0=kein TOUCH	
.equ adr_TOUCH_ANZAHL_TASTEN			=SRAM_START+1159	; ANZAHL gespeicherter TASTEN		
.equ adr_TOUCH_SPEICHER256				=SRAM_START+1160	; Speicherbereich der Koordinaten	

.equ adr_FEHLER_SPEICHER80				=SRAM_START+1500	; 80 BYTE fr FEHLERSPEICHER	

.equ adr_VGA_TURBO_ON					=SRAM_START+1600
.equ adr_VGA_TURBO_OFF					=SRAM_START+1601
.equ adr_VGA_TURBO_DUMMY				=SRAM_START+1602
.equ adr_VGA_BILDZEILEN_NR_L			=SRAM_START+1603	; BILD-ZEILENNUMMER					
.equ adr_VGA_BILDZEILEN_NR_H			=SRAM_START+1604
.equ adr_VGA_ZEIGER_DATA_L				=SRAM_START+1605	; ZEIGER fr BILD-DATEN				
.equ adr_VGA_ZEIGER_DATA_H				=SRAM_START+1606
.equ adr_VGA_PIXEL_ZEILEN_COUNTER		=SRAM_START+1607	; PIXELZEILE						
.equ adr_VGA_BILD_ZEILE					=SRAM_START+1608
.equ adr_VGA_TURBO_BEREICH160			=SRAM_START+1610

.equ adr_VGA_BILDBEREICH				=SRAM_START+1800	; BILDSPEICHER						
.equ adr_VGA_BILDBEREICH_ENDE			=SRAM_START+1800+14400-1;(180x160/2 = 14.400 Bytes)			

.equ adr_SRAM_CHECK						=SRAM_START+16300		; SRAM CHECK muss immer "S" sein	
.equ adr_SRAM_END						=SRAM_START+16383		; 

; EEPROM-BELEGUNG						
.equ adr_EEPROM_WERKSEINSTELLUNG		= 0


;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_1s
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,16
	STS(adr_JAHR),temp
	ldi temp,5
	STS(adr_WOCHENTAG),temp
	; ZEIT				
	ldi temp,19
	STS(adr_hh),temp	; hh	
	ldi temp,59
	STS(adr_mm),temp	; mm	
	ldi temp,30
	STS(adr_ss),temp	; ss	
	ldi temp,0
	STS(adr_DCF_ss),temp; DCF-ss
	; MEZ / MESZ		
	ldi temp,0
	STS(adr_MESZ),temp
	; MODUS bei PROGRAMM-START	
	ldi temp,1			; 1=ANALOGUHR	
	STS(adr_MODUS_PROGRAMMSTART),temp
	; ANZEIGE SONNEN-AUF-UNTERGANG
	ldi temp,1
	STS(adr_SONNE_ANZEIGE),temp
	; Anpassung Kreis an Display
 	ldi temp,200				;200..240.255
	STS(adr_ENTZERRUNG_KREIS),temp
	; TOUCH-BEEP-ON				
	ldi temp,2
	STS(adr_TOUCH_BEEP_ON),temp
	; STUNDEN-KLICK				
	ldi temp,1	
	STS(adr_hh_KLICK_ON),temp
	; FARBE-TAG			
	ldi temp,0b00000011	; GELB(R+G)	
	STS(adr_FARBE_TAG),temp
	; FARBE-NACHT		
	ldi temp,0b00000100	; BLAU		
	STS(adr_FARBE_NACHT),temp
	; FARBE-AKTUELL (TAG/NACHT)	
	ldi temp,0b00000110 ; CYAN   = G+B		
	STS(adr_FARBE_AKTUELL),temp
	; NACHTMODUS-ON-hh	
	ldi temp,23
	STS(adr_NACHTMODUS_ON_hh),temp
	; NACHTMODUS-ON-mm	
	ldi temp,00
	STS(adr_NACHTMODUS_ON_mm),temp
	; NACHTMODUS-OFF-hh	
	ldi temp,6
	STS(adr_NACHTMODUS_OFF_hh),temp
	; NACHTMODUS-OFF-mm	
	ldi temp,0
	STS(adr_NACHTMODUS_OFF_mm),temp
	; DISPLAY-ON-hh		
	ldi temp,5
	STS(adr_DISPLAY_ON_hh),temp
	; DISPLAY-ON-mm		
	ldi temp,0
	STS(adr_DISPLAY_ON_mm),temp
	; DISPLAY-OFF-hh	
	ldi temp,1
	STS(adr_DISPLAY_OFF_hh),temp
	; DISPLAY-OFF-mm	
	ldi temp,0
	STS(adr_DISPLAY_OFF_mm),temp
; PORT A+B+C+D initialisieren (alles EINGNGE+PULL-UP aus)	
	out DDRA, NULL
	out PORTA,NULL
	out DDRB, NULL
	out PORTB,NULL
	out DDRC, NULL
	out PORTC,NULL
	out DDRD, NULL
	out PORTD,NULL
; LED_INITIALISIERUNG										
	call LED_INITIALISIERUNG
; WDR_INITIALISIERUNG										
	call WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR											
	call NEUSTART_MIT_WDR
; VGA_PIN_INITIALISIERUNG									
	call VGA_PIN_INITIALISIERUNG
; TWI-INITIALISIERUNG										
	call TWI_INI
; DCF-INITIALISIERUNG										
	call DCF_INITIALISIERUNG
; ADC_INITIALISIERUNG										
	call ADC_INITIALISIERUNG
; TASTEN_INITIALISIERUNG									
	call TASTEN_INITIALISIERUNG
; LED-TEST													
	call LED_TEST 
; TIMER INITALISIERUNG										
;	call TIMER0_INITIALISIERUNG_CTC	; RESERVE				
	call TIMER1_INITIALISIERUNG_CTC	; VGA-BILD				
	call TIMER2_INITIALISIERUNG_CTC	; 32kHz					
	call TIMER3_INITIALISIERUNG_CTC	; UHR					
; Interrupts freigeben										
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINSCHWINGEN												
	call DISPLAY_ON
	call NACHTMODUS_OFF
	call GRAFIC_CLEAR
	call VGA_TEST_FARBBALKEN
	call wait_500ms
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   	
	call PROGRAMM_CHECK
	call ANZEIGE_SYSTEMCHECK					; wichtig !		
	call wait_100ms
	call GRAFIC_CLEAR
	call TOUCH_CLEAR
	call BEEP_2x_KURZ
;-------------------------------------------------------------------------------
	call ANZEIGE_TEXT_WAIT_KURZ
	call wait_100ms
	call EEPROM_KONFIGURATION_SPEICHERN
	call TWI_BUS_FREE_CHECK
;-------------------------------------------------------------------------------
	LDS temp,(adr_MODUS_PROGRAMMSTART)			; MODUS nach PROGRAMMSTART
	STS(adr_MODUS),temp
	STS(adr_MENUE),NULL
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR												; Watch-Dog-RESET	
	call TOUCH_ABFRAGE
	call TOUCH_MODUS
	call STUNDEN_KLICK
	call BERECHNUNG_NACHTMODUS_ON_OFF				; bei Sekunde = 
	call BERECHNUNG_DISPLAY_ON_OFF					; bei Sekunde = 
	call TASTEN_ABFRAGE
	call TASTEN_MENUE
	call TASTEN_WAIT 
	call DS1307_RTC_STELLEN_AUTOMATIK				; bei Sekunde = 5	
	call BERECHNUNG_SONNENAUFGANG_SONNENUNTERGANG	; bei Sekunde = 5	
	call PROGRAMM_CHECK
	call ANZEIGE_ERROR_CODE
	call BETRIEBSSTUNDEN
	call TWI_BUS_FREE_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "VGA_TIMER.asm"					; TIMER							
.include "VGA_BILD_MACRO.asm"				; BILDAUFBAU					
.include "VGA_BILD.asm"						; TIMER+BILDAUFBAU				
.include "VGA_ASCII.asm"					; ASCII							
.include "VGA_ASCII_ALPHABET.asm"			; ASCII Alphabet				
.include "VGA_ANZEIGE.asm"					; ANZEIGE						
.include "VGA_ANZEIGE_ZAHLEN.asm"			; ZAHLEN						
.include "VGA_ANZEIGE_KURZ.asm"				; ANZEIGE						
.include "VGA_DCF77.asm"					; DCF77							
.include "VGA_GRAFIC.asm"					; GRAFIC allgemein				
.include "VGA_GRAFIC_PUNKT.asm"				; PUNKT							
.include "VGA_GRAFIC_PUNKT_AUF_KREIS.asm"	; PUNKT auf KREIS				
.include "VGA_GRAFIC_LINIE.asm"				; LINIE							
.include "VGA_GRAFIC_RECHTECK.asm"			; RECHTECK						
.include "VGA_GRAFIC_BOX.asm"				; BOX							
.include "VGA_GRAFIC_ZEIGER.asm"			; ZEIGER						
.include "VGA_GRAFIC_KREIS.asm"				; KREIS							
.include "VGA_FUNKTIONEN.asm"				; FUNKTIONEN					
.include "VGA_SONSTIGES.asm"				; sonstiges						
.include "VGA_GRAFIC_TESTS.asm"				; TESTBILDER					
.include "VGA_MODUS_UHR_ANALOG.asm"			; UHR-ANALOG					
.include "VGA_MODUS_UHR_DIGITAL.asm"		; UHR-DIGITAL					
.include "VGA_MODUS_BAROMETER.asm"			; HYGROMETER					
.include "VGA_MODUS_HYGROMETER.asm"			; HYGROMETER					
.include "VGA_MODUS_EDIT_ZEIT.asm"			; EDIT ZEIT / DATUM				
.include "VGA_MODUS_EDIT_NACHT.asm"			; EDIT-NACHTMODUS				
.include "VGA_MODUS_EDIT_ZAHL.asm"			; EDIT-ZAHL						
.include "VGA_TWI.asm"						; TWI							
.include "VGA_TWI_DS1307.asm"				; TWI-RTC						
.include "VGA_TWI_HYT939.asm"				; %								
.include "VGA_TWI_HP03S.asm"				; Barometer						
.include "VGA_ADC.asm"						; ADC							
.include "VGA_TOUCH.asm"					; TOUCH							
.include "VGA_TOUCH_MODUS.asm"				; MODUS / MENUE					
.include "VGA_WAIT_22MHZ.asm"				; 20 MHz						
.include "VGA_EEPROM.asm"					; EEPROM						
.include "VGA_TASTEN.asm"					; TASTEN						
.include "VGA_TABELLE_SONNE.asm"			; SONNEN-AUFGANG-UNTERGANG		
.include "VGA_TABELLE_ASCII_8x12.asm"		; TABELLE (umfangreich)			
.include "VGA_TABELLE_SINUS_COSINUS.asm"	; TABELLE (umfangreich)			
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_0:
.db "VGA 640x480 60Hz ",0
TEXT_BEGRUESSUNG_1:
.db " ",0
TEXT_BEGRUESSUNG_2:
.db "180 x 160 PIXEL",0
TEXT_BEGRUESSUNG_3:
.db " ",0
TEXT_BEGRUESSUNG_4:
.db "ASCII 22x13 (8x12) ",0
TEXT_BEGRUESSUNG_5:
.db " ",0
TEXT_BEGRUESSUNG_6:
.db "ATmega1284P 22MHz",0
TEXT_BEGRUESSUNG_7:
.db " ",0
TEXT_BEGRUESSUNG_8:
.db "ANALOGUHR",0
TEXT_BEGRUESSUNG_9:
.db " ",0
TEXT_BEGRUESSUNG_10:
.db "DCF-77 ",0
TEXT_BEGRUESSUNG_11:
.db " ",0
TEXT_BEGRUESSUNG_12:
.db "V1 09/2015 ",0
; ##############################################################################################
; ##############################################################################################
; ##############################################################################################
; .db <X1> <Y1> <X2(OFFSET> <Y2(OFFSET)><Rckgabewert> <TEXT-ZEILE1> <NULL> <TEXT-ZEILE2> <NULL>	



; SONDERTASTEN											
TOUCH_TASTE_13:		; OK	
.db  (18*8+5), (0*24+12), 30, 20, 13	,0 ,'O','K',' '				,0								
TOUCH_TASTE_28:		; DEL	
.db  (18*8+5), (2*24+12), 30, 20, 28	,0 ,'D','E','L'				,0
TOUCH_TASTE_29:		; CLEAR	
.db  (18*8+5), (3*24+12), 30, 20, 29	,0 ,'C','L',' '				,0
TOUCH_TASTE_27:		; ESC	
.db  5, (0*24+12), 30, 20, 27	,0 ,'E','S','C'				,0
TOUCH_TASTE_30:		; kHz	
.db  5, (2*24+12), 30, 20, 30	,0 ,'k','H','z'				,0
TOUCH_TASTE_31:		; MHz	
.db  5, (3*24+12), 30, 20, 31	,0 ,'M','H','z'				,0
; ZAHLEN-FELD (3x4)												

TOUCH_TASTE_Z16:		; Reserve	
.db  (5*8+5), (0*24+12), 30, 20, 16	,0 ,' ','R',' '				,0
TOUCH_TASTE_Z48:		; 0			
.db  (9*8+5), (0*24+12), 30, 20, 48	,0 ,' ','0',' '				,0
TOUCH_TASTE_Z15:		; +/-		
.db (13*8+5), (0*24+12), 30, 20, 15	,0 ,'+','/','-'				,0

TOUCH_TASTE_Z49:		; 1	
.db  (5*8+5), (3*24+12), 30, 20, 49	,0 ,' ','1',' '				,0
TOUCH_TASTE_Z50:		; 2	
.db  (9*8+5), (3*24+12), 30, 20, 50	,0 ,' ','2',' '				,0
TOUCH_TASTE_Z51:		; 3	
.db (13*8+5), (3*24+12), 30, 20, 51	,0 ,' ','3',' '				,0
TOUCH_TASTE_Z52:		; 4	
.db  (5*8+5), (2*24+12), 30, 20, 52	,0 ,' ','4',' '				,0
TOUCH_TASTE_Z53:		; 5	
.db  (9*8+5), (2*24+12), 30, 20, 53	,0 ,' ','5',' '				,0
TOUCH_TASTE_Z54:		; 6	
.db (13*8+5), (2*24+12), 30, 20, 54	,0 ,' ','6',' '				,0
TOUCH_TASTE_Z55:		; 7	
.db  (5*8+5), (1*24+12), 30, 20, 55	,0 ,' ','7',' '				,0
TOUCH_TASTE_Z56:		; 8	
.db  (9*8+5), (1*24+12), 30, 20, 56	,0 ,' ','8',' '				,0
TOUCH_TASTE_Z57:		; 9	
.db (13*8+5), (1*24+12), 30, 20, 57	,0 ,' ','9',' '				,0


; EDIT ZEIT / DATUM										
TOUCH_TASTE_ET_80:	; TAG
.db (0*24), 100, 16, 16, 80 ,0 ,0
TOUCH_TASTE_ET_81:
.db (0*24),  45, 16, 16, 81	,0 ,0
TOUCH_TASTE_ET_82:	; MONAT
.db (1*24), 100, 16, 16, 82	,0 ,0
TOUCH_TASTE_ET_83:
.db (1*24),  45, 16, 16, 83	,0 ,0
TOUCH_TASTE_ET_84:	; JAHR
.db (2*24), 100, 16, 16, 84	,0 ,0
TOUCH_TASTE_ET_85:
.db (2*24),  45, 16, 16, 85	,0 ,0
TOUCH_TASTE_ET_86:	; hh
.db (3*24), 100, 16, 16, 86	,0 ,0
TOUCH_TASTE_ET_87:
.db (3*24),  45, 16, 16, 87	,0 ,0
TOUCH_TASTE_ET_88:	; mm
.db (4*24), 100, 16, 16, 88	,0 ,0
TOUCH_TASTE_ET_89:
.db (4*24),  45, 16, 16, 89	,0 ,0
TOUCH_TASTE_ET_90:	; ss
.db (5*24), 100, 16, 16, 90	,0 ,0
TOUCH_TASTE_ET_91:
.db (5*24),  45, 16, 16, 91	,0 ,0
TOUCH_TASTE_ET_92:	; Wochentag
.db (6*24), 100, 16, 16, 92	,0 ,0
TOUCH_TASTE_ET_93:
.db (6*24),  45, 16, 16, 93	,0 ,0
TOUCH_TASTE_ET_94:	; MESZ		
.db (7*24), 100, 8, 16, 94	,0 ,0
TOUCH_TASTE_ET_95:
.db (7*24),  45, 8, 16, 95	,0 ,0
; EDIT TAG/NACH/DISPLAY									
TOUCH_TASTE_ED_80:	; NACHT-ON	
.db 140, (136-0*12), 16, 10, 80	,0 ,0
TOUCH_TASTE_ED_81:
.db 160, (136-0*12), 16, 10, 81	,0 ,0
TOUCH_TASTE_ED_82:	; NACHT-off
.db 140, (136-1*12), 16, 10, 82	,0 ,0
TOUCH_TASTE_ED_83:
.db 160, (136-1*12), 16, 10, 83	,0 ,0
TOUCH_TASTE_ED_84:	; FARBE-TAG
.db 140, (136-2*12), 16, 10, 84	,0 ,0
TOUCH_TASTE_ED_85:
.db 160, (136-2*12), 16, 10, 85	,0 ,0
TOUCH_TASTE_ED_86:	; FARBE-NACHT
.db 140, (136-3*12), 16, 10, 86	,0 ,0
TOUCH_TASTE_ED_87:
.db 160, (136-3*12), 16, 10, 87	,0 ,0
TOUCH_TASTE_ED_88:	; DISPLAY-ON
.db 140, (136-4*12), 16, 10, 88	,0 ,0
TOUCH_TASTE_ED_89:
.db 160, (136-4*12), 16, 10, 89	,0 ,0
TOUCH_TASTE_ED_90:	; DISOLAY-OFF
.db 140, (136-5*12), 16, 10, 90	,0 ,0
TOUCH_TASTE_ED_91:
.db 160, (136-5*12), 16, 10, 91	,0 ,0
; HAUPTMENUE(A)	
TOUCH_TASTE_101:
.db    5, 119-(0*36), 53, 32, 101	,' ','U','H','R',' '			,0 	,'a','n','a','l','o','g'	,0	; UHR
TOUCH_TASTE_102:
.db   61, 119-(0*36), 53, 32, 102	,' ','U','H','R',' '			,0 	,'d','i','g','i','t','a'	,0	; UHR
TOUCH_TASTE_103:
.db  117, 119-(0*36), 53, 32, 103	,' ','U','H','R',' '  			,0 	,' ',' ',' ',' ',' ',' '	,0	; UHR
TOUCH_TASTE_104:
.db    5, 119-(1*36), 53, 32, 104	,'H','Y','G','R','O'			,0 	,'M','E','T','E','R',' '	,0	; HYGROMETER
TOUCH_TASTE_105:
.db   61, 119-(1*36), 53, 32, 105	,'B','A','R','O',' '			,0 	,'M','E','T','E','R',' '	,0	; BAROMETER	
TOUCH_TASTE_106:
.db  117, 119-(1*36), 53, 32, 106	,' ',' ',' ',' ',' '			,0 	,' ',' ',' ',' ',' ',' '	,0
TOUCH_TASTE_107:
.db    5, 119-(2*36), 53, 32, 107	,' ',' ',' ',' ',' '			,0 	,' ',' ',' ',' ',' ',' '	,0
TOUCH_TASTE_108:
.db   61, 119-(2*36), 53, 32, 108	,' ',' ',' ',' ',' '			,0 	,' ',' ',' ',' ',' ',' '	,0
TOUCH_TASTE_109:
.db  117, 119-(2*36), 53, 32, 109	,' ','T','A','G',' ',' '		,0 	,'N','A','C','H','T',' '	,0
TOUCH_TASTE_110:
.db    5, 119-(3*36), 53, 32, 110 									,0 	,'<','<',' ',' ' 			,0	; BACK			
TOUCH_TASTE_111:
.db   61, 119-(3*36), 53, 32, 111	,' ','O','F','F',' ',' '		,0 	,' ',' ',' ',' ',' ',' '	,0	; OFF			
TOUCH_TASTE_112:
.db  117, 119-(3*36), 53, 32, 112 									,0 	,' ',' ',' ',' ','>','>'	,0	; NEXT			
; HAUPTMENUE(B)	
TOUCH_TASTE_113:
.db    5, 119-(0*36), 53, 32, 113	,'E','D','I','T',' ',' '		,0 	,'Z','E','I','T',' ',' '	,0	; EDIT-ZEIT				
TOUCH_TASTE_114:
.db   61, 119-(0*36), 53, 32, 114	,'E','D','I','T',' ',' '		,0 	,'N','A','C','H','T',' '	,0	; EDIT-NACHTMODUS		
TOUCH_TASTE_115:
.db  117, 119-(0*36), 53, 32, 115	,'E','D','I','T',' ',' '		,0 	,'Z','A','H','L',' ',' '	,0	; EDIT-TEST-ZAHL		
TOUCH_TASTE_116:
.db    5, 119-(1*36), 53, 32, 116	,'E','D','I','T',' ',' '		,0 	,'K','R','E','I','S',' '	,0	; EDIT-KREIS-KORREKTUR	
TOUCH_TASTE_117:
.db   61, 119-(1*36), 53, 32, 117	,'E','D','I','T',' ',' '		,0 	,'T','-','B','E','E','P'	,0	; EDIT-TOUCH-BEEP		
TOUCH_TASTE_118:
.db  117, 119-(1*36), 53, 32, 118	,'E','D','I','T',' ',' '		,0 	,'h','-','B','E','E','P'	,0	; EDIT-STUNDEN-KLICK	
TOUCH_TASTE_119:
.db    5, 119-(2*36), 53, 32, 119	,'E','D','I','T',' ',' '		,0 	,'S','O','N','N','E',' '	,0	; EDIT-ANZEIGE-SONNENAUFGANG/UNTERGANG	
TOUCH_TASTE_120:
.db   61, 119-(2*36), 53, 32, 120	,'E','D','I','T',' ',' '		,0 	,'D','R','U','C','K',' '	,0	; EDIT-DRUCK-OFFSET		
TOUCH_TASTE_121:
.db  117, 119-(2*36), 53, 32, 121	,'f','r','e','e','.','.'		,0 	,'1','2','1','.','.','.'	,0
TOUCH_TASTE_122:
.db    5, 119-(3*36), 53, 32, 122 									,0 	,'<','<',' ',' '    		,0	; BACK			
TOUCH_TASTE_123:
.db   61, 119-(3*36), 53, 32, 123	,'f','r','e','e','.','.'		,0 	,'1','2','3','.','.','.'	,0
TOUCH_TASTE_124:
.db  117, 119-(3*36), 53, 32, 124 									,0 	,' ',' ',' ',' ','>','>'	,0	; NEXT			
; HAUPTMENUE(C)	
TOUCH_TASTE_125:
.db    5, 119-(0*36), 53, 32, 125	,' ','R','O','T',' ',' '		,0 								,0	; ROT			
TOUCH_TASTE_126:
.db   61, 119-(0*36), 53, 32, 126	,' ','G','R','U','N',' '		,0 								,0	; GRN			
TOUCH_TASTE_127:
.db  117, 119-(0*36), 53, 32, 127	,' ','B','L','A','U',' '		,0 								,0	; BLAU			
TOUCH_TASTE_128:
.db    5, 119-(1*36), 53, 32, 128	,' ','G','E','L','B',' '		,0 								,0	; GELB			
TOUCH_TASTE_129:
.db   61, 119-(1*36), 53, 32, 129	,'M','A','G','E','N','T'		,0 								,0	; MAGENTA		
TOUCH_TASTE_130:
.db  117, 119-(1*36), 53, 32, 130	,' ','C','Y','A','N',' '		,0 								,0	; CYAN			
TOUCH_TASTE_131:
.db    5, 119-(2*36), 53, 32, 131	,'W','E','I','S','S',' '		,0 								,0	; WEISS			
TOUCH_TASTE_132:
.db   61, 119-(2*36), 53, 32, 132	,'B','L','A','C','K',' '		,0 								,0	; BLACK			
TOUCH_TASTE_133:
.db  117, 119-(2*36), 53, 32, 133	,'R','E','G','E','N','-'		,0 	,'B','O','G','E','N'		,0	; REGENBOGEN	
TOUCH_TASTE_134:
.db    5, 119-(3*36), 53, 32, 134 									,0 	,'<','<',' ',' '			,0	; BACK			
TOUCH_TASTE_135:
.db   61, 119-(3*36), 53, 32, 135	,'S','T','E','R','N','-'		,0 	,'H','I','M','M','E','L'	,0	; STERNENHIMMEL
TOUCH_TASTE_136:
.db  117, 119-(3*36), 53, 32, 136 									,0 	,' ',' ',' ',' ','>','>'	,0	; NEXT			
; HAUPTMENUE(D)	
TOUCH_TASTE_137:
.db    5, 119-(0*36), 53, 32, 137	,' ','V','G','A',' ',' '		,0 	,'T','E','S','T','S'		,0	; VGA-TESTs		
TOUCH_TASTE_138:
.db   61, 119-(0*36), 53, 32, 138	,'S','Y','S','T','E','M'		,0 	,'T','E','S','T','S'		,0	; SYSTEM-TEST	
TOUCH_TASTE_139:
.db  117, 119-(0*36), 53, 32, 139	,'S','Y','S','T','E','M'		,0 	,'S','T','A','T','U','S'	,0	; SYSTEM-STATUS	
TOUCH_TASTE_140:
.db    5, 119-(1*36), 53, 32, 140	,'D','C','F','-','7','7'		,0 	,'S','T','A','T','U','S'	,0	; DCF-STATUS	
TOUCH_TASTE_141:
.db   61, 119-(1*36), 53, 32, 141	,'S','Y','S','T','E','M'		,0 	,'I','N','F','O',' ',' '	,0	; SYSTEM-INFO	
TOUCH_TASTE_142:
.db  117, 119-(1*36), 53, 32, 142	,'f','r','e','e','.','.'		,0 	,'1','4','2','.','.','.'	,0
TOUCH_TASTE_143:
.db    5, 119-(2*36), 53, 32, 143	,'F','E','H','L','E','R'		,0 	,'L','I','S','T','E',' '	,0	; FEHLER-LISTE	
TOUCH_TASTE_144:
.db   61, 119-(2*36), 53, 32, 144	,'f','r','e','e','.','.'		,0 	,'1','4','4','.','.','.'	,0
TOUCH_TASTE_145:
.db  117, 119-(2*36), 53, 32, 145	,'f','r','e','e','.','.'		,0 	,'1','4','5','.','.','.'	,0
TOUCH_TASTE_146:
.db    5, 119-(3*36), 53, 32, 146 									,0 	,'<','<',' ',' '    		,0	; BACK			
TOUCH_TASTE_147:
.db   61, 119-(3*36), 53, 32, 147	,'R','E','S','E','T',' '		,0 								,0	; RESET			
TOUCH_TASTE_148:
.db  117, 119-(3*36), 53, 32, 148 									,0 	,' ',' ',' ',' ','>','>'	,0	; NEXT			


; ADRESSE fr PROGRAMMENDE		
PROGRAMM_ENDE:
